SystemOrganization addCategory: #'Magma client-API'!
SystemOrganization addCategory: #'Magma client-Exceptions'!
SystemOrganization addCategory: #'Magma client-Info'!
SystemOrganization addCategory: #'Magma client-MagmaCollections'!
SystemOrganization addCategory: #'Magma client-Preferences'!
SystemOrganization addCategory: #'Magma client-private'!
SystemOrganization addCategory: #'Magma client-Code management'!
SystemOrganization addCategory: #'Magma client-Domain'!
SystemOrganization addCategory: #'Magma client-Notifications'!
SystemOrganization addCategory: #'Magma client-Events'!
SystemOrganization addCategory: #'Magma client-Large Collections'!
SystemOrganization addCategory: #'Magma client-Private'!

!TTFontDescription methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:37'!
isImmutableInMagma

	^ true! !

!ByteArray methodsFor: '*magma client' stamp: 'cmm 4/10/2005 16:01'!
maAllowsWriteBarrier
	"Primitive failed when attempted."

	^ false! !

!ByteArray methodsFor: '*magma client' stamp: 'cmm 10/9/2004 21:11'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^self ~= aMaByteObjectBuffer asByteArray! !

!ScreenController methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:35'!
isImmutableInMagma

	^ true! !

!MaObjectSerializer methodsFor: '*magma client' stamp: 'cmm 5/8/2003 13:50'!
cachedObjectCountByClass

	^oidManager objectCountByClass! !

!MaObjectSerializer methodsFor: '*magma client' stamp: 'cmm 6/3/2004 14:07'!
classDefinitions: aDictionary
	"aDictionary keys are the classId (an Integer), values are a collection of known MaClassDefinitions, representing different versions of that class."

	self classIdManager classDefinitionsById: aDictionary! !

!MaObjectSerializer methodsFor: '*magma client' stamp: 'cmm 6/6/2004 16:04'!
cleanObject: anObject

	truncatedObjects
		removeKey: anObject
		ifAbsent: [ "no problem" ].
	^oidManager cleanObject: anObject! !

!MaObjectSerializer methodsFor: '*magma client' stamp: 'cmm 8/11/2002 11:18'!
ensurePreparedToAllocateNewOids: anInteger

	oidManager ensurePreparedToAllocateNewOids: anInteger! !

!Object methodsFor: '*magma client' stamp: 'cmm 1/13/2005 17:33'!
asMagmaForwardingProxy

	^ MagmaSession connectedSessions
		maDetect: [ : each | each isPersistent: self ]
		ifFound: [ : foundSession | foundSession newForwardingProxyFor: self ]
		ifNone: [ MagmaUserError signal: 'Cannot create a forwarding proxy because I am not persistent in any connected session.' ]! !

!Object methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:40'!
isImmutableInMagma
	"This is used to help determine whether I should be stored in Magma's 'readSet', which is used to track changes.  But changes to some objects, such as Symbols, Blocks, CompiledMethods or logically-referenced globals are not tracked.  Therefore, there is no reason to bloat the readSet (not to mention when refreshPersistentObjectsEvenWhenChangedOnlyByMe is true, it won't try to refresh the unrefreshable."

	^ self maInstSize = 0! !

!Object methodsFor: '*magma client' stamp: 'cmm 1/13/2005 16:11'!
isMagmaOfflineObject

	^ false! !

!Object methodsFor: '*magma client' stamp: 'cmm 1/28/2005 00:16'!
isMagmaServerResult

	^ false! !

!Object methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:41'!
maAllowsWriteBarrier
	"Override in subclasses, if desired."

	^ self isImmutableInMagma not
	and: [ self isBehindWriteBarrier not
	and: [ self class canUncompact ] ]! !

!Object methodsFor: '*magma client' stamp: 'cmm 4/10/2005 18:00'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer 
	"I am variable."

	aMaVariableObjectBuffer isPointers 
		ifFalse: 
			[MagmaSoftwareError signal: self maOriginalClass name 
						, ' should implement maIsChangedFrom:using:.'].
	1 to: self maInstSize
		do: 
			[:index | 
			(index > self maOriginalClass instSize 
				or: [(self maIsTransient: index) not]) 
					ifTrue: 
						[(aMaObjectSerializer oidFor: (self instVarAt: index)) 
							~= (aMaVariableObjectBuffer maInstVarAt: index) ifTrue: [^true]]].
	^false! !

!Object methodsFor: '*magma client' stamp: 'cmm 4/10/2005 18:00'!
maRefreshTo: aMaVariableBuffer using: aMagmaSession 
	"I am variable."

	self maOriginalClass isBytes 
		ifTrue: 
			[self 
				replaceFrom: 1
				to: self size
				with: aMaVariableBuffer asByteArray
				startingAt: 1]
		ifFalse: 
			["I am pointers or words."

			aMaVariableBuffer instVarsDoWithIndex: 
					[:eachOid :eachIndex | 
					(self maIsTransient: eachIndex) 
						ifFalse: 
							[self instVarAt: eachIndex
								put: (aMagmaSession serializer objectWithOid: eachOid
										ifAbsent: [aMagmaSession serializer proxyFor: eachOid])]]]! !

!Object methodsFor: '*magma client' stamp: 'cmm 4/13/2005 13:37'!
materializedFromMagma: aMagmaMaterializationEvent
	"Sigh.  Instance-based event listeners are required for every instance, so here is an opportunity to register.  Another way to do this is to simply send 
	
	myMagmaSession
		when: #materializedFromMagma 
		send: #yourMaterializationHandlerSelector:  (the arg is a MagmaMaterializationEvent)
		to: yourObject

If you use this method-based approach instead, be sure to call super."

	"do nothing by default."! !

!Set methodsFor: '*magma client' stamp: 'cmm 3/27/2005 20:38'!
maAllowsWriteBarrier
	^ false! !

!Set methodsFor: '*magma client' stamp: 'cmm 3/27/2005 23:16'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer

	| oidSet |
	aMaVariableObjectBuffer objectInstSize ~= self size ifTrue: [ ^ true ].
	oidSet _ Set new: aMaVariableObjectBuffer objectInstSize.
	aMaVariableObjectBuffer instVarsDoWithIndex: [ : eachOid : x | oidSet add: eachOid ].
	self do: [ :each | (oidSet includes: (aMaObjectSerializer oidFor: each)) ifFalse: [ ^ true ] ].
	^ false! !

!Set methodsFor: '*magma client' stamp: 'cmm 10/22/2004 00:01'!
maRefreshTo: aMaVariableObjectBuffer using: aMagmaSession

	| save |
	save _ self copy.  "prevent GC of my items until we get it refreshed.."
	save size.   "prevent compiler from optimizing it out.."
	self maRemoveAll.
	aMaVariableObjectBuffer instVarsDoWithIndex:
		[ : each : x |
		self add: (
			aMagmaSession
				objectWithOid: each
				ifAbsent: [ self error: 'shoud be present' ]) ]! !

!EToyVocabulary methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:37'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"We get here only if using non-standard storage, in which case we reference to existing global vocabularies, and changes to logically-referenced globals are not tracked."

	^ self maUsesStandardStorage not! !

!ChangeSet methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:33'!
isImmutableInMagma

	^ true! !

!SystemDictionary methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:35'!
isImmutableInMagma

	^ true! !

!SystemDictionary methodsFor: '*magma client' stamp: 'cmm 3/27/2005 23:13'!
maAllowsWriteBarrier
	"No reason to, this is referenced logically."

	^ false! !

MCRepository subclass: #MCMagmaRepository
	instanceVariableNames: 'session location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Code management'!

MCMagmaRepository subclass: #MCLocalMagmaRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Code management'!

!MCLocalMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:53'!
creationTemplate
	^ self name, ' path: ''<fully qualified path'''! !

!MCLocalMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:37'!
description
	^ 'Magma (local)'! !

!MCLocalMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:13'!
fillInTheBlankRequest

	^ 'Local Magma Repository:'! !

!MCLocalMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2005 18:46'!
path: aString

	^ self location: (MagmaLocalLocation path: aString)! !

!MCLocalMagmaRepository methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2005 18:44'!
description
	^ 'magmaLocal://', location description! !

!MCMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 1/31/2005 23:49'!
location: aMagmaLocation

	^ self new
		location: aMagmaLocation ;
		yourself! !

!MCMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:19'!
morphicConfigure
	^ self fillInTheBlankConfigure! !

!MCMagmaRepository methodsFor: 'framework' stamp: 'cmm 2/15/2005 13:07'!
basicStoreVersion: aMCVersion

	self ensureConnectedSession commit: [ self codeBase storeVersion: aMCVersion ]! !

!MCMagmaRepository methodsFor: 'private' stamp: 'cmm 2/15/2005 14:21'!
codeBase

	^ self ensureConnectedSession codeBase! !

!MCMagmaRepository methodsFor: 'private' stamp: 'cmm 3/11/2005 14:11'!
ensureConnectedSession

	session 
		ifNil: 
			[ session _ MagmaSession connectedSessions
				detect: [ : each | each location = location ]
				ifNone: [ location newSession ] ].
	[ session ensureConnected ]
		on: MagmaUserRequiredNotification 
		do: [ : request | request resume: (MagmaUser id: 'monticello ui_', UUID new asString36) ].
	^ session! !

!MCMagmaRepository methodsFor: 'framework' stamp: 'cmm 2/15/2005 13:07'!
includesVersionNamed: aString

	^ self ensureConnectedSession codeBase includesVersionNamed: aString! !

!MCMagmaRepository methodsFor: 'private' stamp: 'cmm 1/30/2005 18:44'!
location: aMagmaLocation

	location _ aMagmaLocation! !

!MCMagmaRepository methodsFor: 'framework' stamp: 'cmm 10/24/2004 23:33'!
morphicOpen: aWorkingCopy

	(MCRepositoryInspector repository: self workingCopy: aWorkingCopy) show! !

!MCMagmaRepository methodsFor: 'accessing' stamp: 'cmm 11/5/2004 00:15'!
packages

	^ (self codeBase packages collect: [ : each | each package ]) asSet
		asSortedCollection: [ : a : b | a name < b name ]! !

!MCMagmaRepository methodsFor: 'framework' stamp: 'cmm 10/26/2004 23:36'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	^ self codeBase
		versionWithInfo: aVersionInfo
		ifAbsent: errorBlock! !

!MCMagmaRepository methodsFor: 'reading packages' stamp: 'cmm 10/26/2004 22:23'!
versionsAvailableForPackage: aPackage
	^ self codeBase versionsAvailableForPackage: aPackage! !

MCMagmaRepository subclass: #MCRemoteMagmaRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Code management'!

!MCRemoteMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 3/28/2005 22:11'!
creationTemplate
	^
self species name, '
	host: ''localhost''
	port: 51969'! !

!MCRemoteMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:37'!
description
	^ 'Magma (remote)'! !

!MCRemoteMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 10/27/2004 12:13'!
fillInTheBlankRequest

	^ 'Remote Magma Repository:'! !

!MCRemoteMagmaRepository class methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2005 18:45'!
host: hostName port: anInteger

	^ self location:
		(MagmaRemoteLocation
			host: hostName
			port: anInteger)! !

!MCRemoteMagmaRepository methodsFor: 'as yet unclassified' stamp: 'cmm 1/30/2005 18:45'!
description
	^ 'magmaRemote://', location description! !

!MaVariableWordBuffer methodsFor: '*magma client' stamp: 'cmm 2/14/2005 10:33'!
isDifferent: anObject using: aMaObjectSerializer
	"To determine different for variable classes requires special-case, therefore dispatch."
	anObject maInstSize ~= self objectInstSize ifTrue: [ ^ true ].
	self instVarsDoWithIndex: 
		[ : eachWord : index |
		eachWord ~= (anObject instVarAt: index) ifTrue: [ ^ true ] ].
	^ false! !

!MaVariableWordBuffer methodsFor: '*magma client' stamp: 'cmm 2/14/2005 10:32'!
refresh: variableObject using: aMagmaSession
	"Collections require special-case behavior to handle this, dispatch."

	self instVarsDoWithIndex:
		[ : eachWord : eachIndex |
		variableObject
			instVarAt: eachIndex
			put: eachWord ]! !

!ScrollPane methodsFor: '*magma client' stamp: 'cmm 4/13/2005 14:11'!
isImmutableInMagma 
	"disallow one clients scrolling to affect other clients."

	^ true! !

!ScrollPane methodsFor: '*magma client' stamp: 'cmm 4/13/2005 14:11'!
wantsMagmaEvents
	"We don't refresh scrollbars.  Although this technically isn't necessary as long I answer true to isImmutableInMagma, this will prevent my updatableActionMap from getting the event-listeners put in there unnecessarily."

	^ false! !

MaMutatingProxy subclass: #MagmaMutatingProxy
	instanceVariableNames: 'session oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaMutatingProxy class methodsFor: 'creation' stamp: 'cmm 1/18/2005 16:21'!
session: aMagmaSession oid: anInteger

	^ self new
		mutatingProxySession: aMagmaSession ;
		mutatingProxyOid: anInteger! !

!MagmaMutatingProxy methodsFor: 'testing' stamp: 'cmm 2/21/2005 21:36'!
= object
	"The only way to answer correctly is for the fully-materialized objects to tell you.  However, if object is the same object as me, it would be true.  Getting two separate mutating-proxies for the same object is possible when a storage-object refers to a persistent object (i.e., MaCompiledMethodStorage>>'className')."

	self == object ifTrue: [ ^ true ].
	^ object maIsMutatingProxy
		ifTrue:
			[ self mutatingProxySession magmaId = object mutatingProxySession magmaId
			and: [ self mutatingProxyOid = object mutatingProxyOid ] ]
		ifFalse: [ self mutant = object ]! !

!MagmaMutatingProxy methodsFor: 'accessing' stamp: 'cmm 5/28/2002 00:36'!
identityHash

	^self mutant identityHash
! !

!MagmaMutatingProxy methodsFor: 'testing' stamp: 'cmm 1/13/2005 13:43'!
maRequiresOwnBuffer

	^false
! !

!MagmaMutatingProxy methodsFor: 'accessing' stamp: 'cmm 2/21/2005 21:41'!
mutant

	| answer s |
	s _ session.  "do this because, after realObjectFor:, we will be in the context of the new object, not this proxy, and session will not be available."
	answer _ session realObjectFor: self mutatingProxyOid.
	self == answer
		ifFalse:
			[ "This is possible when we reference back into the persistent model from a substitute storage-object (i.e., MaCompiledMethodStorage>>'name'.  See also, MaObjectSerializer>>append:."
			self
				becomeForward: answer
				copyHash: false ].
	s preferences signalProxyMaterializations
		ifTrue: [ MagmaProxyMaterialization signalMaterializedObject: answer ].
	^answer! !

!MagmaMutatingProxy methodsFor: 'accessing' stamp: 'cmm 1/18/2005 16:10'!
mutatingProxyOid

	^ oid! !

!MagmaMutatingProxy methodsFor: 'accessing' stamp: 'cmm 1/18/2005 16:10'!
mutatingProxyOid: anInteger

	oid _ anInteger! !

!MagmaMutatingProxy methodsFor: 'accessing' stamp: 'cmm 1/18/2005 16:16'!
mutatingProxySession
	"This has such an ugly name so as not to conflict with other API named #session, to which I need to invoke my doesNotUnderstand: logic."
	^session! !

!MagmaMutatingProxy methodsFor: 'accessing' stamp: 'cmm 1/18/2005 16:20'!
mutatingProxySession: aMagmaSession

	session _ aMagmaSession
! !

!MagmaMutatingProxy methodsFor: 'printing' stamp: 'cmm 10/16/2002 16:11'!
printOn: aStream

	MagmaPreferences debugProxies
		ifTrue:
			[ super printOn: aStream ]
		ifFalse:
			[ self mutant printOn: aStream ]
! !

!MagmaMutatingProxy methodsFor: 'commenting' stamp: ''!
whyNoHash

	"Because we don't want to allow the receiver to ever be added to a hashed
	collection.  We want it to mutate and then be added, otherwise we'd have to
	know which hashed collections to rehash once the receiver was mutated."
! !

!Dictionary methodsFor: '*magma client' stamp: 'cmm 2/23/2005 14:39'!
maIsChangedFrom: aMaVariableObjectBuffer using: aMaObjectSerializer

	| logicalInstSize oidDict |
	logicalInstSize _ aMaVariableObjectBuffer objectInstSize.
	self size*2 = logicalInstSize ifFalse: [ ^ true ].
	oidDict _ Dictionary new: logicalInstSize / 2.
	1 to: logicalInstSize by: 2 do:
		[ :index | 
		oidDict 
			at: (aMaVariableObjectBuffer maInstVarAt: index)
			put: (aMaVariableObjectBuffer maInstVarAt: index+1) ].
	self keysAndValuesDo:
		[ : eachKey : eachValue |
		oidDict
			maAt: (aMaObjectSerializer oidFor: eachKey)
			ifPresent:
				[ : valueOid |
				valueOid = (aMaObjectSerializer oidFor: eachValue) ifFalse: [ ^true ] ]
			ifAbsent: [ ^ true ] ].
	^ false! !

!Dictionary methodsFor: '*magma client' stamp: 'cmm 2/22/2005 17:12'!
maRefreshTo: aMaVariableObjectBuffer using: aMagmaSession
	"The linkedOids in aMaVariableObjectBuffer are in key->value pairs."

	| save transformationBlock |
	save _ self copy.  "prevent GC of my elements until I get repopulated."
	save size.  "avoid friendly optimization intrusion."
	self maRemoveAll.
	transformationBlock _
		[ :oid |
			aMagmaSession serializer
				objectWithOid: oid
				ifAbsent: [ aMagmaSession serializer proxyFor: oid ] ].
	1
		to: aMaVariableObjectBuffer objectInstSize
		by: 2
		do:
			[ :eachKeyIndex | | eachKey eachValue |
			eachKey _ aMaVariableObjectBuffer maInstVarAt: eachKeyIndex.
			eachValue _ aMaVariableObjectBuffer maInstVarAt: eachKeyIndex + 1.
			self
				at: (transformationBlock value: eachKey)
				put: (transformationBlock value: eachValue) ]! !

WBClassBuilder subclass: #MagmaWbClassBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Private'!

!MagmaWbClassBuilder methodsFor: 'as yet unclassified' stamp: 'cmm 4/10/2005 18:04'!
installClassAccessorOverride
	class 
		compileSilently:
'maOriginalClass
	^ self class superclass'
		classified: 'standard'! !

!MagmaWbClassBuilder methodsFor: 'as yet unclassified' stamp: 'cmm 4/4/2005 14:24'!
installInstVarAtPutOverride
	self shouldOverrideInstVarAtPut ifTrue:
		[ class compileSilently:
			'instVarAt: aNumber put: anObject
				| shouldSignal |
				shouldSignal := (super instVarAt: aNumber) ~~ anObject.
				shouldSignal ifTrue: [ self writeBarrier aboutToModify: self ].
				super instVarAt: aNumber put: anObject.
				shouldSignal ifTrue: [ self writeBarrier modified: self ]'
				classified: 'standard' ]! !

!MagmaWbClassBuilder methodsFor: 'as yet unclassified' stamp: 'cmm 4/3/2005 16:48'!
installOverrideOf: aSymbol fields: anArray

	class 
		addSelectorSilently: aSymbol 
		withMethod:
			(MagmaWbMethodBuilder 
				selector: aSymbol 
				class: class 
				fields: anArray) compiledMethod.
	fieldsCache at: aSymbol put: anArray! !

!MagmaWbClassBuilder methodsFor: 'as yet unclassified' stamp: 'cmm 4/10/2005 18:03'!
installStandardOverrides
	super installStandardOverrides.
	self 
		installClassAccessorOverride ;
		installInstVarAtPutOverride! !

!MagmaWbClassBuilder methodsFor: 'as yet unclassified' stamp: 'cmm 4/10/2005 19:55'!
migrateFromTarget: oldSuperclass to: newSuperclass

	| oldClass |
self halt.
	oldClass _ class.
	"Was the immediate WriteBarrier superclass modified (or was it a superclass of that)?"
	(oldClass superclass == newSuperclass)
		ifTrue:
			[ oldClass superclass: oldSuperclass.
			class _ self createSubclassOf: newSuperclass.
			class updateInstancesFrom: oldClass ]
		ifFalse:
			[ "Although my class refers to the proper superclass, it must be rebuilt because its format has changed and must now be updated."
			class _ self createSubclassOf: oldClass superclass.
			ClassBuilder new mutate: oldClass to: class
"			self
				updateInstancesOf: oldClass
				to:  class" ]! !

!MagmaWbClassBuilder methodsFor: 'as yet unclassified' stamp: 'cmm 4/4/2005 14:20'!
shouldOverrideInstVarAtPut

	^ self class isPointers! !

MaSoftwareError subclass: #MagmaSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MaFixedObjectBuffer methodsFor: '*magma client' stamp: 'cmm 3/28/2005 21:12'!
isDifferent: anObject using: aMaObjectSerializer
	"Only report anObject different if any of its *recorded* instVars changed, or if any of its *new* instVars is not nil."
	| classIdManager inImageDefinition bufferDefinition |
	classIdManager _ aMaObjectSerializer classIdManager.
	inImageDefinition _ classIdManager inImageDefinition: anObject maSerializationClass.
	bufferDefinition _ 
		classIdManager
			definitionForClassId: (classIdManager idForClass: anObject maSerializationClass)
			version: self classVersion.
	1 to: anObject maInstSize do:
		[ : index |  | instVarIndexInBackup |
		(anObject maIsTransient: index) ifFalse:
			[ instVarIndexInBackup _ bufferDefinition
				indexOfInstVarCorrespondingTo: index
				of: inImageDefinition.
			(instVarIndexInBackup = 0 and: [ (anObject instVarAt: index) notNil ]) ifTrue: [ ^ true ].
			(aMaObjectSerializer oidFor: (anObject instVarAt: index)) = (self maInstVarAt: instVarIndexInBackup) ifFalse: [ ^ true ] ] ].
	^ false! !

!MaFixedObjectBuffer methodsFor: '*magma client' stamp: 'cmm 3/28/2005 21:11'!
refresh: anObject using: aMagmaSession
	| inImageDefinition linkDescriptionDefinition classIdManager |
	classIdManager _ aMagmaSession serializer classIdManager.
	inImageDefinition _  classIdManager inImageDefinition: anObject maSerializationClass.
	linkDescriptionDefinition _ classIdManager
		definitionForClassId: (classIdManager idForClass: anObject maSerializationClass)
		version: self classVersion.
	self instVarsDoWithIndex:
		[ : sourceOid : sourceIndex |  | targetIndex |
		targetIndex _ 
			inImageDefinition
				indexOfInstVarCorrespondingTo: sourceIndex
				of: linkDescriptionDefinition.
		targetIndex > 0
			ifTrue:
				[ (anObject maIsTransient: targetIndex) ifFalse:
					[ anObject
						instVarAt: targetIndex
						put:
							(aMagmaSession serializer
								objectWithOid: sourceOid
								ifAbsent: [ aMagmaSession serializer proxyFor: sourceOid ]) ] ]
			ifFalse:
				[ sourceOid = MaOidCalculator oidForNil
					ifFalse:
						[ aMagmaSession serializer recordTruncatedObject: anObject ] ] ]! !

!Morph methodsFor: '*magma client' stamp: 'cmm 2/25/2005 17:23'!
aboutToRefreshFromMagma: aMagmaRefreshEvent

	| restoreData |
	self isInWorld ifFalse: [ "no need"  ^ self ].
	self isWorldMorph ifTrue: [ "not supported"  ^ self ].
	"capture position and index, then delete so it can be updated 'offline'."
	restoreData _ Dictionary new.
	restoreData
		at: #owner put: owner ;
		at: #index put: (owner submorphs indexOf: self) ;
		at: #wasStepping put: (self isWorldMorph or: [ self isStepping ]).
	aMagmaRefreshEvent restoreData: restoreData.
	self delete! !

!Morph methodsFor: '*magma client' stamp: 'cmm 4/10/2005 16:19'!
maAllowsWriteBarrier 
	"Just trying to be 'safe'."

	^ false! !

!Morph methodsFor: '*magma client' stamp: 'cmm 2/27/2005 18:48'!
refreshedFromMagma: aMagmaRefreshEvent

	aMagmaRefreshEvent hasRestoreData
		ifTrue:
			[ (aMagmaRefreshEvent restoreData at: #owner)
				addMorph: self
				asElementNumber: (aMagmaRefreshEvent restoreData at: #index).
			owner isWorldMorph
				ifTrue: 
					[ owner startSteppingSubmorphsOf: self.
					WorldState addDeferredUIMessage: (MessageSend receiver: owner selector: #clearTurtleTrails) ]
				ifFalse:
					[ (aMagmaRefreshEvent restoreData at: #wasStepping)
						ifTrue: [ self startStepping ] ] ]! !

!Morph methodsFor: '*magma client' stamp: 'cmm 2/22/2005 21:10'!
wantsMagmaEvents
	^ true! !

!Bitmap methodsFor: '*magma client' stamp: 'cmm 4/10/2005 16:20'!
maAllowsWriteBarrier 
	"Just trying to be 'safe'."

	^ false! !

!Bitmap methodsFor: '*magma client' stamp: 'cmm 10/9/2004 21:11'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^self compressToByteArray ~= aMaByteObjectBuffer asByteArray! !

!Bitmap methodsFor: '*magma client' stamp: 'cmm 10/8/2004 17:03'!
maRefreshTo: aMaByteObjectBuffer using: aMagmaSession

	| s byteArray |
	byteArray _ aMaByteObjectBuffer asByteArray.
	s _ ReadStream on: byteArray.
	self class decodeIntFrom: s.
	self decompress: self fromByteArray: byteArray at: s position+1! !

!MaOidManager methodsFor: '*magma client' stamp: 'cmm 6/10/2003 22:36'!
cleanObject: anObject

	^oids
		removeKey: anObject
		ifAbsent: [ nil ]! !

!MaOidManager methodsFor: '*magma client' stamp: 'cmm 5/8/2003 23:15'!
ensurePreparedToAllocateNewOids: numberOfOids
	"This is needed because we only have 2 million new-object oids.  As we commit more and more transactions, the nextOid counter continues to increase to its ceiling.  Once it reaches, we need to clear out all objects with new-object oids and they'll have to be assigned new oids."

	(MaOidCalculator isOidForNewObject: nextOid + numberOfOids + 100) ifTrue: [ ^false ].
	"We're about out of new-object oids.  Existing non-persistent objects are going to get new oids now.."
	oids copy keysAndValuesDo:
		[ :eachObject :eachOid |
		(MaOidCalculator isOidForNewObject: eachOid)
			ifTrue:
				[ oids removeKey: eachObject ] ].
	self resetNextOid.
	^true! !

MaOidManager subclass: #MagmaOidManager
	instanceVariableNames: 'newObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaOidManager commentStamp: 'cmm 6/21/2004 00:20' prior: 0!
Because removeKey: is so slow in Squeak, I keep track of which ones are newObjects.  That way, when we return from a commit, replacement of temp to permanent oids is much faster.!

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 4/3/2003 00:33'!
ensurePreparedToAllocateNewOids: numberOfOids

	(super ensurePreparedToAllocateNewOids: numberOfOids)
		ifTrue:
			[ self initializeNewObjects ]! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 4/3/2003 00:31'!
initializeNewObjects

	newObjects _ WeakValueDictionary new! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 4/10/2005 18:00'!
objectCountByClass
	^(objects collect: [:e | e maOriginalClass]) asBag sortedCounts! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2003 13:18'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^MaOidCalculator
		objectWithOid: anInteger
		ifNone:
			[ (MaOidCalculator isOidForNewObject: anInteger)
				ifTrue:
					[ newObjects
						maAt: anInteger
						ifPresent:
							[ :obj |
							obj 
								ifNil: [ aBlock value ] 
								ifNotNil: [ oneArgBlock value: obj ] ]
						ifAbsent: aBlock ]
				ifFalse:
					[ objects
						maAt: anInteger
						ifPresent:
							[ :obj |
							obj   "oid key marked to be cleaned"
								ifNil: [ aBlock value ]
								ifNotNil: [ oneArgBlock value: obj ] ]
						ifAbsent: aBlock ] ]




! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 3/16/2005 12:38'!
oidOf: anObject is: anInteger

	^(MaOidCalculator isOidForNewObject: anInteger)
		ifTrue:
			[ newObjects 
				at: anInteger 
				put: anObject.
			oids
				at: anObject
				put: anInteger ]
		ifFalse:
			[ super
				oidOf: anObject
				is: anInteger ]! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 3/24/2005 12:08'!
postIndependentCopy

	newObjects _ newObjects copy! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2003 12:58'!
removeGarbageCollectedObjectEntries

	super removeGarbageCollectedObjectEntries.
	newObjects _ newObjects reject: [ :each | each isNil ]! !

!MagmaOidManager methodsFor: 'as yet unclassified' stamp: 'cmm 4/3/2003 00:31'!
reset

	super reset.
	self initializeNewObjects! !

MaWarning subclass: #MagmaWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MagmaWarning subclass: #MagmaTruncationWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MaMinimalObject methodsFor: '*magma client' stamp: 'cmm 3/28/2005 17:02'!
maAllowsWriteBarrier

	^ false! !

!Symbol methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:34'!
isImmutableInMagma

	^ true! !

!Symbol methodsFor: '*magma client' stamp: 'cmm 10/8/2004 17:19'!
maRefreshTo: aMaByteObjectBuffer using: aMagmaSession
	"Never try to refresh a Symbol.  They cannot change."
! !

!MaObjectBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 23:19'!
isDifferent: anObject using: aMaObjectSerializer
	self subclassResponsibility! !

!MaObjectBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 22:54'!
refresh: anObject using: aMaObjectSerializer
	self subclassResponsibility! !

MaNotification subclass: #MagmaNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Notifications'!

MagmaNotification subclass: #MagmaIncomingChangeSetNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Notifications'!

!MagmaIncomingChangeSetNotification methodsFor: 'as yet unclassified' stamp: 'cmm 2/3/2005 21:22'!
defaultAction
	"The ChangeSet will be created if it does not exist.  Resume with true to instruct Magma to file in the code with the ChangeSet."

	self resume: false! !

MagmaNotification subclass: #MagmaProxyMaterialization
	instanceVariableNames: 'materializedObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Notifications'!

!MagmaProxyMaterialization commentStamp: 'cmm 1/13/2005 23:05' prior: 0!
I am signaled when a mutating proxy is materialized.  The materializedObject is available as an argument.

To use:

	[ ... do your stuff ... ]
		on: MagmaProxyMaterialization 
		do:
			[ : theNotification |
			doSomethingWith: theNotification.
			theNotification resume "<-- very important!!" ]

!

!MagmaProxyMaterialization class methodsFor: 'signaling' stamp: 'cmm 4/10/2005 18:00'!
signalMaterializedObject: anObject 
	(self new)
		messageText: 'materializing a ' , anObject maOriginalClass printString;
		materializedObject: anObject;
		signal! !

!MagmaProxyMaterialization methodsFor: 'as yet unclassified' stamp: 'cmm 4/27/2003 20:14'!
materializedObject

	^materializedObject! !

!MagmaProxyMaterialization methodsFor: 'as yet unclassified' stamp: 'cmm 5/2/2003 17:23'!
materializedObject: anObject

	materializedObject _ anObject! !

MagmaNotification subclass: #MagmaProxySerialization
	instanceVariableNames: 'proxyBeingSerialized'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Notifications'!

!MagmaProxySerialization commentStamp: 'cmm 1/14/2005 12:30' prior: 0!
Some users may want to know all of the "foreign" repositories that can be reached from their repository.  Magma doesn't maintain its own list, but will signal this notification for each one it encounters during serialization.  Client programs who care about this may track it, if they wish, just be sure to remember to resume the notification.!

!MagmaProxySerialization class methodsFor: 'as yet unclassified' stamp: 'cmm 1/14/2005 12:30'!
for: aMagmaForwardingProxy

	^ self new
		proxyBeingSerialized: aMagmaForwardingProxy ;
		yourself! !

!MagmaProxySerialization methodsFor: 'as yet unclassified' stamp: 'cmm 1/14/2005 12:29'!
proxyBeingSerialized

	^ proxyBeingSerialized! !

!MagmaProxySerialization methodsFor: 'as yet unclassified' stamp: 'cmm 1/14/2005 12:29'!
proxyBeingSerialized: aMagmaForwardingProxy

	proxyBeingSerialized _ aMagmaForwardingProxy! !

MagmaNotification subclass: #MagmaSessionRequest
	instanceVariableNames: 'doBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Notifications'!

!MagmaSessionRequest commentStamp: 'cmm 1/13/2005 23:08' prior: 0!
I am used to signal to the session controller a session directive, such as connect, commit, abort, disconnect, or others.

Use my class-side api in your domain code.  For example, in your setters:

	name: aString
		MagmaSessionRequest signalCommit: [ name _ aString ]

When Magma is not used, the session request has no effect.!

!MagmaSessionRequest class methodsFor: 'private' stamp: 'cmm 4/22/2003 23:41'!
signal: aString do: oneArgBlock
	"oneArgBlock takes the session that you wish to do something to."

	^self new
		messageText: aString;
		doBlock: oneArgBlock;
		signal! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/24/2003 15:00'!
signalAbort

	self 
		signal: 'aborting transaction'
		do: [ :session | session abort ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:42'!
signalBegin

	self 
		signal: 'beginning transaction'
		do: [ :session | session begin ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:43'!
signalCommit

	self 
		signal: 'committing transaction'
		do: [ :session | session commit ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 12/11/2004 14:04'!
signalCommit: aBlock

	| result |
	self signalBegin.
	result _ aBlock value.
	self signalCommit.
	^ result! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:50'!
signalCommitAndBegin

	self 
		signal: 'committing transaction and beginning a new one'
		do: [ :session | session commitAndBegin ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/24/2003 16:35'!
signalFinalizeOids

	self 
		signal: 'beginning transaction'
		do: [ :session | session finalizeOids ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/10/2005 19:13'!
signalNoteOldKeysFor: anObject

	self 
		signal: 'committing transaction'
		do: [ :session | session noteOldKeysFor: anObject ]! !

!MagmaSessionRequest class methodsFor: 'signaling' stamp: 'cmm 4/22/2003 23:43'!
signalStubOut: anObject

	self
		signal: 'stubbing out ', anObject printString
		do: [ :session | session stubOut: anObject ]! !

!MagmaSessionRequest methodsFor: 'private' stamp: 'cmm 3/20/2003 01:05'!
doBlock: oneArgBlock

	doBlock _ oneArgBlock! !

!MagmaSessionRequest methodsFor: 'handler' stamp: 'cmm 3/23/2003 22:47'!
handleAndResumeUsing: aMagmaSession

	doBlock value: aMagmaSession.
	self resume! !

MagmaNotification subclass: #MagmaUserRequirementNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Notifications'!

!MagmaUserRequirementNotification commentStamp: 'cmm 3/11/2005 14:13' prior: 0!
I am used when Magma discovers it is missing an object and must get it from the user.  For example, when the user invokes a forwarding-proxy to another repository, connection credentials for that repository must be supplied.  Magma does not keep these for you, but it requires them.!

MagmaUserRequirementNotification subclass: #MagmaUserRequiredNotification
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Notifications'!

!MagmaUserRequiredNotification class methodsFor: 'private' stamp: 'cmm 3/13/2005 18:08'!
requestUserFor: aMagmaSession

	^ (self session: aMagmaSession)
		messageText: 'Supply a userId for ', aMagmaSession linkInformation ;
		signal! !

!MagmaUserRequiredNotification class methodsFor: 'as yet unclassified' stamp: 'cmm 3/13/2005 18:07'!
session: aMagmaSession

	^ self new
		session: aMagmaSession ;
		yourself! !

!MagmaUserRequiredNotification methodsFor: 'as yet unclassified' stamp: 'cmm 3/13/2005 18:07'!
defaultAction
	"The user did not listen for this notification.  For now, bail them out by offering them an opportunity to create one on the fly."

	self resume:
		(session user
			ifNil:
				[ MagmaUser id: (FillInTheBlank request: 'Enter your user-id at ', session linkInformation) ])! !

!MagmaUserRequiredNotification methodsFor: 'as yet unclassified' stamp: 'cmm 3/13/2005 18:07'!
session: aMagmaSession

	session _ aMagmaSession! !

!CompiledMethod methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:34'!
isImmutableInMagma

	^ true! !

!ClassDescription methodsFor: '*magma client' stamp: 'cmm 3/28/2005 16:44'!
maAllowsWriteBarrier

	^ false! !

!MaVariableBuffer methodsFor: '*magma client' stamp: 'cmm 11/24/2004 09:23'!
isDifferent: anObject using: aMaObjectSerializer
	"To determine different for variable classes requires special-case, therefore dispatch."
	^ anObject
		maIsChangedFrom: self
		using: aMaObjectSerializer! !

!MaVariableBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 23:10'!
refresh: variableObject using: aMagmaSession
	"Collections require special-case behavior to handle this, dispatch."
	variableObject
		maRefreshTo: self
		using: aMagmaSession! !

!MaClassReferenceBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 23:21'!
isDifferent: anObject using: aMaObjectSerializer
	"Class changes are not detected directly in the class.  They are instead detected in MaClassDefinition's."
	^ false! !

!MaClassReferenceBuffer methodsFor: '*magma client' stamp: 'cmm 11/23/2004 22:55'!
refresh: anObject using: aMaObjectSerializer
	"Nothing to do for classes."! !

!String methodsFor: '*magma client' stamp: 'cmm 3/28/2005 12:39'!
maAllowsWriteBarrier
	"Primitive failed when attempted."

	^ false! !

!String methodsFor: '*magma client' stamp: 'cmm 10/17/2004 14:24'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer

	^self ~= aMaByteObjectBuffer asString! !

!LargePositiveInteger methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:37'!
isImmutableInMagma

	^ true! !

!LargePositiveInteger methodsFor: '*magma client' stamp: 'cmm 3/27/2005 23:12'!
maAllowsWriteBarrier 
	"No reason to."
	^ false! !

MaForwardingProxy subclass: #MagmaForwardingProxy
	instanceVariableNames: 'magmaId oid session cachedObject offlineResults'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaForwardingProxy commentStamp: 'cmm 1/13/2005 14:47' prior: 0!
I refer to an object in the repository indicated by my 'magmaId'.  You send me a message and I'll signal my session to try to connect if necessary and forward the message on to the real object in that repository.

If my session cannot make a connection, I will create an "MagmaOfflineObject" which will remember the message you sent and try to send it when the session becomes available.!

!MagmaForwardingProxy class methodsFor: 'as yet unclassified' stamp: 'cmm 4/7/2005 22:55'!
session: aMagmaSession oid: anInteger

	^ self new
		forwardingProxySession: aMagmaSession ;
		forwardingProxyOid: anInteger! !

!MagmaForwardingProxy methodsFor: 'testing' stamp: 'cmm 1/13/2005 17:49'!
canGetRealObject

	^ cachedObject notNil
	or: [ session notNil and: [ session isConnected ] ]! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/18/2005 12:57'!
doesNotUnderstand: aMessage

	(aMessage arguments anySatisfy: [ : each | each isMagmaOfflineObject ])
				ifTrue:
					[ MagmaEnvironmentError signal: 'Can''t use an offline object as input to a message.' ].
	^ self canGetRealObject
		ifTrue:
			[ self
				forward: aMessage
				to: self realObject ]
		ifFalse:
			[ self ensureConnectedOrOffline.
			session isConnected
				ifTrue:
					[ self
						forward: aMessage
						to: self realObject ]
				ifFalse:
					[ "attempt to soften the impact of being on a plane with some sort of offline functionality."
					MagmaNotification signal: 'Creating offline object for ', oid printString, ' needing message ', aMessage printString.
					self offlineResults add: (MagmaOfflineObject needingMessage: aMessage) ] ]! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/18/2005 17:02'!
ensureConnectedOrOffline
	"If the state of this proxy is still ambiguous, disambiguate it by trying to connect to my session."

	(self isForwardingProxyOffline not or: [ session isNil ]) ifTrue:
		[ [ self forwardingProxySession ensureConnected ]
			on: MaNetworkError
			do:
				[ : err | MagmaNotification signal: 'could not connect to ', self forwardingProxySession linkInformation, '.' ] ]! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/15/2005 13:36'!
forward: aMessage to: anObject

	| answer |
	answer _
		super
			forward: aMessage
			to: anObject.
	self hasOfflineResults ifTrue:
		[ offlineResults do:
			[ : each |
			each
				becomeForward: (each waitingMessage sendTo: answer)
				copyHash: false ].
		MagmaWarning signal: 'Reconnecting to ', session magmaId name, ' has caused temporary offline-objects to become real objects.  Please rehash collections as necessary.'.
		self resetOfflineResults ].
	^ answer! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/18/2005 16:23'!
forwardingProxyOid
	^ oid! !

!MagmaForwardingProxy methodsFor: 'initialize-release' stamp: 'cmm 1/18/2005 16:22'!
forwardingProxyOid: anInteger

	oid _ anInteger! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/18/2005 16:16'!
forwardingProxySession
	"This has such an ugly name so as not to conflict with other API named #session, to which I need to invoke my doesNotUnderstand: logic."
	^ session ifNil: [ session _ magmaId session ]! !

!MagmaForwardingProxy methodsFor: 'initialize-release' stamp: 'cmm 1/18/2005 16:22'!
forwardingProxySession: aMagmaSession

	session _ aMagmaSession.
	magmaId _ aMagmaSession magmaId.
	magmaId location: aMagmaSession location! !

!MagmaForwardingProxy methodsFor: 'testing' stamp: 'cmm 1/14/2005 12:18'!
hasOfflineResults
	"I am offline if an attempt has been made to connect to my session but failed.  Once offline, I will not continue to try connecting to my session each time a message is sent."

	^ offlineResults isEmptyOrNil not! !

!MagmaForwardingProxy methodsFor: 'testing' stamp: 'cmm 1/18/2005 16:24'!
isForwardingProxyOffline
	"I am offline if an attempt has been made to connect to my session but failed.  Once offline, I will not continue to try connecting to my session each time a message is sent."

	^ self hasOfflineResults! !

!MagmaForwardingProxy methodsFor: 'testing' stamp: 'cmm 4/8/2005 15:20'!
isImmutableInMagma 
	"There is absolutely no reason to subject yourself to the danger of trying to point this to a different object.  Just create a new one via #asMagmaForwardingProxy."

	^ true! !

!MagmaForwardingProxy methodsFor: 'testing' stamp: 'cmm 1/17/2005 12:47'!
maIsForwardingProxy

	^ true! !

!MagmaForwardingProxy methodsFor: 'serialization' stamp: 'cmm 1/14/2005 12:30'!
maPreserialize

	(MagmaProxySerialization for: self) signal! !

!MagmaForwardingProxy methodsFor: 'testing' stamp: 'cmm 1/16/2005 23:52'!
maRequiresOwnBuffer

	^ true! !

!MagmaForwardingProxy methodsFor: 'serialization' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables 
	^ super maTransientVariables, #( 'session' 'cachedObject' 'offlineResults' )! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/17/2005 17:36'!
name

	^ self doesNotUnderstand: (Message selector: #name)! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/13/2005 16:04'!
offlineResults

	^ offlineResults ifNil: [ offlineResults _ OrderedCollection new ]! !

!MagmaForwardingProxy methodsFor: 'actions' stamp: 'cmm 4/18/2005 16:43'!
proxyDisconnect
	"If I was unable to connect to my repository earlier, use this method to try to connect again."

	self forwardingProxySession disconnect! !

!MagmaForwardingProxy methodsFor: 'actions' stamp: 'cmm 1/18/2005 16:18'!
proxyReconnect
	"If I was unable to connect to my repository earlier, use this method to try to connect again."

	self forwardingProxySession ensureConnected! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/13/2005 17:41'!
realObject

	^ cachedObject ifNil:
		[ cachedObject _ session
			objectWithOid: oid
			ifAbsent:
				[ MagmaGarbageCollectedObject signal: 'Sorry, this object has been dereferenced and subsequently garbage collected.' ] ]! !

!MagmaForwardingProxy methodsFor: 'initialize-release' stamp: 'cmm 1/13/2005 16:03'!
resetOfflineResults

	offlineResults _ nil! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/17/2005 13:02'!
size

	^ self doesNotUnderstand: (Message selector: #size)! !

!MagmaForwardingProxy methodsFor: 'private' stamp: 'cmm 1/17/2005 21:57'!
value

	^ self doesNotUnderstand: (Message selector: #value)! !

!ContextPart methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:35'!
isImmutableInMagma

	^ true! !

!SystemOrganizer methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:33'!
isImmutableInMagma

	^ true! !

!HandMorph methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:37'!
isImmutableInMagma

	^ true! !

MaError subclass: #MagmaCommitError
	instanceVariableNames: 'result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MagmaCommitError commentStamp: 'cmm 3/21/2003 00:50' prior: 0!
I am signaled when another user has committed a change an object that you changed since you began your transaction.!

!MagmaCommitError methodsFor: 'as yet unclassified' stamp: 'cmm 12/17/2002 23:59'!
result

	^result! !

!MagmaCommitError methodsFor: 'as yet unclassified' stamp: 'cmm 12/17/2002 23:59'!
result: aMaCommitResult

	result _ aMaCommitResult! !

MaObject subclass: #MaBasicReadStrategy
	instanceVariableNames: 'minimumDepth isNew'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MaBasicReadStrategy commentStamp: '<historical>' prior: 0!
This class operates on the client and server.!

!MaBasicReadStrategy class methodsFor: 'creation' stamp: ''!
deep

	^self minimumDepth: 99999
! !

!MaBasicReadStrategy class methodsFor: 'creation' stamp: ''!
minimumDepth: anInteger

	^self new minimumDepth: anInteger
! !

!MaBasicReadStrategy methodsFor: 'new/old' stamp: 'cmm 1/25/2005 23:53'!
beNew
	"Be in a state that indicates I have changed and am different than my cached version on the server."

	isNew _ true! !

!MaBasicReadStrategy methodsFor: 'new/old' stamp: 'cmm 1/25/2005 14:55'!
beOld
	"Indicate that I have been checked against my classDefinitions and all possible depthSpecifications have been converted to the required server format (id's instead of classes)."
	isNew _ false! !

!MaBasicReadStrategy methodsFor: 'copying' stamp: 'cmm 2/8/2005 23:03'!
copyWithoutSpecifications

	^ self copy! !

!MaBasicReadStrategy methodsFor: 'unused depths' stamp: 'cmm 4/28/2003 22:38'!
hasUnusedDepths

	^false! !

!MaBasicReadStrategy methodsFor: 'private' stamp: 'cmm 4/28/2003 22:31'!
initialize

	super initialize.
	isNew _ true! !

!MaBasicReadStrategy methodsFor: 'accessing' stamp: 'cmm 4/7/2005 15:14'!
isBasic
	^ true! !

!MaBasicReadStrategy methodsFor: 'new/old' stamp: 'cmm 1/25/2005 23:53'!
isNew
	"Answer whether I have changed and now need to be cached in my session on the server."
	^isNew! !

!MaBasicReadStrategy methodsFor: 'building' stamp: 'cmm 1/26/2005 00:02'!
makeReadyForUseUsing: aMaClassIdManager
	"nothing to do for MaBasicReadStrategy's."! !

!MaBasicReadStrategy methodsFor: 'accessing' stamp: ''!
minimumDepth

	^minimumDepth
! !

!MaBasicReadStrategy methodsFor: 'building' stamp: 'cmm 1/25/2005 23:52'!
minimumDepth: anInteger

	minimumDepth _ anInteger.
	self beNew! !

MaBasicReadStrategy subclass: #MaReadStrategy
	instanceVariableNames: 'depths depthSpecifications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MaReadStrategy commentStamp: 'cmm 1/26/2005 21:28' prior: 0!
When objects are retrieved from a Magma repository, the server must eventually decide to stop traversing the graph and return a reasonable chunk of objects.  Sometimes, the default pattern of reading may be ineffecient for the processing needed.

Therefore, my instances can be used to suggest to the server a particular depth for particular class or even a variable within a class.

Implementation notes:

There are two parts; 'specifications' and 'depths'.  The specifications track what the user wants, while the depths are the efficiently-integerized representation for each MaClassDefinition (and version).  That's why there are not more first-class objects here, MaObjectSerializer is efficient with #'s (although now with the server caching it's probably no longer an excuse).  Whenever the specs change, or when the ClassDefinitions change the depths need to be rebuilt.  That's what my #isNew api is all about.

When transmitted to the server, it caches me there and I am then told to #beOld.  But only my depths are actually transmitted for further efficiency.  My '*magma server' methods are employed to determine the depth on the server.

Use my 'building' methods so that the Testing methods can then answer whether a particular depth should be read on a particular object or class.
!

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 1/26/2005 22:28'!
convertSpecificationsToIdsUsing: aMaClassIdManager
	"Convert the classes in the receiver to classId's, since that is what the server goes by."

	| specifiedClassNames |
	specifiedClassNames _ depthSpecifications keys collect: [ : each | each name ].
	aMaClassIdManager classDefinitionsById do:
		[ : eachDefinitions |
		eachDefinitions do:
			[ : eachDefinition |
			eachDefinition withAllSuperclassDefinitionsDo:
				[ : eachDef |
				(specifiedClassNames includes: eachDef name)
					ifTrue:
						[ depths
							at: { eachDefinition id.  eachDefinition version }
							ifAbsentPut:
								[ self beNew.
								(self instVarMapFor: eachDef) ] ] ] ] ]! !

!MaReadStrategy methodsFor: 'specifications' stamp: 'cmm 9/23/2004 15:52'!
copyWithoutSpecifications

	^super copy
		resetSpecifications ;
		yourself! !

!MaReadStrategy methodsFor: 'accessing' stamp: 'cmm 1/26/2005 11:16'!
depthArrayOfSize: arraySize

	^(Array new: arraySize) atAllPut: 0; yourself! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 6/10/2004 22:27'!
depthDictionaryOfSize: arraySize

	^ Dictionary new: arraySize! !

!MaReadStrategy methodsFor: 'building' stamp: 'cmm 6/28/2004 14:58'!
forVariableNamed: aString onAny: aClass readToDepth: anInteger

	(aClass instVarNames includes: aString)
		ifFalse:
			[ MagmaUserError signal: aString , ' is not an attribute of ' , aClass name ].
	(depthSpecifications
		at: aClass
		ifAbsentPut: [ self depthDictionaryOfSize: aClass instSize ])
			at: aString
			put: anInteger! !

!MaReadStrategy methodsFor: 'specifications' stamp: 'cmm 6/28/2004 14:56'!
hasUnusedDepths

	^ depthSpecifications notEmpty! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 1/26/2005 22:56'!
inheritDeeperDepthsUsing: aMaClassIdManager
	"When the user specifies:

		myReadStrategy
			forVariableNamed: 'submorphs'
			onAny: Morph
			readToDepth: 99999

	then we need to ensure that any subclasses of Morph also read to 99999 for that variable.  Since each class has its own entire set of depth specs, we update the subclasses with the greater depth between their own and that of all their superclasses."

	depths keysAndValuesDo:
		[ : eachIdAndVersion : eachDepths |
		eachDepths isInteger "using one default base depth for all variables"
			ifTrue:
				[ depths at: eachIdAndVersion put: (eachDepths max: (depths at: eachIdAndVersion)) ]
			ifFalse:
				[ | definition |
				definition _ aMaClassIdManager
					definitionForClassId: eachIdAndVersion first
					version: eachIdAndVersion last.
				eachDepths withIndexDo:
					[ : eachDepth : instVarIndex |
					definition allSuperclassDefinitionsDo:
						[ : eachDefinition |
						eachDefinition namedInstSize >= instVarIndex
							ifTrue:
								[ | superclassDepth |
								superclassDepth _ (depths at: { eachDefinition id. eachDefinition version }) at: instVarIndex.
								eachDepths 
									at: instVarIndex 
									put: (eachDepth max: superclassDepth) ] ] ] ] ]! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 2/9/2005 10:14'!
initialize

	super initialize.
	"depths:  key is converted to the classId, value is either
	anInteger for depth of all instVars or an Array detailing the
	depth of each instVar."
	self 
		resetDepths ;
		initializeDefaultSpecifications! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 2/9/2005 15:38'!
initializeDefaultSpecifications

	depthSpecifications _ Dictionary new.
	self
		onAny: MaClassDefinition
		readToDepth: 99999 ;

		onAny: Morph
		readToDepth: 99999 ;
		
		onAny: Project
		readToDepth: 99999 ;
		
		onAny: Color
		readToDepth: 99999 ;

		onAny: MaRootAnchor
		readToDepth: 1 ;

		onAny: Collection
		readToDepth: 1 ;
		
		onAny: MagmaCollection
		readToDepth: 99999! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 1/26/2005 22:21'!
instVarMapFor: aMaClassDefinition
	"Answer an Array with an instVarMap of aMaClassDefinition according to user-declared read depths."

	| specifiedDepths answer |
	(aMaClassDefinition isDefined
	and: [ depthSpecifications includesKey: aMaClassDefinition classObject ])
		ifTrue:
			[ specifiedDepths _ depthSpecifications at: aMaClassDefinition classObject.
			specifiedDepths isInteger
				ifTrue: [ answer _ specifiedDepths ]
				ifFalse:
					[ answer _ self depthArrayOfSize: aMaClassDefinition namedInstSize.
					specifiedDepths keysAndValuesDo:
						[ : eachInstVarName : eachDepth |
						answer
							at: (aMaClassDefinition allInstVarNames indexOf: eachInstVarName)
							put: eachDepth ] ] ].
	^ answer! !

!MaReadStrategy methodsFor: 'accessing' stamp: 'cmm 4/7/2005 15:14'!
isBasic
	^ false! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 1/26/2005 22:56'!
makeReadyForUseUsing: aMaClassIdManager

	self 
		resetDepths ;
		convertSpecificationsToIdsUsing: aMaClassIdManager ;
		inheritDeeperDepthsUsing: aMaClassIdManager! !

!MaReadStrategy methodsFor: 'building' stamp: 'cmm 6/28/2004 14:56'!
onAny: aClass readToDepth: anInteger

	depthSpecifications
		at: aClass
		put: anInteger! !

!MaReadStrategy methodsFor: 'private' stamp: 'cmm 6/30/2004 17:14'!
resetDepths

	depths _ Dictionary new! !

!MaReadStrategy methodsFor: 'specifications' stamp: 'cmm 9/23/2004 15:55'!
resetSpecifications

	depthSpecifications _ nil! !

MaObject subclass: #MaChangedKeySpecification
	instanceVariableNames: 'object attribute oldHashValues newHashValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaChangedKeySpecification class methodsFor: 'creation' stamp: 'cmm 12/5/2002 18:00'!
object: anObject attribute: aSymbol oldHashValues: oldHashValueInteger newHashValues: newHashValueInteger

	^self new
		object: anObject;
		attribute: aSymbol;
		oldHashValues: oldHashValueInteger;
		newHashValues: newHashValueInteger! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: ''!
attribute

	^attribute! !

!MaChangedKeySpecification methodsFor: 'private building' stamp: ''!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: 'cmm 12/5/2002 17:54'!
newHashValues

	^newHashValues! !

!MaChangedKeySpecification methodsFor: 'private building' stamp: 'cmm 12/5/2002 18:00'!
newHashValues: anArray

	newHashValues _ anArray! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: ''!
object

	^object! !

!MaChangedKeySpecification methodsFor: 'private building' stamp: ''!
object: anObject

	object _ anObject
! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: ''!
oid

	^object
! !

!MaChangedKeySpecification methodsFor: 'accessing' stamp: 'cmm 12/5/2002 17:54'!
oldHashValues

	^oldHashValues! !

!MaChangedKeySpecification methodsFor: 'private building' stamp: 'cmm 12/5/2002 18:00'!
oldHashValues: anArray

	oldHashValues _ anArray! !

!MaChangedKeySpecification methodsFor: 'building' stamp: 'cmm 11/19/2002 22:42'!
serializeUsing: aMaObjectSerializer

	object _ aMaObjectSerializer oidFor: object! !

MaObject subclass: #MaCommitPackage
	instanceVariableNames: 'objects allLargeCollectionChanges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaCommitPackage commentStamp: 'cmm 3/8/2005 09:41' prior: 0!
This class represents all of the changes made from a single client for a single transaction.!

!MaCommitPackage class methodsFor: 'creation' stamp: ''!
new
	"Don't have unnecessarily large physicalSize.  Keep the work on the client."

	^self new: 8
! !

!MaCommitPackage class methodsFor: 'creation' stamp: ''!
new: anInteger

	^super new setSize: anInteger
! !

!MaCommitPackage methodsFor: 'building' stamp: 'cmm 4/5/2005 21:37'!
addLargeCollectionChanges: aMaLargeCollectionChanges using: aMagmaSession

	"Add a copy of the changes instead of the originals because each serialization mutates the changes from first-class objects into oids."
	self allLargeCollectionChanges add: aMaLargeCollectionChanges copyForSerialization.
	"Make sure we get new objects that may only be referenced by a LargeCollection."
	aMaLargeCollectionChanges
		addNewAdditionsTo: self
		using: aMagmaSession! !

!MaCommitPackage methodsFor: 'private' stamp: ''!
addNewAdditionsIn: aMaLargeCollectionChanges using: aMagmaSession

	aMaLargeCollectionChanges additionsDo:
		[ :eachObject :eachHashIndexValues |
		(aMagmaSession isPersistent: eachObject) ifFalse: [ self addObject: eachObject ] ]
! !

!MaCommitPackage methodsFor: 'building' stamp: ''!
addObject: anObject

	^objects add: anObject
! !

!MaCommitPackage methodsFor: 'accessing' stamp: 'cmm 4/5/2005 21:38'!
allLargeCollectionChanges

	^ allLargeCollectionChanges ifNil: [ allLargeCollectionChanges _ Set new ]! !

!MaCommitPackage methodsFor: 'building' stamp: ''!
allLargeCollectionChanges: aSet

	allLargeCollectionChanges _ aSet
! !

!MaCommitPackage methodsFor: 'private' stamp: 'cmm 4/5/2005 21:39'!
allLargeCollectionChangesDo: aBlock

	allLargeCollectionChanges ifNotNil: [ allLargeCollectionChanges do: aBlock ]! !

!MaCommitPackage methodsFor: 'copying' stamp: ''!
copyWithNewLargeCollectionChanges

	^self copy
		allLargeCollectionChanges: (self allLargeCollectionChanges collect: [ :each | each copy ])
! !

!MaCommitPackage methodsFor: 'testing' stamp: ''!
hasNewIndexes
	"Don't use conform: or detect: because it forces creation of a collection for
	the new indexes."

	self
		allLargeCollectionChangesDo: [ :eachChanges | eachChanges hasAddedIndexes ifTrue: [ ^true ] ].
	^false
! !

!MaCommitPackage methodsFor: 'testing' stamp: 'cmm 11/26/2002 22:18'!
hasRemovedIndexes

	self
		allLargeCollectionChangesDo: [ :eachChanges | eachChanges hasRemovedIndexes ifTrue: [ ^true ] ].
	^false! !

!MaCommitPackage methodsFor: 'accessing' stamp: 'cmm 4/6/2005 18:03'!
largeCollectionChangesFor: aMagmaLargeCollection

	allLargeCollectionChanges ifNil: [ MagmaSoftwareError signal: 'no changes found' ].
	^ allLargeCollectionChanges
		detect: [ : each | each collection == aMagmaLargeCollection ]
		ifNone: [ MagmaSoftwareError signal: 'no changes found' ]! !

!MaCommitPackage methodsFor: 'actions' stamp: ''!
newIndexesDo: twoArgBlock
	"For all largeCollections that have had one or more indexes added on this
	transaction, evaluate twoArgBlock.  The first argument is collection (or oid of
	the colection if the receiver has serialized itself, the second is a collection of
	the indexes."

	self allLargeCollectionChangesDo:
		[ :eachChanges |
		eachChanges hasAddedIndexes
			ifTrue:
				[ twoArgBlock
					value: eachChanges collection
					value: eachChanges addedIndexes ] ]
! !

!MaCommitPackage methodsFor: 'actions' stamp: ''!
newObjectsDo: aBlock
	"This can only be used after the receiver has serialialized his objects
	(via #serializeObjectsUsing:)."

	| isRootBuffer |
	"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
	isRootBuffer _ true.
	objects buffersDo:
		[ :each |
		isRootBuffer
			ifTrue:
				[ isRootBuffer _ false ]
			ifFalse:
				[ (MaOidCalculator isOidForNewObject: each oid) ifTrue: [ aBlock value: each ] ] ]
! !

!MaCommitPackage methodsFor: 'accessing' stamp: ''!
objects

	^objects! !

!MaCommitPackage methodsFor: 'actions' stamp: 'cmm 12/19/2002 23:25'!
objectsDo: aBlock

	objects isCollection
		ifTrue:
			[ objects do: aBlock ]
		ifFalse:
			[ | isRootBuffer |
			"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
			isRootBuffer _ true.
			objects buffersDo:
				[ :each |
				isRootBuffer ifTrue: [ isRootBuffer _ false ] ifFalse: [ aBlock value: each ] ] ]! !

!MaCommitPackage methodsFor: 'actions' stamp: ''!
persistentObjectsDo: aBlock
	"This can only be used after the receiver has serialialized his objects
	(via #serializeObjectsUsing:)."

	| isRootBuffer |
	"Skip the first buffer because that is the receivers objects OC itself, not part of any client objects."
	isRootBuffer _ true.
	objects buffersDo:
		[ :each |
		isRootBuffer
			ifTrue:
				[ isRootBuffer _ false ]
			ifFalse:
				[ (MaOidCalculator isOidForNewObject: each oid) ifFalse: [ aBlock value: each ] ] ]
! !

!MaCommitPackage methodsFor: 'building' stamp: 'cmm 3/27/2005 20:52'!
removeObject: anObject

	objects
		remove: anObject
		ifAbsent: [ "no problem" ]! !

!MaCommitPackage methodsFor: 'actions' stamp: 'cmm 11/26/2002 22:14'!
removedIndexesDo: twoArgBlock
	"For all largeCollections that have had one or more indexes removed on this transaction, evaluate twoArgBlock.  The first argument is the collection (or oid of the collection if the receiver has serialized itself, the second is a collection of the indexes)."

	self allLargeCollectionChangesDo:
		[ :eachChanges |
		eachChanges hasRemovedIndexes
			ifTrue:
				[ twoArgBlock
					value: eachChanges collection
					value: eachChanges removedIndexes ] ]! !

!MaCommitPackage methodsFor: 'private' stamp: 'cmm 11/14/2002 21:35'!
serializeLargeCollectionsChangesUsingCopyOf: aMaObjectSerializer
	"The objects are serialized, now serialize the allLargeCollectionChanges of
	the receiver."

	| copiedSerializer |
	copiedSerializer _ nil.
	self allLargeCollectionChangesDo:
		[ :eachChanges | 
		copiedSerializer ifNil: [ copiedSerializer _ aMaObjectSerializer copyWithNewBuffer ].
		eachChanges serializeUsing: copiedSerializer ]
! !

!MaCommitPackage methodsFor: 'building' stamp: 'cmm 3/16/2005 12:38'!
serializeObjectsUsing: aMagmaSession
	"Serialize my 'objects' into a MaSerializedGraphBuffer since the server does not deal with objects, just their buffers."

	| mustReserialize serializer numberOfClassesBefore |

	serializer _ aMagmaSession serializer.
	serializer ensurePreparedToAllocateNewOids: objects size.
	numberOfClassesBefore _ serializer classIdManager numberOfClasses.
	mustReserialize _ false.
	[ objects _
		serializer
			serializeGraph: objects
			do:
				[ :each |
				"Determine if class definition of each has changed."
				(serializer classIdManager hasClassDefinitionFor: each maSerializationClass)
					ifFalse:
						[ mustReserialize _ true.
						serializer classIdManager assimilateInImageDefinition: each maSerializationClass ].
				"Look for any newly created LargeCollections.."
				each maIsLargeCollection
					ifTrue:
						[ (aMagmaSession managesMagmaCollection: each)
							ifFalse:
								[ mustReserialize _ true.
								aMagmaSession addLargeCollection: each ] ] ] ]
		on: MaTraverseProxyNotification 
		do:
			[ : error | 
			error proxy mutatingProxySession magmaId = aMagmaSession magmaId
				ifTrue: [ error resume ]
				ifFalse: [ MagmaUserError signal: 'Halting to protect you from yourself.  You should only share copies, not the actual instances, across repositories.' ] ].
	self serializeLargeCollectionsChangesUsingCopyOf: serializer.
	^mustReserialize or: [ serializer classIdManager numberOfClasses > numberOfClassesBefore ]! !

!MaCommitPackage methodsFor: 'private' stamp: 'cmm 4/21/2002 23:11'!
setSize: anInteger

	objects _ IdentitySet new: anInteger
! !

!MaCommitPackage methodsFor: 'accessing' stamp: 'cmm 12/31/2002 00:21'!
size
	self maMarked: 'dev'.  "If you can get rid of ensurePreparedToAllocateNewOids:, then you should be able to get rid of this."
	^objects size! !

MaObject subclass: #MaIndexDefinition
	instanceVariableNames: 'attribute recordSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

MaIndexDefinition subclass: #MaByteSequenceIndexDefinition
	instanceVariableNames: 'keySize meaningfulCharacters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaByteSequenceIndexDefinition commentStamp: 'cmm 12/25/2004 23:47' prior: 0!
I represent an index that is based on a sequence of bytes to calculate the index-hash value.  I know the number of meaningful characters I can be searched by based on my bit-size.!

MaByteSequenceIndexDefinition subclass: #MaAsciiStringIndexDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaAsciiStringIndexDefinition commentStamp: 'cmm 12/25/2004 23:48' prior: 0!
I search based on an exactly matching sequence of ASCII characters (characters between 0 and 127).!

!MaAsciiStringIndexDefinition methodsFor: 'actions' stamp: ''!
canIndex: anObject

	^(super canIndex: anObject) and: [ (self indexObjectFor: anObject) isString ]
! !

!MaAsciiStringIndexDefinition methodsFor: 'accessing' stamp: 'cmm 2/2/2005 22:03'!
indexHashForIndexObject: aString
	"Answer the index hash value of the receiver, a value
	for a MaHashIndex.  Only ASCII values 0 - 127 are meaningful,
	all others in aString are ignored."

	| answer power |
	aString isString ifFalse: [ MagmaInvalidIndexObject signal: 'Not a valid index object.  Need a String please.' ].
	answer _ 0.
	power _ meaningfulCharacters - 1.
	aString do:
		[ :eachChar |
		(eachChar asciiValue
			between: 0
			and: 127)
				ifTrue:
					[ answer _ answer + (eachChar asciiValue * (self sizeOfCharacterSet raisedTo: power)).
					power _ power - 1.
					power < 0 ifTrue: [ ^answer ] ] ].
	^answer
! !

!MaAsciiStringIndexDefinition methodsFor: 'private accessing' stamp: ''!
sizeOfCharacterSet

	^128
! !

!MaAsciiStringIndexDefinition methodsFor: 'actions' stamp: 'cmm 5/1/2002 23:15'!
validateCanIndex: anObject

	super validateCanIndex: anObject.
	(self indexObjectFor: anObject) isString
		ifFalse:
			[ MagmaUserError signal:
				'Cannot calculate hashIndex value for ' , anObject printString , ' because its ' ,
					attribute , ' does not evaluate to a String.' ]
! !

!MaByteSequenceIndexDefinition methodsFor: 'accessing' stamp: 'cmm 4/10/2005 18:00'!
indexHashForIndexObject: aStringOrByteArray 
	"Answer the index hash value of the receiver, a value for a MaHashIndex."

	| byteArray |
	aStringOrByteArray maOriginalClass isBytes 
		ifFalse: 
			[MagmaInvalidIndexObject 
				signal: 'Not a valid index object.  Need a byte-object please.'].
	byteArray := ByteArray new: keySize * 8.
	byteArray 
		replaceFrom: 1
		to: (byteArray size min: aStringOrByteArray size)
		with: aStringOrByteArray
		startingAt: 1.
	^byteArray maUint: keySize at: 0! !

!MaByteSequenceIndexDefinition methodsFor: 'initialize' stamp: 'cmm 2/22/2004 21:45'!
initialize

	super initialize.
	self keySize: 32! !

!MaByteSequenceIndexDefinition methodsFor: 'accessing' stamp: 'cmm 2/22/2004 21:04'!
keySize

	^keySize! !

!MaByteSequenceIndexDefinition methodsFor: 'initialize' stamp: 'cmm 3/3/2004 16:49'!
keySize: numberOfBits
	"Only set this ONCE, when you create.  It is not changeable after the dictionary is created."

	keySize _ numberOfBits.
	meaningfulCharacters _ ((2 raisedTo: numberOfBits) log: self sizeOfCharacterSet) truncated! !

!MaByteSequenceIndexDefinition methodsFor: 'accessing' stamp: ''!
meaningfulCharacters
	"Answer the number of characters this index will use to index."	

	^meaningfulCharacters
! !

!MaByteSequenceIndexDefinition methodsFor: 'accessing' stamp: 'cmm 3/13/2005 20:02'!
sizeOfCharacterSet

	^ 256! !

MaByteSequenceIndexDefinition subclass: #MaSearchStringIndexDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaSearchStringIndexDefinition commentStamp: 'cmm 12/25/2004 23:50' prior: 0!
I represent an index with just 64 characters of the ascii range utilized; 33 - 96, so we must do without the {, }, |, ~, and space characters.  This increases my number of meaningful characters and eliminates the need for case-sensitive matching.!

MaSearchStringIndexDefinition subclass: #MaKeywordIndexDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaKeywordIndexDefinition commentStamp: 'cmm 12/25/2004 23:50' prior: 0!
I am just like a MaSearchStringIndexDefinition except I index a collection of words.!

!MaKeywordIndexDefinition methodsFor: 'testing' stamp: 'cmm 12/5/2002 17:40'!
canIndex: anObject

	^(super canIndex: anObject) and: [ (self indexObjectFor: anObject) isCollection ]
! !

!MaKeywordIndexDefinition methodsFor: 'accessing' stamp: 'cmm 4/14/2005 15:02'!
indexHashesForIndexObject: aCollectionOfStrings

	^ super indexHashesForIndexObject: aCollectionOfStrings! !

!MaSearchStringIndexDefinition methodsFor: 'private' stamp: 'cmm 12/11/2002 14:18'!
highChar

	^Character value: 96! !

!MaSearchStringIndexDefinition methodsFor: 'private' stamp: 'cmm 2/2/2005 22:04'!
indexHashForIndexObject: aString
	"Answer the index hash value of the receiver, a value
	for a MaHashIndex.  Since string searches are easiest when you don't
	have to worry about case, we only use a 64 ascii character range,
	from 33 to 96.  This means we must do without the {, }, |,
	~, and space characters.  These are at 123-126 and 32.
	Characters outside of this range must be ignored.  This gives
	us an extra 5 meaningful characters on a 128-bit index while also
	providing applications a more convenient search."

	| answer stringIndex conditionedString conditionedStringIndex |
	aString isString ifFalse: [ MagmaInvalidIndexObject signal: 'Invalid index object, need a String.' ].
	conditionedString _ (String new: meaningfulCharacters) atAllPut: self lowChar.
	stringIndex _ 1.
	conditionedStringIndex _ 1.
	"First, load zeroString with conditioned characters from aString."
	[ conditionedStringIndex <= meaningfulCharacters and: [ stringIndex <= aString size ] ]
		whileTrue:
			[ | conditionedChar |
			conditionedChar _ (aString at: stringIndex) asUppercase.
			(conditionedChar asciiValue
				between: self lowChar asciiValue
				and: self highChar asciiValue)
					ifTrue:
						[ conditionedString at: conditionedStringIndex put: conditionedChar.
						conditionedStringIndex _ conditionedStringIndex + 1 ].
			stringIndex _ stringIndex + 1 ].
	"Now compute the hash value."
	answer _ 0.
	conditionedString doWithIndex:
		[ :eachChar :index |
		answer _ answer + ((eachChar asciiValue - self lowChar asciiValue) * (self sizeOfCharacterSet raisedTo: meaningfulCharacters - index)) ].
	^answer! !

!MaSearchStringIndexDefinition methodsFor: 'private' stamp: 'cmm 12/11/2002 14:15'!
lowChar

	^Character value: 33! !

!MaSearchStringIndexDefinition methodsFor: 'private' stamp: 'cmm 2/23/2003 23:20'!
sizeOfCharacterSet
	^self highChar asciiValue - self lowChar asciiValue + 1! !

MaIndexDefinition subclass: #MaDateIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaDateIndex commentStamp: 'cmm 12/25/2004 23:51' prior: 0!
I am a 24-bit index useful for indexing objects by a Date.!

!MaDateIndex methodsFor: 'as yet unclassified' stamp: 'cmm 2/2/2005 22:02'!
indexHashForIndexObject: aDate

	(aDate respondsTo: #asJulianDayNumber)
		ifFalse:
			[ MagmaInvalidIndexObject signal: 'Not a valid date.' ].
	^ aDate asJulianDayNumber! !

!MaDateIndex methodsFor: 'as yet unclassified' stamp: 'cmm 4/8/2004 00:41'!
keySize
"Rationale for 24-bit index:
	Date julianDayNumber: (2 raisedTo: 24) 
(prints 10 May 41222)
Will Squeak still be around then??"

	^ 24! !

MaIndexDefinition subclass: #MaFloatIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MaFloatIndex commentStamp: 'cmm 12/25/2004 23:51' prior: 0!
I am a 32-bit index usefulf or indexing objects by a Float value.!

!MaFloatIndex methodsFor: 'as yet unclassified' stamp: 'cmm 2/2/2005 22:03'!
indexHashForIndexObject: aFloat

	aFloat isFloat ifFalse: [ MagmaInvalidIndexObject signal: 'Not a valid index object.  Need a Float please.' ].
	^aFloat asIEEE32BitWord! !

!MaFloatIndex methodsFor: 'as yet unclassified' stamp: 'cmm 2/22/2004 21:59'!
keySize

	^ 32! !

!MaIndexDefinition class methodsFor: 'creation' stamp: 'cmm 9/26/2004 20:22'!
attribute: aSymbol

	^ super new
		attribute: aSymbol;
		yourself! !

!MaIndexDefinition class methodsFor: 'inappropriate use' stamp: 'cmm 9/26/2004 20:23'!
new

	MagmaUserError signal: 'Should not create indexes with #new.  Use #attribute: instead.'! !

!MaIndexDefinition methodsFor: 'accessing' stamp: ''!
attribute
	"the accessor symbol for any kind of object that has this attribute.
	These are used to determine what whether the receiver is appropriate to restrict
	or sort a Query."

	^attribute
! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaIndexDefinition methodsFor: 'testing' stamp: ''!
canIndex: anObject

	^anObject respondsTo: attribute
! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
highestPossibleKey

	^(2 raisedTo: self keySize) - 1
! !

!MaIndexDefinition methodsFor: 'private' stamp: 'cmm 4/11/2005 16:26'!
indexHashFor: anObject 
	"Answer the Integer hash used to locate anObject."

	self validateCanIndex: anObject.
	^ self indexHashForIndexObject: (self indexObjectFor: anObject)! !

!MaIndexDefinition methodsFor: 'must override' stamp: 'cmm 11/7/2002 23:06'!
indexHashForIndexObject: anObject

	self subclassResponsibility! !

!MaIndexDefinition methodsFor: 'private' stamp: 'cmm 12/5/2002 17:31'!
indexHashesFor: anObject 
	"Answer an Integer or Array of Integers that will be used to locate the receiver."

	self validateCanIndex: anObject.
	^self indexHashesForIndexObject: (self indexObjectFor: anObject)
! !

!MaIndexDefinition methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
indexHashesForIndexObject: anObject 
	^(anObject isCollection and: [anObject maOriginalClass isPointers]) 
		ifTrue: [anObject collect: [:each | self indexHashForIndexObject: each]]
		ifFalse: [Array with: (self indexHashForIndexObject: anObject)]! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
indexObjectFor: anObject

	^anObject perform: attribute
! !

!MaIndexDefinition methodsFor: 'initialize' stamp: 'cmm 3/13/2005 20:30'!
initialize

	super initialize.
	self recordSize: 10  "use a minimal recordSize in case keys have poor density"! !

!MaIndexDefinition methodsFor: 'must override' stamp: 'cmm 2/22/2004 21:47'!
keySize
	"Answer an Integer number of bits, in multiples of 8, that each key value can be."

	self subclassResponsibility! !

!MaIndexDefinition methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self attribute
! !

!MaIndexDefinition methodsFor: 'accessing' stamp: 'cmm 12/10/2002 23:30'!
recordSize

	^recordSize! !

!MaIndexDefinition methodsFor: 'initialize' stamp: 'cmm 2/22/2004 21:37'!
recordSize: anInteger
	"Only set this ONCE, when you create.  It is not changeable after the dictionary is created."

	recordSize _ anInteger! !

!MaIndexDefinition methodsFor: 'debugging' stamp: 'cmm 4/7/2005 23:24'!
sortBlock

	^ [ :a :b | (self indexHashFor: a) < (self indexHashFor: b) ]! !

!MaIndexDefinition methodsFor: 'private' stamp: ''!
uniqueFileIdentifier

	^self attribute
! !

!MaIndexDefinition methodsFor: 'validate' stamp: 'cmm 5/1/2002 23:12'!
validateCanIndex: anObject

	(self canIndex: anObject)
		ifFalse:
			[ MagmaUserError signal:
				'Cannot calculate the hashIndexFor: ' , anObject printString ]
! !

MaObject subclass: #MaRootAnchor
	instanceVariableNames: 'root definition stats'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaRootAnchor commentStamp: 'cmm 2/28/2005 12:47' prior: 0!
This class represents the real root of every repository.  It provides us with a
replaceable root, since the locations of objects can never change.  It also makes
it cleaner to write the root, since all we have to do is write this object using special
code, then we can write the root by simply changing this object.

This class will live on the client and server, since the client can ask for to replace
the root.
!

!MaRootAnchor class methodsFor: 'creation' stamp: ''!
object: anObject

	^self new object: anObject
! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:55'!
definition

	^ definition! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:56'!
definition: aMagmaRepositoryDefinition

	definition _ aMagmaRepositoryDefinition! !

!MaRootAnchor methodsFor: 'initialize-release' stamp: 'cmm 12/29/2004 00:03'!
initialize
	super initialize.
	stats _ OrderedCollection new! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:55'!
root

	^ root! !

!MaRootAnchor methodsFor: 'building' stamp: 'cmm 12/28/2004 23:55'!
root: anObject

	root _ anObject
! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:56'!
stats

	^ stats! !

!MaRootAnchor methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:56'!
stats: aMagmaServerStatistics

	stats _ aMagmaServerStatistics! !

MaObject subclass: #MagmaClientConnection
	instanceVariableNames: 'sessionId userId maximumNumberOfChallengers currentReadStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaClientConnection class methodsFor: 'creation' stamp: 'cmm 6/26/2002 00:21'!
userId: aString sessionId: sessionIdInteger maximumNumberOfChallengers: anInteger

	^self new
		userId: aString;
		sessionId: sessionIdInteger;
		maximumNumberOfChallengers: anInteger
! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 4/28/2003 16:48'!
currentReadStrategy

	^currentReadStrategy! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 4/28/2003 16:48'!
currentReadStrategy: aMaReadStrategy

	currentReadStrategy _ aMaReadStrategy! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
maximumNumberOfChallengers

	^maximumNumberOfChallengers! !

!MagmaClientConnection methodsFor: 'building' stamp: 'cmm 6/26/2002 00:21'!
maximumNumberOfChallengers: anInteger

	maximumNumberOfChallengers _ anInteger
! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
sessionId

	^sessionId! !

!MagmaClientConnection methodsFor: 'private building' stamp: 'cmm 6/26/2002 00:21'!
sessionId: anInteger

	sessionId _ anInteger
! !

!MagmaClientConnection methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:21'!
userId

	^userId! !

!MagmaClientConnection methodsFor: 'private building' stamp: 'cmm 6/26/2002 00:21'!
userId: aString

	userId _ aString
! !

MaObject subclass: #MagmaCollectionReader
	instanceVariableNames: 'collection lowKey highKey readStrategy index segment pageSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MagmaCollectionReader commentStamp: 'cmm 3/21/2005 15:02' prior: 0!
I represent a set of objects contained by a MagmaCollection mapped by a contiguous key range.  Though I am not a Collection, I can be thought of one in terms of reading objects out (I can't add or remove any objects for you, but I can hand you my #collection who'll do it for you).

I am created by sending read:from:to: to a MagmaCollection.  The first object in the collection with the "from" key will be #at:... 1 in me.  My #size is how many objects there are in my collection before you reach the last one with the "to" key.

I am persistable in Magma just like any regular object.  I can be stored as a "pre-defined" query or something.  I'll work just fine after enduring storage and retrieval to a Magma database.!

!MagmaCollectionReader class methodsFor: 'creation' stamp: 'cmm 11/13/2002 23:49'!
collection: aMagmaCollection index: aMaHashIndex lowKey: lowHashKey highKey: highHashKey readStrategy: aMaReadStrategy

	^self new
		collection: aMagmaCollection;
		index: aMaHashIndex;
		lowKey: lowHashKey;
		highKey: highHashKey;
		readStrategy: aMaReadStrategy! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'brp 4/5/2005 12:32'!
abortDo: aBlock

	self isNewCollection ifTrue: [ self errorNotPersistent ].
	self
		slowlyDo: aBlock
		pageBoundariesDo: [ self session abort ]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:58'!
allSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for any element return false.
	Otherwise return true."

	self do: [:each | (aBlock value: each) ifFalse: [^ false]].
	^ true! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 3/21/2005 12:41'!
anyOne

	^ self isLoaded 
		ifTrue: [ segment objects anyOne ]
		ifFalse: [ self at: 1 ]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:58'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!MagmaCollectionReader methodsFor: 'converting' stamp: 'cmm 12/14/2002 17:33'!
asArray: count
	"Answer an Array of up to count elements contained in me."

	| a size |
	a _ Array new: (size _ count min: self size).
	1 to: size do:
		[ :x |
		a at: x put: (self at: x) ].
	^a! !

!MagmaCollectionReader methodsFor: 'converting' stamp: 'cmm 11/16/2004 23:04'!
asSet
	"Answer a Set whose elements are the unique elements of the receiver."

	^ Set withAll: self! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 11/20/2002 00:32'!
at: anInteger

	^self
		at: anInteger
		ifOutOfBounds: [ self error: 'out of bounds' ]! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'brp 4/7/2005 07:45'!
at: indexInteger ifOutOfBounds: aBlock
	"Interrogates the committed and uncommitted contents of the underlying collection."

	^ (self isLoaded and: [ segment includesIndex: indexInteger ])
		ifTrue:
			[ segment at: indexInteger ]
		ifFalse:
			[ self
				loadFromIndex: indexInteger
				pageSize: pageSize.
			(segment includesIndex: indexInteger)
				ifTrue: [ segment at: indexInteger ]
				ifFalse: [ aBlock value ] ]! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 2/22/2004 19:42'!
attribute

	^ index attribute! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 3/21/2005 12:17'!
beStale

	segment _ nil! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:58'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection _ self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/30/2002 23:49'!
collection

	^collection! !

!MagmaCollectionReader methodsFor: 'initialize-release' stamp: 'cmm 4/14/2005 23:08'!
collection: aMagmaCollection

	collection _ aMagmaCollection.
	self setUpListener! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'brp 4/5/2005 12:32'!
commitDo: oneArgBlock

	self isNewCollection ifTrue: [ self errorNotPersistent ].

	self session begin.
	self
		slowlyDo: oneArgBlock
		pageBoundariesDo: [ self session commitAndBegin ].
	self session commit! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:59'!
count: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the number of elements that answered true."

	| sum |
	sum _ 0.
	self do: [:each | (aBlock value: each) ifTrue: [sum _ sum + 1]].
	^ sum! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:00'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [self errorNotFound: aBlock]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:00'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:01'!
detectMax: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the highest magnitude.
	If collection empty, return nil.  This method might also be called elect:."

	| maxElement maxValue val |
	self do: [:each | 
		maxValue == nil
			ifFalse: [
				(val _ aBlock value: each) > maxValue ifTrue: [
					maxElement _ each.
					maxValue _ val]]
			ifTrue: ["first element"
				maxElement _ each.
				maxValue _ aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ maxElement! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:01'!
detectMin: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the lowest number.
	If collection empty, return nil."

	| minElement minValue val |
	self do: [:each | 
		minValue == nil
			ifFalse: [
				(val _ aBlock value: each) < minValue ifTrue: [
					minElement _ each.
					minValue _ val]]
			ifTrue: ["first element"
				minElement _ each.
				minValue _ aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ minElement! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:02'!
difference: aCollection
	"Answer the set theoretic difference of two collections."

	^ self reject: [:each | aCollection includes: each]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'brp 4/5/2005 13:56'!
do: oneArgBlock

	self isNewCollection 
		ifTrue: [ self slowlyDo: oneArgBlock pageBoundariesDo: [] ]
		ifFalse: [ self abortDo: oneArgBlock ]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:00'!
errorNotFound: anObject

	MagmaUserError signal: 'Object is not in the collection.'! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'brp 4/5/2005 10:52'!
errorNotPersistent

	MagmaUserError signal: 'Not supported for non-persistent collections.'
! !

!MagmaCollectionReader methodsFor: 'initialize-release' stamp: 'cmm 3/21/2005 12:58'!
highKey: anInteger

self maMarked: 'dev'.  "I think this next line is unnecessary."
	anInteger = highKey ifFalse: [ self beStale ].
	highKey _ anInteger! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 4/5/2005 15:12'!
ifEmpty: emptyBlock ifNotEmpty: notEmptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise"
	" If the notEmptyBlock has an argument, eval with the receiver as its argument"

	^ self isEmpty ifTrue: emptyBlock ifFalse: [notEmptyBlock valueWithPossibleArgument: self]! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 4/5/2005 15:12'!
ifEmpty: emptyBlock ifNotEmptyDo: notEmptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise"
	"Evaluate the notEmptyBlock with the receiver as its argument"

	^ self isEmpty ifTrue: emptyBlock ifFalse: [notEmptyBlock value: self]! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 4/5/2005 15:13'!
ifNotEmpty: aBlock
	"Evaluate the given block unless the receiver is empty.

      If the block has an argument, eval with the receiver as its argument,
      but it might be better to use ifNotEmptyDo: to make the code easier to
      understand"

	^self isEmpty ifFalse: [aBlock valueWithPossibleArgument: self].
! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 4/5/2005 15:13'!
ifNotEmpty: notEmptyBlock ifEmpty: emptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise
	 If the notEmptyBlock has an argument, eval with the receiver as its argument"

	^ self isEmpty ifFalse: [notEmptyBlock valueWithPossibleArgument: self] ifTrue: emptyBlock! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 4/5/2005 15:13'!
ifNotEmptyDo: aBlock
	"Evaluate the given block with the receiver as its argument."

	^self isEmpty ifFalse: [aBlock value: self].
! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 4/5/2005 15:14'!
ifNotEmptyDo: notEmptyBlock ifEmpty: emptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise
	Evaluate the notEmptyBlock with the receiver as its argument"

	^ self isEmpty ifFalse: [notEmptyBlock value: self] ifTrue: emptyBlock! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 4/5/2005 12:39'!
includes: anObject

	(index canIndex: anObject) ifFalse: [ ^false ].
	(collection includes: anObject) ifFalse: [ ^ false ].
	((index indexHashesFor: anObject) anySatisfy: 
		[ :each | each between: lowKey and: highKey ]) ifFalse: [ ^ false ].
	self do: [ : each | each == anObject ifTrue: [ ^ true ] ].
	^ false! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 7/18/2002 15:44'!
index

	^index! !

!MagmaCollectionReader methodsFor: 'initialize-release' stamp: 'cmm 7/18/2002 15:44'!
index: aMaIndexDefinition

	index _ aMaIndexDefinition
! !

!MagmaCollectionReader methodsFor: 'initialize-release' stamp: 'cmm 3/22/2005 12:40'!
initialize

	super initialize.
	self pageSize: 125! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:03'!
inject: thisValue into: binaryBlock 
	"Accumulate a running value associated with evaluating the argument, 
	binaryBlock, with the current value of the argument, thisValue, and the 
	receiver as block arguments. For instance, to sum the numeric elements 
	of a collection, aCollection inject: 0 into: [:subTotal :next | subTotal + 
	next]."

	| nextValue |
	nextValue _ thisValue.
	self do: [:each | nextValue _ binaryBlock value: nextValue value: each].
	^nextValue! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:03'!
intersection: aCollection
	"Answer the set theoretic intersection of two collections."

	^ self select: [:each | aCollection includes: each]! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'cmm 7/18/2002 15:44'!
isEmpty

	^self size = 0
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 3/21/2005 12:17'!
isLoaded

	^ segment notNil! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 4/5/2005 12:31'!
isNewCollection

	^ collection isNewCollection! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 4/14/2005 13:19'!
lastKnownSize

	self isLoaded ifFalse:
		[ self
			loadFromIndex: 1
			pageSize: 2 "small, since they're only asking for the size." ].
	^ segment lastKnownSize! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 4/15/2005 15:41'!
loadFromIndex: indexInteger pageSize: pageSizeInteger

	| numberOfUncommitted |
	numberOfUncommitted _ self numberOfUncommittedInRange.
	segment _
		collection
			segmentFromKey: lowKey
			to: highKey
			startingAt: ((indexInteger - numberOfUncommitted) max: 1)
			on: index
			pageSize: pageSizeInteger + (numberOfUncommitted*2)
			using: readStrategy! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 3/21/2005 12:58'!
lowKey: anInteger

self maMarked: 'dev'.  "I think this next line is unnecessary."
	anInteger = lowKey ifTrue: [ self beStale ].
	lowKey _ anInteger! !

!MagmaCollectionReader methodsFor: 'ma contextual search' stamp: 'cmm 1/8/2005 18:38'!
maNewSearchContext

	^ MagmaCollectionContext reader: self! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 2/22/2005 12:49'!
maTransientVariables 
	^ super maTransientVariables, #( 'segment' )! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 4/14/2005 23:48'!
maWantsPostMaterialization 
	^ true! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:03'!
noneSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for all elements return true.
	Otherwise return false"

	self do: [:item | (aBlock value: item) ifTrue: [^ false]].
	^ true! !

!MagmaCollectionReader methodsFor: 'testing' stamp: 'brp 11/8/2004 18:42'!
notEmpty

	^ self isEmpty not
! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 4/15/2005 15:30'!
numberOfUncommittedInRange
	"This is used to modify the startingAt: of a page-access.  We slide the page left as many in-range as have been inserted prior to my current first key in the page so we can know whether those uncommitted keys should be merged into the resulting segment.  After sliding over, those uncommitted keys will either be part of the *middle* of the segment or not.  If they are still left of it then we must not merge them (unless the startIndex is 1, in which case we know we are at the beginning and so we can merge them).  Otherwise, if they are left of it but the startIndex is >1, we must not merge them (trim them) because the next-lower key on disk may still be higher than them."

	| count indexPosition |
	count _ 0.
	indexPosition _ collection indexes indexOf: index.
	collection changes additionsDo:
		[ : eachObject : eachHashes |
		count _ count + 
			((eachHashes at: indexPosition) count: 
				[ : each | each between: lowKey and: highKey ]) ].
	^ count! !

!MagmaCollectionReader methodsFor: 'page' stamp: 'cmm 3/21/2005 12:12'!
pageSize
	"The number of object retrieved to memory at a time."

	^ pageSize! !

!MagmaCollectionReader methodsFor: 'page' stamp: 'cmm 3/21/2005 12:13'!
pageSize: anInteger 
	"Tell the receiver to retrieve anInteger number of elements at a time when 'scrolling' to a new part of the collection via at:."

	pageSize _ anInteger! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 11/7/2002 22:57'!
readStrategy

	^readStrategy! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 11/7/2002 22:50'!
readStrategy: aMaReadStrategy

	readStrategy _ aMaReadStrategy! !

!MagmaCollectionReader methodsFor: 'refresh' stamp: 'cmm 11/13/2002 23:34'!
refresh

	self beStale! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 23:03'!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 11/16/2004 22:57'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection _ self species new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 7/18/2002 15:44'!
session

	^collection session
! !

!MagmaCollectionReader methodsFor: 'initialize-release' stamp: 'cmm 4/14/2005 23:09'!
setUpListener

	"Whenever aMagmaCollection changes, we need to remerge its changes in with me."
	collection addDependent: self! !

!MagmaCollectionReader methodsFor: 'accessing' stamp: 'cmm 4/14/2005 13:19'!
size
	"Retrieve the latest-known size from the server, regardless if I'm already loaded."

	self isLoaded
		ifTrue:
			[ self
				loadFromIndex: segment startIndex
				pageSize: 2 ].
	^ self lastKnownSize! !

!MagmaCollectionReader methodsFor: 'enumerating' stamp: 'cmm 3/21/2005 16:49'!
slowlyDo: oneArgBlock pageBoundariesDo: aBlock
	"Approximately enumerate all elements of the receiver.  Doesn't lock the underlying collection."

	| x done stopwatch |
	done _ false.
	x _ 1.
	stopwatch _ MaStopwatch new start.
	[ done ]
		whileFalse:
			[ self
				loadFromIndex: x
				pageSize: 100.
			segment objects do:
				[ :each | oneArgBlock value: each.
				stopwatch time > 5 maSeconds
					ifTrue:
						[ MagmaNotification signal: (x-1) printString, ' objects enumerated.'.	
						stopwatch restart ] ].
			x _ x + segment actualPageSize.
			done _ segment atEnd ]! !

!MagmaCollectionReader methodsFor: 'private' stamp: 'cmm 11/16/2004 22:57'!
species

	^ OrderedCollection! !

!MagmaCollectionReader methodsFor: 'converting' stamp: 'cmm 4/17/2005 22:23'!
update: addedOrRemovedSymbol
	"My collection has had an object added or removed, I will now need to remerge its uncommitted contents into my segment."

	self beStale! !

MaObject subclass: #MagmaCommitConflict
	instanceVariableNames: 'connection conflictingOids conflictingObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MagmaCommitConflict commentStamp: 'cmm 3/21/2003 00:50' prior: 0!
When a MagmaCommitError is signaled, it will have a list of me in it so you can determine the cause of the conflict.  I describe what objects were in conflict (conflictingObjects) and who changed them (connection).

conflictingObjects only reflects what is still in your image (e.g., not GC'd).  conflictingOids contains the oid of every object that was in conflict.!

!MagmaCommitConflict class methodsFor: 'creation' stamp: 'cmm 7/5/2004 14:37'!
connection: aMagmaClientConnection

	^ self new
		connection: aMagmaClientConnection ;
		yourself! !

!MagmaCommitConflict methodsFor: 'private' stamp: 'cmm 6/26/2002 00:00'!
addConflictingOid: oidInteger

	conflictingOids add: oidInteger
! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 7/5/2004 14:40'!
conflictingConnection

	^ connection! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:01'!
conflictingObjects

	^conflictingObjects
! !

!MagmaCommitConflict methodsFor: 'accessing' stamp: 'cmm 6/26/2002 00:01'!
conflictingOids

	^conflictingOids
! !

!MagmaCommitConflict methodsFor: 'initializing' stamp: 'cmm 7/5/2004 14:39'!
connection: aMagmaClientConnection

	connection _ aMagmaClientConnection! !

!MagmaCommitConflict methodsFor: 'initializing' stamp: 'cmm 12/24/2002 15:52'!
initialize
	super initialize.
	conflictingOids := OrderedCollection new! !

!MagmaCommitConflict methodsFor: 'private' stamp: 'cmm 6/26/2002 22:46'!
initializeConflictingObjectsUsing: aMaObjectSerializer

	conflictingObjects _ OrderedCollection new.
	conflictingOids 
		do: 
			[ :each | 
			aMaObjectSerializer 
				objectWithOid: each
				ifFound: [ :foundObj | conflictingObjects add: foundObj ]
				ifAbsent: [ "do nothing" ] ]! !

MaObject subclass: #MagmaEvent
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Events'!

!MagmaEvent class methodsFor: 'as yet unclassified' stamp: 'cmm 2/25/2005 12:51'!
session: aMagmaSession
	^ self new
		session: aMagmaSession ;
		yourself! !

!MagmaEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 14:29'!
session
	"Answer the value of session"

	^ session! !

!MagmaEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 14:29'!
session: anObject
	"Set the value of session"

	session _ anObject! !

MagmaEvent subclass: #MagmaMaterializationEvent
	instanceVariableNames: 'object buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Events'!

!MagmaMaterializationEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 13:59'!
buffer
	"Answer the value of buffer"

	^ buffer! !

!MagmaMaterializationEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 13:59'!
buffer: anObject
	"Set the value of buffer"

	buffer _ anObject! !

!MagmaMaterializationEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 13:59'!
object
	"Answer the value of object"

	^ object! !

!MagmaMaterializationEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 13:59'!
object: anObject
	"Set the value of object"

	object _ anObject! !

MagmaEvent subclass: #MagmaRefreshEvent
	instanceVariableNames: 'object buffer restoreData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Events'!

!MagmaRefreshEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 12:51'!
buffer
	"Answer the value of buffer"

	^ buffer! !

!MagmaRefreshEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 12:51'!
buffer: anObject
	"Set the value of buffer"

	buffer _ anObject! !

!MagmaRefreshEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 13:44'!
hasRestoreData

	^ restoreData notNil! !

!MagmaRefreshEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 12:51'!
object
	"Answer the value of object"

	^ object! !

!MagmaRefreshEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 12:51'!
object: anObject
	"Set the value of object"

	object _ anObject! !

!MagmaRefreshEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 12:51'!
restoreData
	"Answer the value of restoreData"

	^ restoreData! !

!MagmaRefreshEvent methodsFor: 'accessing' stamp: 'cmm 2/25/2005 12:51'!
restoreData: anObject
	"Set the value of restoreData"

	restoreData _ anObject! !

MaObject subclass: #MagmaId
	instanceVariableNames: 'uuid name description contact location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Domain'!

!MagmaId methodsFor: 'testing' stamp: 'cmm 4/10/2005 18:00'!
= aMagmaId 
	self == aMagmaId ifTrue: [^true].
	aMagmaId maOriginalClass = self species ifFalse: [^false].
	^uuid = aMagmaId uuid! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/13/2005 22:34'!
contact
	"If having trouble connecting to this repository."

	^ contact! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/13/2005 22:33'!
contact: aString
	"Specify information on how to contact the person who maintains this repository."

	^ contact! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/13/2005 22:34'!
description
	"About this repository."

	^ description! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/13/2005 22:35'!
description: aString
	"A description of this repository."

	description _ aString! !

!MagmaId methodsFor: 'testing' stamp: 'cmm 1/16/2005 22:24'!
hash

	^ uuid hash! !

!MagmaId methodsFor: 'initialize-release' stamp: 'cmm 1/17/2005 22:31'!
initialize

	uuid _ UUID new.
	name _ uuid asString36! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/17/2005 13:52'!
location
	"The last known location of this repository."

	^ location! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/17/2005 13:52'!
location: aMagmaLocation
	"The last known location of this repository."

	location _ aMagmaLocation! !

!MagmaId methodsFor: 'printing' stamp: 'cmm 1/17/2005 17:42'!
maPrintAbbreviatedOn: aStream

	self maPrintAttribute: #uuid on: aStream! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/13/2005 22:35'!
name
	"How people refer to this repository."

	^ name! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/13/2005 22:36'!
name: aString

	name _ aString! !

!MagmaId methodsFor: 'session' stamp: 'cmm 1/17/2005 17:15'!
session

	^ MagmaSession connectedSessions
		detect: [ : each | each magmaId = self ]
		ifNone: [ location newSession ]! !

!MagmaId methodsFor: 'accessing' stamp: 'cmm 1/13/2005 10:35'!
uuid

	^ uuid! !

MaObject subclass: #MagmaLargeCollection
	instanceVariableNames: 'session changes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Large Collections'!

MagmaLargeCollection subclass: #MagmaArray
	instanceVariableNames: 'segment pageSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Large Collections'!

!MagmaArray commentStamp: 'cmm 4/13/2005 15:21' prior: 0!
I can be used like a normal Array up to ~250,000,000 objects and only consume memory for one "page" at a time (defined by #pageSize).

I do not have to be pre-allocated.  You can use at:put: to any size up to the limit.  Once I grow, I don't shrink though; and size of my supporting file on the server is linearly related to my size.

While not as fast as an in-memory Array, access is quite fast.  Commit-errors are reduced to same-index changes.!

!MagmaArray methodsFor: 'accessing' stamp: 'cmm 4/13/2005 15:18'!
at: anIndex

	^ self
		at: anIndex
		ifAbsent: [ self error: 'index out of range' ]! !

!MagmaArray methodsFor: 'accessing' stamp: 'cmm 4/13/2005 17:48'!
at: anInteger ifAbsent: aBlock

	^ (self isLoaded and: [ segment includesIndex: anInteger ])
		ifTrue:
			[ segment at: anInteger ]
		ifFalse:
			[ changes
				at: anInteger
				ifAbsent:
					[ self isNewCollection
						ifTrue:
							[ anInteger < self size
								ifTrue: [ nil ]
								ifFalse: [ aBlock value ] ]
						ifFalse:
							[ self loadFromIndex: anInteger.
							(segment includesIndex: anInteger)
								ifTrue: [ segment at: anInteger ]
								ifFalse:
									[ anInteger < self size
										ifTrue: [ nil ]
										ifFalse: [ aBlock value ] ] ] ] ]! !

!MagmaArray methodsFor: 'accessing' stamp: 'cmm 3/18/2005 13:21'!
at: anInteger put: anObject

	changes
		add: anObject
		at: anInteger.
	^ anObject! !

!MagmaArray methodsFor: 'do not use' stamp: 'cmm 3/21/2005 12:37'!
includes: anObject
	"This should not be used because, being large and non-indexed, would be a performance drain.  If you need this, you should probably use a regular MagmaCollection."

	self shouldNotImplement! !

!MagmaArray methodsFor: 'initialize' stamp: 'cmm 3/22/2005 12:40'!
initialize

	super initialize.
	self pageSize: 125! !

!MagmaArray methodsFor: 'initialize' stamp: 'cmm 3/17/2005 21:43'!
initializeChanges

	changes _ MagmaArrayChanges collection: self! !

!MagmaArray methodsFor: 'private' stamp: 'cmm 3/21/2005 12:36'!
isLoaded

	^ segment notNil! !

!MagmaArray methodsFor: 'private' stamp: 'cmm 3/21/2005 12:43'!
loadFromIndex: indexInteger

	segment _
		self
			segmentFromIndex: indexInteger
			on: nil
			pageSize: pageSize
			using: session readStrategy! !

!MagmaArray methodsFor: 'private' stamp: 'cmm 3/19/2005 11:25'!
maTransientVariables 
	"Large-collection changes are processed separately in the server, therefore they are stored separately in the commit-package, therefore, we mark them transient."

	^ super maTransientVariables, #( 'segment' )! !

!MagmaArray methodsFor: 'do not use' stamp: 'cmm 3/21/2005 12:38'!
occurrencesOf: anObject
	"This should not be used because, being large and non-indexed, would be a performance drain.  If you need this, you should probably use a regular MagmaCollection."

	self shouldNotImplement! !

!MagmaArray methodsFor: 'accessing' stamp: 'cmm 3/21/2005 12:30'!
pageSize

	^ pageSize! !

!MagmaArray methodsFor: 'accessing' stamp: 'cmm 3/21/2005 12:30'!
pageSize: anInteger

	pageSize _ anInteger! !

!MagmaArray methodsFor: 'accessing' stamp: 'cmm 4/13/2005 12:15'!
size

	^ session isNil
		ifTrue:
			[ changes maxIndex ]
		ifFalse:
			[ (session sizeOfLargeCollection: self) max: changes maxIndex ]! !

!MagmaArray methodsFor: 'accessing' stamp: 'cmm 4/12/2005 17:24'!
species

	^ OrderedCollection! !

MagmaLargeCollection subclass: #MagmaCollection
	instanceVariableNames: 'indexes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MagmaCollection class methodsFor: 'as yet unclassified' stamp: 'cmm 1/9/2005 14:57'!
initialize

	super initialize.
	(Smalltalk hasClassNamed: #MauiRegistry)
		ifTrue:
			[ (Smalltalk at: #MauiRegistry) global
				register: (Smalltalk at: #MauiCollectionMorph)
				forAny: self ]
				! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 4/15/2005 16:17'!
add: anObject

	self validateCanAdd: anObject.
	changes
		add: anObject
		at: (indexes collect: [ :each | each indexHashesFor: anObject ]).
	self changed: #added.
	^ anObject! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 12/7/2004 13:20'!
addIndex: aMaIndexDefinition

	self lock.
	indexes add: aMaIndexDefinition.
	changes addIndex: aMaIndexDefinition! !

!MagmaCollection methodsFor: 'converting' stamp: 'cmm 4/12/2005 12:44'!
asArray: anInteger
	| answer x size |
	answer _ Array new: ((size _ self size) min: anInteger).
	x _ 1.
	self
		maDo: [ : each | answer at: x put: each. x _ x + 1 ]
		while: [ x <= size ].
	^ answer! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 4/6/2005 17:26'!
buildIndexes: aCollection ignoring: objectOidsAlreadyIndexed
	"aCollection of MaIndexDefinitions."

	MagmaNotification signal: 'About to build ', aCollection size printString, ' indexes.'.
	self commitDo:
		[ : each |  | oid |
		oid _ session oidFor: each.
		(MaOidCalculator isOidForNewObject: oid) 
			ifTrue:
				[ MagmaSoftwareError signal: 'expected a persistent object' ].
		(objectOidsAlreadyIndexed includes: oid)
			ifFalse:
				[ aCollection do:
					[ :eachIndex |
					changes
						add: each
						at: (eachIndex indexHashesFor: each)
						toIndexForAttribute: eachIndex attribute ] ] ].
	MagmaNotification signal: 'Indexes built.'! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 7/31/2002 00:15'!
canAdd: anObject

	^self canIndex: anObject! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 2/22/2004 19:21'!
canIndex: anObject

	^indexes allSatisfy: [ :each | each canIndex: anObject ]
! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:44'!
commitUnlock

	[ session commit: [ self unlock ] ]
		on: MagmaCommitError
		do:
			[ :error |
			error messageText:
				error messageText,
				'Abnormal condition.  The enumeration completed, but your session was unable to unlock the collection.  No one can update the collection until it is unlocked.  ' ]! !

!MagmaCollection methodsFor: 'testing' stamp: 'cmm 12/7/2004 13:44'!
includes: anObject

	(changes includesObject: anObject) ifTrue: [ ^true ].
	session isNil ifTrue: [ ^false ].
	^(self occurrencesOf: anObject) > 0! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 2/1/2005 22:49'!
indexNamed: attributeSymbol

	^indexes
		detect: [ :each | each attribute = attributeSymbol ]
		ifNone: [ MagmaUserError signal: attributeSymbol , ' is not an indexed attribute' ]! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 7/18/2002 15:05'!
indexes

	^indexes
! !

!MagmaCollection methodsFor: 'enumerating' stamp: 'cmm 10/1/2004 14:43'!
indexesDo: aBlock

	indexes do: aBlock! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 3/15/2005 23:31'!
initialize
	super initialize.
	indexes _ OrderedCollection new! !

!MagmaCollection methodsFor: 'initializing' stamp: 'cmm 3/17/2005 21:41'!
initializeChanges

	changes _ MagmaCollectionChanges collection: self! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:21'!
lock

	changes setLocked: true! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 12/7/2004 13:44'!
occurrencesOf: anObject

	| newOccurrences |

	newOccurrences _ changes occurrencesOf: anObject.
	(session isNil or:
		[ (session isPersistent: anObject) not or: [ (session isPersistent: self) not ] ])
			ifTrue:
				[ ^newOccurrences ].
	^(session
		occurrencesOf: anObject
		in: self) + newOccurrences
! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 12/11/2002 15:14'!
read: attributeSymbol
	"Answers a MaLargeCollectionReader with access to all of my elements."

	| index |
	index _ self indexNamed: attributeSymbol.
	^self
		readIndex: index
		fromHash: 0
		toHash: index highestPossibleKey! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 12/11/2002 16:30'!
read: attributeSymbol at: key
	"Answers a MaLargeCollectionReader with access to all elements at key."

	^self
		read: attributeSymbol
		from: key
		to: key! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 2/23/2004 00:41'!
read: attributeSymbol from: lowKey
	"Answers a MaLargeCollectionReader with access to all of my elements after lowKey."

	| index |
	index _ self indexNamed: attributeSymbol.
	^self
		readIndex: index
		fromHash: (index indexHashForIndexObject: lowKey)
		toHash: index highestPossibleKey! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 2/23/2004 00:41'!
read: attributeSymbol from: startKey to: endKey
	"Answers a MaLargeCollectionReader with access to all of my elements between startKey and endKey."

	| index |
	index _ self indexNamed: attributeSymbol.
	^self
		readIndex: index
		fromHash: (index indexHashForIndexObject: startKey)
		toHash: (index indexHashForIndexObject: endKey)! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 2/23/2004 00:41'!
read: attributeSymbol to: highKey
	"Answers a MaLargeCollectionReader with access to all of my elements up to highKey."

	| index |
	index _ self indexNamed: attributeSymbol.
	^self
		readIndex: index
		fromHash: 0
		toHash: (index indexHashForIndexObject: highKey)! !

!MagmaCollection methodsFor: 'private' stamp: 'brp 4/5/2005 13:23'!
readIndex: aMaIndexDefinition fromHash: lowHashValue toHash: highHashValue
	"Answers a MaLargeCollectionReader."

	^ MagmaCollectionReader
		collection: self
		index: aMaIndexDefinition
		lowKey: lowHashValue
		highKey: highHashValue
		readStrategy: (session ifNotNil: [ session resetReadStrategy ])! !

!MagmaCollection methodsFor: 'add / remove' stamp: 'cmm 4/15/2005 16:18'!
remove: anObject

	changes
		remove: anObject
		at: (indexes collect: [ :each | each indexHashesFor: anObject ]).
	self changed: #removed.
	^ anObject! !

!MagmaCollection methodsFor: 'indexing' stamp: 'cmm 12/7/2004 13:21'!
removeIndexOn: attributeSymbol

	self lock.
	changes removeIndexOn: attributeSymbol.
	indexes remove: (indexes detect: [ :each | each attribute = attributeSymbol ])! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 4/15/2005 16:28'!
segmentFromKey: lowHashIndexKey to: highHashIndexKey startingAt: indexInteger on: aMaIndexDefinition pageSize: anInteger using: aMaReadStrategy
	"Answer a MaIndexedCollectionSegment."

	^ self isNewCollection
		ifTrue:
			[ changes
				localSegmentFrom: lowHashIndexKey
				to: highHashIndexKey
				on: aMaIndexDefinition ]
		ifFalse: 
			[ | segment |
			segment :=
				session
					upTo: anInteger
					objectsIn: self
					fromKey: lowHashIndexKey
					to: highHashIndexKey
					startingAt: indexInteger
					on: aMaIndexDefinition
					using: aMaReadStrategy.
			changes
				mergeChangesInto: segment
				fromKey: lowHashIndexKey
				to: highHashIndexKey
				on: aMaIndexDefinition.
			segment ]! !

!MagmaCollection methodsFor: 'accessing' stamp: 'cmm 4/13/2005 12:14'!
size

	^ session isNil
		ifTrue:
			[ changes deltaSize ]
		ifFalse:
			[ (session sizeOfLargeCollection: self) + changes deltaSize ]! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 11/16/2004 23:09'!
species

	^ Bag! !

!MagmaCollection methodsFor: 'private' stamp: 'cmm 12/7/2004 13:22'!
unlock

	changes setLocked: false! !

!MagmaCollection methodsFor: 'validating' stamp: 'cmm 2/1/2005 23:48'!
validateCanAdd: anObject

	(self canIndex: anObject) ifFalse: [
		MagmaUserError signal:
			anObject printString , ' cannot be added to ' , self printString ,
			' because it does not support all of the indexable attributes.' ]! !

MagmaCollection subclass: #MagmaSet
	instanceVariableNames: 'equivalenceAttribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-MagmaCollections'!

!MagmaSet commentStamp: 'cmm 2/2/2005 00:09' prior: 0!
Implement simple Set functionality for MagmaCollections.  Further, I am equality rather than identity based.!

!MagmaSet class methodsFor: 'create' stamp: 'cmm 2/2/2005 00:08'!
equivalenceIndex: aMaIndexDefinition

	^ self new
		addIndex: aMaIndexDefinition ;
		equivalenceAttribute: aMaIndexDefinition attribute ;
		yourself! !

!MagmaSet methodsFor: 'add / remove' stamp: 'cmm 2/2/2005 22:06'!
add: anObject

	self validateCanAdd: anObject.
	changes
		add: anObject
		at: (indexes collect: [ :each | each indexHashesFor: anObject ]).
	^ anObject! !

!MagmaSet methodsFor: 'accessing' stamp: 'brp 11/9/2004 15:52'!
equivalenceAttribute

	^ equivalenceAttribute! !

!MagmaSet methodsFor: 'accessing' stamp: 'cmm 4/12/2005 12:25'!
equivalenceAttribute: aSymbol

	(indexes anySatisfy: [ : each | each attribute = aSymbol ])
		ifFalse:
			[ MagmaUserError signal: 'An index on ', aSymbol, ' must be present to set it as your equivalenceAttribute.' ].
	equivalenceAttribute := aSymbol! !

!MagmaSet methodsFor: 'testing' stamp: 'cmm 4/12/2005 12:23'!
includes: anObject

	(changes includesObject: anObject) ifTrue: [ ^ true ].
	self isNewCollection ifTrue: [ ^ false ].
	(anObject respondsTo: equivalenceAttribute) ifFalse: [ ^ false ].
	^ [ (self
			read: equivalenceAttribute
			at: (anObject perform: equivalenceAttribute)) anySatisfy: [ :each | each = anObject ] ]	

			on: MagmaInvalidIndexObject 
			do: [ :error | false ]! !

!MagmaSet methodsFor: 'initializing' stamp: 'cmm 2/2/2005 17:25'!
initializeChanges

	changes _ MagmaSetChanges collection: self
! !

!MagmaSet methodsFor: 'add / remove' stamp: 'cmm 4/12/2005 12:35'!
remove: anObject

	| equivalentObject |
	^ (self includes: anObject)
		ifTrue: 
			[ equivalentObject := self isNewCollection 
				ifTrue: 
					[ changes 
						equivalentObject: anObject
						ifNone: [ MagmaSoftwareError signal: 'expected to find equivalentObject' ] ]
				ifFalse: 
					[ (self 
						read: equivalenceAttribute 
						at: (anObject perform: equivalenceAttribute)) anyOne].
			changes
				remove: equivalentObject
				at: (indexes collect: [ :each | each indexHashesFor: equivalentObject ]) ]
		ifFalse: 
			[ MagmaEquivalentObjectNotInCollection signal: anObject printString , ' is not in ' , self printString ]! !

!MagmaSet methodsFor: 'validating' stamp: 'brp 4/5/2005 12:20'!
validateCanAdd: anObject

	(anObject respondsTo: equivalenceAttribute)
		ifFalse:
			[ MagmaUserError signal:
				anObject printString , ' cannot be added to ' , self printString ,
				' because it does not respond to the equivalence attribute index ' ,
					equivalenceAttribute ].
	(self includes: anObject) 
		ifTrue: [ MagmaDuplicateObjectInCollection signal: 
					anObject printString , ' cannot be added to ' , self printString ]
		ifFalse: [ super validateCanAdd: anObject ]! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'brp 4/5/2005 12:31'!
abortDo: oneArgBlock
	"This method should normally be used for utility scripts."

	self isNewCollection ifTrue: [ self errorNotPersistent ].
	self
		slowlyDo: oneArgBlock
		pageBoundariesDo: [ session abort ]! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:05'!
allSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for any element return false.
	Otherwise return true."

	self do: [:each | (aBlock value: each) ifFalse: [^ false]].
	^ true! !

!MagmaLargeCollection methodsFor: 'accessing' stamp: 'cmm 3/15/2005 23:09'!
anyOne

	^ self detect: [ : each | true ]! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:06'!
anySatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns true for any element return true.
	Otherwise return false."

	self do: [:each | (aBlock value: each) ifTrue: [^ true]].
	^ false! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'cmm 3/17/2005 21:14'!
canIndex: anObject

	^ false! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'cmm 3/17/2005 20:57'!
changes

	^ changes! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:06'!
collect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into a collection like the receiver. Answer  
	the new collection."

	| newCollection |
	newCollection _ self species new.
	self do: [:each | newCollection add: (aBlock value: each)].
	^ newCollection! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'brp 4/5/2005 12:31'!
commitDo: oneArgBlock
	"This method should normally be used for utility scripts."

	self isNewCollection ifTrue: [ self errorNotPersistent ].

	session commit: [ self lock ].
	session begin.
	self
		slowlyDo: oneArgBlock
		pageBoundariesDo: [ session commitAndBegin ].
	session commit.
	self commitUnlock! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:06'!
count: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the number of elements that answered true."

	| sum |
	sum _ 0.
	self do: [:each | (aBlock value: each) ifTrue: [sum _ sum + 1]].
	^ sum! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:06'!
detect: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the first element for which aBlock evaluates to true."

	^ self detect: aBlock ifNone: [self errorNotFound: aBlock]! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:06'!
detect: aBlock ifNone: exceptionBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Answer the first element for which aBlock evaluates to true. If none  
	evaluate to true, then evaluate the argument, exceptionBlock."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:06'!
detectMax: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the highest magnitude.
	If collection empty, return nil.  This method might also be called elect:."

	| maxElement maxValue val |
	self do: [:each | 
		maxValue == nil
			ifFalse: [
				(val _ aBlock value: each) > maxValue ifTrue: [
					maxElement _ each.
					maxValue _ val]]
			ifTrue: ["first element"
				maxElement _ each.
				maxValue _ aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ maxElement! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:06'!
detectMin: aBlock
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Answer the element for which aBlock evaluates to the lowest number.
	If collection empty, return nil."

	| minElement minValue val |
	self do: [:each | 
		minValue == nil
			ifFalse: [
				(val _ aBlock value: each) < minValue ifTrue: [
					minElement _ each.
					minValue _ val]]
			ifTrue: ["first element"
				minElement _ each.
				minValue _ aBlock value: each].
				"Note that there is no way to get the first element that works 
				for all kinds of Collections.  Must test every one."].
	^ minElement! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:07'!
difference: aCollection
	"Answer the set theoretic difference of two collections."

	^ self reject: [:each | aCollection includes: each]! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'brp 4/5/2005 14:05'!
do: oneArgBlock

	self isNewCollection 
		ifTrue: [ self slowlyDo: oneArgBlock pageBoundariesDo: [] ]
		ifFalse: [ self abortDo: oneArgBlock ]! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'cmm 3/15/2005 23:27'!
enumerationPageSize

	^100! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:07'!
errorNotFound: anObject

	MagmaUserError signal: 'Object is not in the collection.'! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'brp 4/5/2005 10:52'!
errorNotPersistent

	MagmaUserError signal: 'Not supported for non-persistent collections.'
! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'cmm 4/12/2005 17:26'!
ifEmpty: aBlock
	"Evaluate the block if I'm empty"

	^ self isEmpty ifTrue: aBlock! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'brp 4/5/2005 15:22'!
ifEmpty: emptyBlock ifNotEmpty: notEmptyBlock
	"Evaluate emptyBlock if I'm empty, notEmptyBlock otherwise"
	" If the notEmptyBlock has an argument, eval with the receiver as its argument"

	^ self isEmpty ifTrue: emptyBlock ifFalse: [notEmptyBlock valueWithPossibleArgument: self]! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'brp 4/5/2005 15:23'!
ifNotEmpty: aBlock
	"Evaluate the given block unless the receiver is empty.

      If the block has an argument, eval with the receiver as its argument,
      but it might be better to use ifNotEmptyDo: to make the code easier to
      understand"

	^self isEmpty ifFalse: [aBlock valueWithPossibleArgument: self].
! !

!MagmaLargeCollection methodsFor: 'indexes' stamp: 'cmm 3/16/2005 13:59'!
indexesDo: aBlock
	"Some large-collections do not require indexes.  Do nothing by default."! !

!MagmaLargeCollection methodsFor: 'initialize' stamp: 'cmm 4/11/2005 14:20'!
initialize

	super initialize.
	self initializeChanges.
	changes beNewCollection! !

!MagmaLargeCollection methodsFor: 'override' stamp: 'cmm 3/17/2005 21:43'!
initializeChanges

	self subclassResponsibility! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:07'!
inject: thisValue into: binaryBlock 
	"Accumulate a running value associated with evaluating the argument, 
	binaryBlock, with the current value of the argument, thisValue, and the 
	receiver as block arguments. For instance, to sum the numeric elements 
	of a collection, aCollection inject: 0 into: [:subTotal :next | subTotal + 
	next]."

	| nextValue |
	nextValue _ thisValue.
	self do: [:each | nextValue _ binaryBlock value: nextValue value: each].
	^nextValue! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:07'!
intersection: aCollection
	"Answer the set theoretic intersection of two collections."

	^ self select: [:each | aCollection includes: each]! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'cmm 3/15/2005 23:12'!
isEmpty

	^self size = 0
! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'brp 4/5/2005 11:23'!
isNewCollection

	^ changes isNewCollection! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'cmm 3/28/2005 16:01'!
maAllowsWriteBarrier 
	"My changes are tracked through the MagmaLargeCollectionChanges mechanism."

	^ false! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:12'!
maDo: aBlock while: conditionBlock

	conditionBlock value ifFalse: [ ^ self ].
	self do:
		[ : each |
		aBlock value: each.
		conditionBlock value ifFalse: [ ^ self ] ]! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'cmm 3/16/2005 12:37'!
maIsLargeCollection

	^ true! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'cmm 3/19/2005 10:16'!
maTransientVariables 
	"Large-collection changes are processed separately in the server, therefore they are stored separately in the commit-package, therefore, we mark them transient."

	^ super maTransientVariables, #( 'session' 'changes' )! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'cmm 3/17/2005 21:29'!
maWantsPostMaterialization
	"Needed to initialize my changes."
	^ true! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:08'!
noneSatisfy: aBlock
	"Evaluate aBlock with the elements of the receiver.
	If aBlock returns false for all elements return true.
	Otherwise return false"

	self do: [:item | (aBlock value: item) ifTrue: [^ false]].
	^ true! !

!MagmaLargeCollection methodsFor: 'testing' stamp: 'cmm 3/15/2005 23:26'!
notEmpty

	^self isEmpty not
! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:08'!
reject: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver only those elements for 
	which aBlock evaluates to false. Answer the new collection."

	^self select: [:element | (aBlock value: element) == false]! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'brp 4/5/2005 14:23'!
segmentFromIndex: startIndex on: aMaIndexDefinition pageSize: anInteger
	"Answer a MaCollectionSegment."

	^self
		segmentFromIndex: startIndex
		on: aMaIndexDefinition
		pageSize: anInteger
		using: (session ifNotNil: [session resetReadStrategy])
! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'brp 4/5/2005 14:10'!
segmentFromIndex: startIndex on: aMaIndexDefinition pageSize: anInteger using: aMaReadStrategy
	"Answer a MaCollectionSegment."

	^ self isNewCollection
		ifTrue: [ changes
					upTo: anInteger
					fromIndex: startIndex
					on: aMaIndexDefinition ]
		ifFalse: [ session
					upTo: anInteger
					objectsIn: self
					fromIndex: startIndex
					on: aMaIndexDefinition
					using: aMaReadStrategy ]
! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 3/15/2005 23:08'!
select: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| newCollection |
	newCollection _ self species new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'cmm 3/15/2005 23:25'!
session

	^ session! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'cmm 3/15/2005 23:25'!
session: aMagmaSession

	session _ aMagmaSession! !

!MagmaLargeCollection methodsFor: 'private' stamp: 'cmm 3/15/2005 23:26'!
setOid: anInteger

	changes collectionOid: anInteger
! !

!MagmaLargeCollection methodsFor: 'accessing' stamp: 'cmm 4/13/2005 12:14'!
size
	self subclassResponsibility! !

!MagmaLargeCollection methodsFor: 'enumerating (slow)' stamp: 'cmm 4/12/2005 12:47'!
slowlyDo: oneArgBlock pageBoundariesDo: aBlock
	"Unlike other slowlyDo: methods, this method does not lock me, so while you can get a large 'sampling', if the collection is changed while I'm enumerating, there's no guarantee you'll reach every element."

	| segment done index stopwatch |
	done _ false.
	index _ 1.
	stopwatch _ MaStopwatch new start.
	changes additionsDo: [ : eachObject : eachHashes | oneArgBlock value: eachObject ].
	[ done ]
		whileFalse:
			[ segment _
				self
					segmentFromIndex: index
					on: nil
					pageSize: self enumerationPageSize.
			segment objects do:
				[ :each |
				oneArgBlock value: each.
				stopwatch time > 5 maSeconds
					ifTrue:
						[ MagmaNotification signal: (index-1) printString, ' objects enumerated.'.
						stopwatch restart ] ].
			index _ index + segment actualPageSize.
			done _ segment atEnd ]! !

MaObject subclass: #MagmaLargeCollectionChanges
	instanceVariableNames: 'collectionOid changes isNewCollection collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

MagmaLargeCollectionChanges subclass: #MagmaArrayChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaArrayChanges methodsFor: 'overriding' stamp: 'cmm 3/18/2005 13:30'!
add: anObject at: indexOrKey

	self added
		at: indexOrKey
		put: anObject! !

!MagmaArrayChanges methodsFor: 'overriding' stamp: 'cmm 3/18/2005 14:02'!
addNewAdditionsTo: aMaCommitPackage using: aMagmaSession

	self additionsDo:
		[ : eachIndex : eachObject |
		(aMagmaSession isPersistent: eachObject) ifFalse: [ aMaCommitPackage addObject: eachObject ] ]! !

!MagmaArrayChanges methodsFor: 'overriding' stamp: 'cmm 3/24/2005 17:36'!
at: anIndex ifAbsent: aBlock

	self hasAdditions ifFalse: [ ^ aBlock value ].
	^ self added
		at: anIndex
		ifAbsent: aBlock! !

!MagmaArrayChanges methodsFor: 'testing' stamp: 'cmm 3/20/2005 20:57'!
isForMagmaArray
	^ true! !

!MagmaArrayChanges methodsFor: 'overriding' stamp: 'cmm 4/13/2005 12:13'!
maxIndex

	^ self hasAdditions
		ifTrue: [ self added keys max ]
		ifFalse: [ 0 ]! !

!MagmaArrayChanges methodsFor: 'serializing' stamp: 'cmm 3/18/2005 13:47'!
serializeAddedUsing: aMaObjectSerializer

	| added |
	self hasAdditions ifFalse: [ ^self ].
	(added _ self added) keysAndValuesDo: 
		[ : eachIndex : eachObject |
		added
			at: eachIndex
			put: (aMaObjectSerializer oidFor: eachObject) ]! !

MagmaLargeCollectionChanges subclass: #MagmaCollectionChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaCollectionChanges commentStamp: '<historical>' prior: 0!
This is a private class.  Applications should have no need to use this class directly.
!

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 3/16/2005 11:32'!
add: anObject at: hashIndexValuesOrArrayIndex

	| removed |

	((removed _ self removed) includesKey: anObject)
		ifTrue:
			[ removed removeKey: anObject ]
		ifFalse:
			[ self added
				at: anObject
				put: hashIndexValuesOrArrayIndex ]
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 12/9/2002 20:19'!
add: anObject at: indexHashValues toIndexForAttribute: aSymbol

	(self newIndexValues
		at: aSymbol
		ifAbsentPut: [ OrderedCollection new ])
			add: (
				Association
					key: indexHashValues
					value: anObject)! !

!MagmaCollectionChanges methodsFor: 'building' stamp: ''!
addIndex: aMaIndexDefinition

	self hasRemovedIndexes
		ifTrue:
			[ (self removedIndexes includes: aMaIndexDefinition attribute)
				ifTrue:
					[ self removedIndexes remove: aMaIndexDefinition attribute ]
				ifFalse:
					[ self addedIndexes add: aMaIndexDefinition ] ]
		ifFalse:
			[ self addedIndexes add: aMaIndexDefinition ].
	self appendIndexValuesFor: aMaIndexDefinition
! !

!MagmaCollectionChanges methodsFor: 'overriding' stamp: 'cmm 3/18/2005 14:01'!
addNewAdditionsTo: aMaCommitPackage using: aMagmaSession

	self additionsDo:
		[ :eachObject :eachHashIndexValues |
		(aMagmaSession isPersistent: eachObject) ifFalse: [ aMaCommitPackage addObject: eachObject ] ]! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: ''!
addedIndexes

	^changes
		at: #addedIndexes
		ifAbsentPut: [ OrderedCollection new ]
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
addedIndexesDo: oneArgBlock

	self hasAddedIndexes ifFalse: [ ^self ].
	self addedIndexes do: oneArgBlock
! !

!MagmaCollectionChanges methodsFor: 'private' stamp: 'cmm 12/9/2002 20:21'!
appendIndexValuesFor: aMaIndexDefinition
	"An index has been added.  Since the server processes all added and removed indexes prior to all added and removed objects, we need to make sure additions and removals have hash-index values for all indexes."

	self additionsDo:
		[ :eachObject :eachCollection |
		eachCollection add: (aMaIndexDefinition indexHashesFor: eachObject) ].
	self removedDo:
		[ :eachObject :eachCollection |
		eachCollection add: (aMaIndexDefinition indexHashesFor: eachObject) ]! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
changedKeySpecificationsDo: oneArgBlock

	self hasChangedKeys ifFalse: [ ^self ].
	self changedKeys do: oneArgBlock
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 11/15/2002 10:49'!
changedKeys
	"answer an OrderedCollection of MaChangedKeySpecification's."

	^changes
		at: #changedKeys
		ifAbsentPut: [ OrderedCollection new ]! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: ''!
deltaSize

	| numberAdded numberRemoved |

	numberAdded _ 0.
	self additionsDo: [ :eachObject :eachHashIndexValues | numberAdded _ numberAdded + 1 ].
	numberRemoved _ 0.
	self removedDo: [ :eachObject :eachHashIndexValues | numberRemoved _ numberRemoved + 1 ].
	^numberAdded - numberRemoved
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasAddedIndexes

	^(changes includesKey: #addedIndexes) and: [ self addedIndexes notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasChangedKeys

	^(changes includesKey: #changedKeys) and: [ self changedKeys notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 3/17/2005 22:01'!
hasChanges

	^ super hasChanges
		or: [ self hasChangedKeys
		or: [ self hasLockSpecified
		or: [ self hasAddedIndexes
		or: [ self hasNewIndexValues
		or: [ self hasRemoved
		or: [ self hasRemovedIndexes ] ] ] ] ] ]! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 8/21/2002 16:44'!
hasLockSpecified

	^changes includesKey: #lock! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 8/22/2002 14:00'!
hasNewIndexValues

	^changes includesKey: #newIndexValues! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasRemoved

	^(changes includesKey: #removed) and: [ self removed notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: ''!
hasRemovedIndexes

	^(changes includesKey: #removedIndexes) and: [ self removedIndexes notEmpty ]
! !

!MagmaCollectionChanges methodsFor: 'testing' stamp: 'cmm 10/27/2002 21:34'!
isLocked

	^(changes includesKey: #lock) and: [ changes at: #lock ]! !

!MagmaCollectionChanges methodsFor: 'private' stamp: 'cmm 2/22/2005 12:48'!
maTransientVariables 
	^ super maTransientVariables, #( 'collection' )! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 12/7/2002 12:18'!
move: anObject from: oldHashValues to: newHashValues forIndexedAttribute: aSymbol

	self changedKeys
		add: (
			MaChangedKeySpecification
				object: anObject
				attribute: aSymbol
				oldHashValues: oldHashValues
				newHashValues: newHashValues)! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 4/21/2002 23:10'!
newIndexValues
	"A dictionary of Dictionarys, (attribute Symbol -> (key->oid)...) used to
	populate all new indexes being built in this transaction."

	^changes
		at: #newIndexValues
		ifAbsentPut: [ Dictionary new ]
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
newIndexValuesDo: aBlock

	self hasNewIndexValues ifFalse: [ ^self ].
	self newIndexValues do: aBlock
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: ''!
occurrencesOf: anObject

	| numberAdded numberRemoved |

	numberAdded _ 0.
	self additionsDo:
		[ :eachObject :eachHashIndexValues |
		eachObject = anObject ifTrue: [ numberAdded _ numberAdded + 1 ] ].
	numberRemoved _ 0.
	self removedDo:
		[ :eachObject :eachHashIndexValues |
		eachObject = anObject ifTrue: [ numberRemoved _ numberRemoved + 1 ] ].
	^numberAdded - numberRemoved
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: ''!
remove: anObject at: hashIndexesCollection

	| added |

	((added _ self added) includesKey: anObject)
		ifTrue:
			[ added removeKey: anObject ]
		ifFalse:
			[ self removed
				at: anObject
				put: hashIndexesCollection ]
! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 12/7/2004 13:47'!
removeIndexOn: attributeSymbol

	self removeIndexValuesFor: (collection indexNamed: attributeSymbol).
	(self hasAddedIndexes
		and: [ self addedIndexes anySatisfy: [ :each | each attribute = attributeSymbol ] ])
			ifTrue:
				[ self addedIndexes
					remove: (self addedIndexes 
						detect: [ :each | each attribute = attributeSymbol ]
						ifNone: [ MagmaSoftwareError signal: 'Apparent bug in MaLargeCollectionChanges>>removeIndexOn:' ]) ]
			ifFalse:
				[ self removedIndexes add: attributeSymbol ]
! !

!MagmaCollectionChanges methodsFor: 'private' stamp: 'cmm 12/7/2004 13:47'!
removeIndexValuesFor: aMaIndexDefinition
	"An index is being removed.  We need to make sure we remove
	the hash index values to the objects that have already been added or
	removed from the receiver."

	| position |

	position _ collection indexes indexOf: aMaIndexDefinition.
	self additionsDo: [ :eachObject :eachCollection | eachCollection removeAt: position ].
	self removedDo: [ :eachObject :eachCollection | eachCollection removeAt: position ]
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: 'cmm 2/1/2005 23:35'!
removed
	"Answer the dictionary of objects that have been removed in the local client, but not yet committed to the repository."

	^ changes
		at: #removed
		ifAbsentPut: [ IdentityDictionary new ]! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
removedDo: twoArgBlock
	"The first argument is each object that has been added during the current
	transaction, the second is a collection of hash-index values for each index."

	self hasRemoved ifFalse: [ ^self ].
	self removed keysAndValuesDo: twoArgBlock
! !

!MagmaCollectionChanges methodsFor: 'accessing' stamp: ''!
removedIndexes

	^changes
		at: #removedIndexes
		ifAbsentPut: [ OrderedCollection new ]
! !

!MagmaCollectionChanges methodsFor: 'actions' stamp: ''!
removedIndexesDo: oneArgBlock

	self hasRemovedIndexes ifFalse: [ ^self ].
	self removedIndexes do: oneArgBlock
! !

!MagmaCollectionChanges methodsFor: 'serializing' stamp: 'cmm 3/18/2005 13:42'!
serializeAddedUsing: aMaObjectSerializer

	| added |

	self hasAdditions ifFalse: [ ^self ].
	(added _ self added) copy keysAndValuesDo:
		[ :eachObject :eachHashIndexValues |
		added
			at: (aMaObjectSerializer oidFor: eachObject)
			put: eachHashIndexValues;
			removeKey: eachObject ]! !

!MagmaCollectionChanges methodsFor: 'serializing' stamp: 'cmm 11/19/2002 22:39'!
serializeChangedIndexValuesUsing: aMaObjectSerializer

	self changedKeySpecificationsDo: [ :eachSpec | eachSpec serializeUsing: aMaObjectSerializer ]! !

!MagmaCollectionChanges methodsFor: 'serializing' stamp: ''!
serializeNewIndexValuesUsing: aMaObjectSerializer

	self newIndexValuesDo:
		[ :eachValues |
		eachValues do:
			[ :eachAssociation |
			eachAssociation value: (aMaObjectSerializer oidFor: eachAssociation value) ] ]
! !

!MagmaCollectionChanges methodsFor: 'serializing' stamp: ''!
serializeRemovedUsing: aMaObjectSerializer

	| removed |

	self hasRemoved ifFalse: [ ^self ].
	(removed _ self removed) copy keysAndValuesDo:
		[ :eachObject :eachHashIndexValues |
		removed
			at: (aMaObjectSerializer oidFor: eachObject)
			put: eachHashIndexValues;
			removeKey: eachObject ]
! !

!MagmaCollectionChanges methodsFor: 'serializing' stamp: 'cmm 3/17/2005 22:05'!
serializeUsing: aMaObjectSerializer

	super serializeUsing: aMaObjectSerializer.
	self
		serializeRemovedUsing: aMaObjectSerializer ;
		serializeNewIndexValuesUsing: aMaObjectSerializer ;
		serializeChangedIndexValuesUsing: aMaObjectSerializer! !

!MagmaCollectionChanges methodsFor: 'building' stamp: 'cmm 8/22/2002 12:16'!
setLocked: aBoolean

	self hasLockSpecified
		ifTrue:
			[ self isLocked ~= aBoolean
				ifTrue:
					[ changes removeKey: #lock ] ]
		ifFalse:
			[ changes
				at: #lock
				put: aBoolean ]! !

MagmaCollectionChanges subclass: #MagmaSetChanges
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaSetChanges methodsFor: 'building' stamp: 'brp 4/5/2005 12:18'!
equivalentObject: anObject
	"Find an equivalent object in the added dictionary"

	self hasAdditions
		ifTrue: [ self added keysDo: [ :k | k = anObject ifTrue: [^k] ] ].
	^ nil
! !

!MagmaSetChanges methodsFor: 'building' stamp: 'cmm 4/12/2005 12:34'!
equivalentObject: anObject ifNone: aBlock
	"Find an equivalent object in the added dictionary"

	self additionsDo:
		[ : eachObject : eachHashes |
		anObject = eachObject ifTrue: [ ^ eachObject ] ].
	^ aBlock value! !

!MagmaSetChanges methodsFor: 'testing' stamp: 'cmm 4/12/2005 12:34'!
includesObject: anObject

	self
		equivalentObject: anObject
		ifNone: [ ^ false ].
	^ true! !

!MagmaLargeCollectionChanges class methodsFor: 'as yet unclassified' stamp: 'cmm 3/17/2005 21:42'!
collection: aMagmaCollection

	^self new collection: aMagmaCollection
! !

!MagmaLargeCollectionChanges methodsFor: 'override' stamp: 'cmm 3/18/2005 13:29'!
add: anObject at: indexOrKey

	self subclassResponsibility! !

!MagmaLargeCollectionChanges methodsFor: 'override' stamp: 'cmm 3/18/2005 14:00'!
addNewAdditionsTo: aMaCommitPackage using: aMagmaSession

	self subclassResponsibility! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:54'!
added
	"On the client, answers an IdentityDictionary whose key is the object to be added, value is a collection of its calculated hashIndex values.  On the server, the key is the oid of the object, not the object itself."

	^ changes
		at: #added
		ifAbsentPut: [ IdentityDictionary new ]! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:54'!
additionsDo: twoArgBlock
	"The first argument is each object that has been added during the current
	transaction, the second is a collection of hash-index values for each index."

	self hasAdditions ifFalse: [ ^self ].
	self added keysAndValuesDo: twoArgBlock
! !

!MagmaLargeCollectionChanges methodsFor: 'initialize-release' stamp: 'cmm 3/16/2005 14:54'!
beNewCollection

	isNewCollection _ true
! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:54'!
changes: aDictionary

	changes _ aDictionary
! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:54'!
collection

	^ collection! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:55'!
collection: aMagmaLargeCollection

	collection _ aMagmaLargeCollection! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:55'!
collectionOid

	^collectionOid
! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:55'!
collectionOid: anInteger

	collectionOid _ anInteger
! !

!MagmaLargeCollectionChanges methodsFor: 'copying' stamp: 'cmm 3/28/2005 22:30'!
copyForSerialization

	| newChanges |

	newChanges _ changes species new.
	changes keysAndValuesDo:
		[ :eachKey :eachValue |
		newChanges
			at: eachKey
			put: eachValue copy ].
	^self copy changes: newChanges
! !

!MagmaLargeCollectionChanges methodsFor: 'testing' stamp: 'cmm 3/17/2005 23:10'!
hasAddedIndexes

	^ false! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 14:56'!
hasAdditions

	^(changes includesKey: #added) and: [ self added notEmpty ]
! !

!MagmaLargeCollectionChanges methodsFor: 'testing' stamp: 'cmm 3/17/2005 22:01'!
hasChanges

	^ self isNewCollection or: [ self hasAdditions ]! !

!MagmaLargeCollectionChanges methodsFor: 'testing' stamp: 'brp 4/6/2005 20:50'!
hasRemoved

	^ false! !

!MagmaLargeCollectionChanges methodsFor: 'testing' stamp: 'cmm 3/18/2005 11:02'!
hasRemovedIndexes

	^ false! !

!MagmaLargeCollectionChanges methodsFor: 'testing' stamp: 'cmm 3/16/2005 14:56'!
includesObject: anObject

	^self hasAdditions ifTrue: [ self added includesKey: anObject ] ifFalse: [ false ]
! !

!MagmaLargeCollectionChanges methodsFor: 'initialize-release' stamp: 'cmm 3/17/2005 21:48'!
initialize
	super initialize.
	self reset! !

!MagmaLargeCollectionChanges methodsFor: 'testing' stamp: 'cmm 3/20/2005 20:57'!
isForMagmaArray
	^ false! !

!MagmaLargeCollectionChanges methodsFor: 'testing' stamp: 'cmm 3/16/2005 15:10'!
isNewCollection

	^isNewCollection
! !

!MagmaLargeCollectionChanges methodsFor: 'reading' stamp: 'cmm 4/17/2005 23:24'!
localSegmentFrom: lowKey to: highKey on: aMaIndexDefinition
	"Populate a segment from the uncommitted changes. This method is only invoked for
	new, uncommitted collections."

	| indexPosition matching |
	indexPosition := collection indexes indexOf: aMaIndexDefinition.
	matching := SortedCollection sortBlock: [ :a :b | a key < b key ].
	self additionsDo:
		[ : object : hashes |
		(hashes at: indexPosition) do:
			[ : eachHash |
			(eachHash between: lowKey and: highKey) 
				ifTrue:
					[ matching add: eachHash -> object ] ] ].
	^ MagmaLargeCollectionSegment new
		lastKnownSize: matching size ;
		keys: (matching collect: [ : each | each key ]) ;
		objects: (matching collect: [ : each | each value ]) ;
		startIndex: 1 ;
		yourself! !

!MagmaLargeCollectionChanges methodsFor: 'initialize-release' stamp: 'cmm 3/16/2005 15:11'!
maTransientVariables 
	^ super maTransientVariables, #( 'collection' )! !

!MagmaLargeCollectionChanges methodsFor: 'reading' stamp: 'cmm 4/18/2005 11:40'!
mergeAdditionsInto: aMagmaLargeCollectionSegment fromKey: lowKey to: highKey on: aMaIndexDefinition

	| integratedObjects nonMembers indexPosition |
	self hasAdditions ifFalse: [ ^ self ].
	integratedObjects := SortedCollection sortBlock: [ : a : b | a key < b key ].
	nonMembers _ IdentityBag new: self added size.
	indexPosition _ collection indexes indexOf: aMaIndexDefinition.
	self additionsDo:
		[ : object : hashes |
		(hashes at: indexPosition) do:
			[ : eachHash | 
			(eachHash between: lowKey and: highKey)
				ifTrue:
					[ integratedObjects add: eachHash -> object.
					nonMembers add: object ] ] ].
	nonMembers ifNotEmpty:
		[ aMagmaLargeCollectionSegment keys
			with: aMagmaLargeCollectionSegment objects
			do: [ : eachKey : eachObject | integratedObjects add: eachKey -> eachObject ].
		aMagmaLargeCollectionSegment
			keys: (integratedObjects collect: [ : each | each key ]) ;
			objects: (integratedObjects collect: [ : each | each value ]).
		self 
			trimNonMembers: nonMembers
			from: aMagmaLargeCollectionSegment.
		aMagmaLargeCollectionSegment lastKnownSize: aMagmaLargeCollectionSegment lastKnownSize + nonMembers size ]! !

!MagmaLargeCollectionChanges methodsFor: 'reading' stamp: 'cmm 4/18/2005 12:51'!
mergeChangesInto: aMagmaLargeCollectionSegment fromKey: lowKey to: highKey on: aMaIndexDefinition
	"Merge my changes into the segment just returned from the server."

	self
		mergeAdditionsInto: aMagmaLargeCollectionSegment
		fromKey: lowKey
		to: highKey
		on: aMaIndexDefinition.
	self
		mergeRemovalsInto: aMagmaLargeCollectionSegment
		fromKey: lowKey
		to: highKey
		on: aMaIndexDefinition! !

!MagmaLargeCollectionChanges methodsFor: 'reading' stamp: 'cmm 4/18/2005 12:55'!
mergeRemovalsInto: aMagmaLargeCollectionSegment fromKey: lowKey to: highKey on: aMaIndexDefinition

	self hasRemoved ifTrue:
		[ | removedMembers indexPosition |
		removedMembers _ 0.
		indexPosition _ collection indexes indexOf: aMaIndexDefinition.
		self removedDo:
			[ : each : eachHashes |
			(eachHashes at: indexPosition) do:
				[ : eachHash |
				(eachHash between: lowKey and: highKey) 
					ifTrue: 
						[ removedMembers _ removedMembers + 1.
						aMagmaLargeCollectionSegment
							removeObject: each
							at: eachHash ] ] ].
		aMagmaLargeCollectionSegment lastKnownSize: aMagmaLargeCollectionSegment lastKnownSize - removedMembers ]! !

!MagmaLargeCollectionChanges methodsFor: 'actions' stamp: 'brp 4/6/2005 21:18'!
removedDo: twoArgBlock
	"The base class does not support removals, so do nothing."
! !

!MagmaLargeCollectionChanges methodsFor: 'accessing' stamp: 'cmm 3/16/2005 15:11'!
reset

	changes _ Dictionary new.
	isNewCollection _ false! !

!MagmaLargeCollectionChanges methodsFor: 'serializing' stamp: 'cmm 3/18/2005 13:42'!
serializeAddedUsing: aMaObjectSerializer

	self subclassResponsibility! !

!MagmaLargeCollectionChanges methodsFor: 'serializing' stamp: 'cmm 3/17/2005 22:04'!
serializeUsing: aMaObjectSerializer

	self serializeAddedUsing: aMaObjectSerializer! !

!MagmaLargeCollectionChanges methodsFor: 'private' stamp: 'cmm 4/17/2005 23:25'!
trimNonMembers: uncommittedSet from: aMagmaLargeCollectionSegment
	"When you have added uncommitteds and they are merged in, you then do at: n where n is the last element in the segment and that element is an uncommitted, it doesn't know that you've exceeded the boundaries of the disk-portion and, therefore, answers the uncommitted instead of one that could occur *before* that one that resides on disk.  My solution is to trim both ends of the segment of non-committeds, we only merge in the *middle* of our committeds, that way we're not blind to what's in the collection on disk."

	[ aMagmaLargeCollectionSegment isEmpty 
	or: [ aMagmaLargeCollectionSegment startIndex = 1
	or: [ uncommittedSet includes: aMagmaLargeCollectionSegment objects first ] ] ]
		whileFalse:
			[ aMagmaLargeCollectionSegment objects removeFirst.
			aMagmaLargeCollectionSegment incrementStartIndex ].
	[ aMagmaLargeCollectionSegment isEmpty 
	or: [ aMagmaLargeCollectionSegment atEnd
	or: [ uncommittedSet includes: aMagmaLargeCollectionSegment objects last ] ] ]
		whileFalse:
			[ aMagmaLargeCollectionSegment objects removeLast ]! !

!MagmaLargeCollectionChanges methodsFor: 'reading' stamp: 'cmm 4/15/2005 16:36'!
upTo: anInteger fromIndex: startIndex on: aMaIndexDefinition
	"Populate a segment from the uncommitted changes. This method is only invoked for
	new, uncommitted collections."

	| index |
	index := aMaIndexDefinition ifNil: [collection indexes first].
	^ self
		localSegmentFrom: 0
		to: MaOidCalculator highestPossibleOid
		on: index! !

MaObject subclass: #MagmaLocation
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Domain'!

!MagmaLocation commentStamp: 'cmm 1/13/2005 10:43' prior: 0!
I provide an objectified link to a Magma repository, local or remote, to use when you don't want to bother with its location details.!

MagmaLocation subclass: #MagmaLocalLocation
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Domain'!

!MagmaLocalLocation class methodsFor: 'create' stamp: 'cmm 9/24/2004 15:44'!
path: aString

	^ self new
		path: aString ; 
		yourself! !

!MagmaLocalLocation methodsFor: 'testing' stamp: 'cmm 4/10/2005 18:00'!
= aMagmaLocalLocation 
	aMagmaLocalLocation maOriginalClass = self species ifFalse: [^false].
	^aMagmaLocalLocation path = self path! !

!MagmaLocalLocation methodsFor: 'testing' stamp: 'cmm 2/15/2005 13:00'!
hash

	^ self path hash! !

!MagmaLocalLocation methodsFor: 'testing' stamp: 'cmm 9/23/2004 14:41'!
isLocal

	^ true! !

!MagmaLocalLocation methodsFor: 'accessing' stamp: 'cmm 2/24/2005 12:06'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: path! !

!MagmaLocalLocation methodsFor: 'actions' stamp: 'cmm 1/17/2005 17:12'!
newSession
	"For local, we have to determine whether the files are already in-use by another local-connection.  If they are, create a new session sharing the originals repositoryController, otherwise open the files."

	^ MagmaSession connectedSessions
		maDetect: [ : each | each pathName = path ]
		ifFound: [ : foundSession | MagmaSession repositoryController: foundSession repositoryController ]
		ifNone: [ MagmaSession openLocal: path ]! !

!MagmaLocalLocation methodsFor: 'accessing' stamp: 'cmm 9/24/2004 12:28'!
path

	^ path! !

!MagmaLocalLocation methodsFor: 'accessing' stamp: 'cmm 9/24/2004 12:28'!
path: aString

	path _ aString! !

!MagmaLocation methodsFor: 'accessing' stamp: 'cmm 10/24/2004 23:30'!
description

	^ String streamContents: [ : stream | self maPrintAbbreviatedOn: stream ]! !

!MagmaLocation methodsFor: 'testing' stamp: 'cmm 9/23/2004 14:41'!
isLocal

	^ false! !

!MagmaLocation methodsFor: 'accessing' stamp: 'cmm 9/15/2004 21:55'!
name

	^ name! !

!MagmaLocation methodsFor: 'accessing' stamp: 'cmm 9/15/2004 21:55'!
name: anObject
	"Set the value of name"

	name _ anObject! !

!MagmaLocation methodsFor: 'actions' stamp: 'cmm 1/13/2005 22:43'!
newSession

	self subclassResponsibility! !

MagmaLocation subclass: #MagmaRemoteLocation
	instanceVariableNames: 'hostAddress port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Domain'!

!MagmaRemoteLocation class methodsFor: 'create' stamp: 'cmm 10/27/2004 12:24'!
host: hostName port: portInteger

	^ self
		hostAddress: (NetNameResolver addressForName: hostName)
		port: portInteger! !

!MagmaRemoteLocation class methodsFor: 'create' stamp: 'cmm 9/23/2004 15:26'!
hostAddress: aByteArray port: portInteger

	^ self new
		hostAddress: aByteArray ;
		port: portInteger ;
		yourself! !

!MagmaRemoteLocation methodsFor: 'testing' stamp: 'cmm 4/10/2005 18:00'!
= aMagmaRemoteLocation 
	aMagmaRemoteLocation maOriginalClass = self species ifFalse: [^false].
	^self port = aMagmaRemoteLocation port 
		and: [self hostAddress = aMagmaRemoteLocation hostAddress]! !

!MagmaRemoteLocation methodsFor: 'testing' stamp: 'cmm 2/15/2005 13:02'!
hash

	^ self hostAddress hash bitXor: self port hash! !

!MagmaRemoteLocation methodsFor: 'accessing' stamp: 'cmm 9/23/2004 14:26'!
hostAddress
	"Answer the value of hostAddress"

	^ hostAddress! !

!MagmaRemoteLocation methodsFor: 'accessing' stamp: 'cmm 9/23/2004 14:26'!
hostAddress: anObject
	"Set the value of hostAddress"

	hostAddress _ anObject! !

!MagmaRemoteLocation methodsFor: 'printing' stamp: 'cmm 3/14/2005 00:13'!
maPrintAbbreviatedOn: aStream

	aStream
		nextPutAll: 'address: ' ;
		"do NOT put a cr in here, it exposes Monitcello bug.."
		maPrint: hostAddress ;
		space ;
		nextPutAll: 'port: ' ;
		maPrint: port! !

!MagmaRemoteLocation methodsFor: 'actions' stamp: 'cmm 1/13/2005 22:44'!
newSession

	^ MagmaSession
		hostAddress: hostAddress
		port: port! !

!MagmaRemoteLocation methodsFor: 'accessing' stamp: 'cmm 9/23/2004 14:26'!
port
	"Answer the value of port"

	^ port! !

!MagmaRemoteLocation methodsFor: 'accessing' stamp: 'cmm 9/23/2004 14:26'!
port: anObject
	"Set the value of port"

	port _ anObject! !

MaObject subclass: #MagmaOfflineObject
	instanceVariableNames: 'proxy waitingMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaOfflineObject class methodsFor: 'create' stamp: 'cmm 1/13/2005 15:44'!
needingMessage: aMessage

	^ self new
		waitingMessage: aMessage ;
		yourself! !

!MagmaOfflineObject methodsFor: 'testing' stamp: 'cmm 1/13/2005 16:11'!
isMagmaOfflineObject

	^ true! !

!MagmaOfflineObject methodsFor: 'initialize-release' stamp: 'cmm 1/13/2005 16:50'!
proxy: aMagmaForwardingProxy

	proxy _ aMagmaForwardingProxy! !

!MagmaOfflineObject methodsFor: 'accessing' stamp: 'cmm 1/13/2005 16:54'!
tryToConnect

	self maMarked: 'dev'..

"My first guess is we signal the ConnectToPeerMagma notification.."! !

!MagmaOfflineObject methodsFor: 'accessing' stamp: 'cmm 1/13/2005 16:05'!
waitingMessage

	^ waitingMessage! !

!MagmaOfflineObject methodsFor: 'initialize-release' stamp: 'cmm 1/13/2005 15:44'!
waitingMessage: aMessage

	waitingMessage _ aMessage! !

MaObject subclass: #MagmaPreferences
	instanceVariableNames: 'attributes'
	classVariableNames: 'HandStatus Debug DebugProxies'
	poolDictionaries: ''
	category: 'Magma client-Preferences'!

!MagmaPreferences commentStamp: 'cmm 1/25/2003 17:49' prior: 0!
Each MagmaSession initializes its own preferences.  Get an instance of my by sending #preferences to a MagmaSession.

Debug and DebugProxies are global preferences.!

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 8/10/2002 18:09'!
debug

	^Debug! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 8/10/2002 18:10'!
debug: aBoolean

	Debug _ aBoolean! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:24'!
debugProxies

	^DebugProxies! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 7/25/2002 22:31'!
debugProxies: aBoolean

	DebugProxies _ aBoolean! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 3/30/2003 12:54'!
handStatus

	^HandStatus! !

!MagmaPreferences class methodsFor: 'accessing' stamp: 'cmm 3/30/2003 12:55'!
handStatus: aBoolean

	HandStatus _ aBoolean! !

!MagmaPreferences class methodsFor: 'initializing' stamp: 'cmm 10/9/2004 22:32'!
initialize

	super initialize.
	self 
		debugProxies: false;
		debug: false;
		handStatus: true! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 3/27/2005 17:19'!
allowWriteBarrier

	^ attributes at: #allowWriteBarrier! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 3/27/2005 23:05'!
allowWriteBarrier: aBoolean

	self systemHasWriteBarrier ifFalse: [ MagmaEnvironmentError signal: 'WriteBarrier not loaded in the image, cannot turn it on.' ].
	attributes
		at: #allowWriteBarrier
		put: aBoolean! !

!MagmaPreferences methodsFor: 'initializing' stamp: 'cmm 4/10/2005 19:20'!
initialize
	super initialize.
	attributes _ Dictionary new.
	self 
		refreshPersistentObjectsEvenWhenChangedOnlyByMe: false ;
		signalProxyMaterializations: false ;
		allowWriteBarrier: false! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:32'!
refreshPersistentObjectsEvenWhenChangedOnlyByMe
	"When set to true, any persistent objects that were changed by this session will be reset to their persistent state."

	^ attributes at: #refreshPersistentObjectsEvenWhenChangedOnlyByMe! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:31'!
refreshPersistentObjectsEvenWhenChangedOnlyByMe: aBoolean

	attributes
		at: #refreshPersistentObjectsEvenWhenChangedOnlyByMe
		put: aBoolean! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:32'!
signalProxyMaterializations
	"When set to true, every time a proxy is materialized, a MagmaProxyMaterialization notification is signaled.  This is useful during development for performance tuning specifically for optimizing your read strategies."

	^ attributes at: #signalProxyMaterializations! !

!MagmaPreferences methodsFor: 'accessing' stamp: 'cmm 4/30/2004 00:31'!
signalProxyMaterializations: aBoolean

	attributes
		at: #signalProxyMaterializations
		put: aBoolean! !

!MagmaPreferences methodsFor: 'testing' stamp: 'cmm 3/27/2005 23:06'!
systemHasWriteBarrier

	^ Smalltalk hasClassNamed: #WriteBarrier! !

MaObject subclass: #MagmaRepositoryCodeBase
	instanceVariableNames: 'packages changeSets classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Code management'!

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 2/14/2005 13:47'!
browseChangeSetNamed: nameString
	"Opens a code-file browser on the change-set named nameString."

	FileContentsBrowser browseStream: (self changeSetNamed: nameString)! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 2/14/2005 13:42'!
browseClassNamed: nameSymbol
	"Opens a code-file browser on the class named nameSymbol."

	FileContentsBrowser browseStream: (self classNamed: nameSymbol)! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:12'!
changeSetNamed: aString

	^ changeSets
		at: aString
		ifAbsent: [ MagmaUserError signal: 'No change set named ', aString, ' found here.' ].! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 11/9/2004 12:25'!
changeSetNames

	changeSets keys asSortedCollection! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:17'!
classNamed: aSymbol

	^ classes
		at: aSymbol
		ifAbsent: [ MagmaUserError signal: 'No class named ', aSymbol, ' found here.' ].! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 11/9/2004 12:25'!
classNames

	^ classes keys asSortedCollection! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:52'!
fileInChangeSetNamed: nameString

	| stream |
	stream _ self changeSetNamed: nameString.
	stream reset.
	ChangeSorter
		newChangesFromStream: stream
		named: nameString! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:17'!
fileInClassNamed: nameString

	| stream |
	stream _ self classNamed: nameString.
	stream reset.
	stream fileInAnnouncing: 'loading class ', nameString, ' from Magma database.'! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:44'!
fileOutChangeSet: aChangeSet

	| stream |
	stream _ ReadWriteStream on: String new.
	aChangeSet fileOutOn: stream.
	stream position: 0.
	changeSets
		at: aChangeSet name
		put: stream! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:44'!
fileOutClass: aClass

	| stream |
	stream _ ReadWriteStream on: String new.
	aClass fileOutOn: stream.
	stream position: 0.
	classes
		at: aClass name
		put: stream! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 11/4/2004 23:09'!
includesVersionNamed: aString
	"The Monticello UI uses this method."
	^ packages anySatisfy: [ : each | each info name = aString ]! !

!MagmaRepositoryCodeBase methodsFor: 'initialize-release' stamp: 'cmm 10/26/2004 22:29'!
initialize

	super initialize.
	packages _ Dictionary new.
	changeSets _ Dictionary new.
	classes _ Dictionary new! !

!MagmaRepositoryCodeBase methodsFor: 'change sets' stamp: 'cmm 10/26/2004 23:14'!
installChangeSets

	changeSets keysDo: [ :eachKey | self fileInChangeSetNamed: eachKey ]! !

!MagmaRepositoryCodeBase methodsFor: 'class fileouts' stamp: 'cmm 10/26/2004 23:18'!
installClasses

	classes keysDo: [ :eachKey | self fileInClassNamed: eachKey ]! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 11/2/2004 13:50'!
packages

	^ packages! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 10/26/2004 23:38'!
storeVersion: aMCVersion
	"The Monticello UI uses this method."
	packages
		at: aMCVersion info
		put: aMCVersion! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 10/26/2004 23:38'!
versionWithInfo: aMCVersionInfo ifAbsent: aBlock
	"The Monticello UI uses this method."
	^ packages
		at: aMCVersionInfo
		ifAbsent: aBlock! !

!MagmaRepositoryCodeBase methodsFor: 'packages' stamp: 'cmm 10/26/2004 22:58'!
versionsAvailableForPackage: aMCVersion
	"The Monticello UI uses this method."
	^ packages
		select: [ : each | each package = aMCVersion ]
		thenCollect: [ : each | each info ]! !

MaObject subclass: #MagmaRepositoryDefinition
	instanceVariableNames: 'magmaId attributes classDefinitions maximumNumberOfChallengers allLargeCollections codeBase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaRepositoryDefinition class methodsFor: 'as yet unclassified' stamp: 'cmm 1/16/2005 21:52'!
defaultMaximumNumberOfChallengers
	"defaultMaximumNumberOfChallengers is used to manage server resources.  Since all commit records against a session build-up in memory until the session crosses a transaction boundary (browse references to MaTransactionLog>>'challengingEntries').  For now, we use this simple default."

	^ 1000! !

!MagmaRepositoryDefinition methodsFor: 'large collections' stamp: 'cmm 3/16/2005 12:45'!
addLargeCollection: aMagmaLargeCollection

	^ allLargeCollections add: aMagmaLargeCollection! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 6/6/2004 23:56'!
addMinimumClassesForOdbmsUsing: aMaObjectSerializer
	"These are the minimum required classes for a client to communicate with the
	repositoryController."

	self minimumClassesToCreateRepository
		do:
			[ :each |
			aMaObjectSerializer classIdManager addNewClass: (Smalltalk classNamed: each) ].
	self classDefinitions: aMaObjectSerializer classIdManager classDefinitionsById! !

!MagmaRepositoryDefinition methodsFor: 'large collections' stamp: 'cmm 5/29/2002 22:43'!
allLargeCollections

	^allLargeCollections! !

!MagmaRepositoryDefinition methodsFor: 'accessing' stamp: 'cmm 3/2/2005 12:20'!
attributeNamed: aString
	"Answer the user object placed at aString."

	^ attributes at: aString! !

!MagmaRepositoryDefinition methodsFor: 'accessing' stamp: 'cmm 3/2/2005 12:19'!
attributeNamed: aString put: anObject
	"Objects required for user-extensions to Magma should be placed here."

	attributes 
		at: aString
		put: anObject! !

!MagmaRepositoryDefinition methodsFor: 'classes' stamp: 'cmm 8/21/2002 21:58'!
classDefinitions
	"Key = classId, value = anOrderedCollection of MaOdbmsClassDefinition's."

	^classDefinitions! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 5/29/2002 22:43'!
classDefinitions: aDictionary

	classDefinitions _ aDictionary
! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 6/4/2004 13:16'!
classDefinitionsForId: anInteger

	^ classDefinitions at: anInteger! !

!MagmaRepositoryDefinition methodsFor: 'code base' stamp: 'cmm 10/26/2004 23:41'!
codeBase

	^ codeBase! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 3/6/2005 11:58'!
initialize

	super initialize.
	self classDefinitions: Dictionary new.
	allLargeCollections _ Set new.
	codeBase _ MagmaRepositoryCodeBase new.
	magmaId _ MagmaId new.
	maximumNumberOfChallengers _ 1000.
	attributes _ Dictionary new! !

!MagmaRepositoryDefinition methodsFor: 'accessing' stamp: 'cmm 1/16/2005 22:20'!
magmaId

	^ magmaId! !

!MagmaRepositoryDefinition methodsFor: 'settings' stamp: 'cmm 5/29/2002 22:43'!
maximumNumberOfChallengers
	"Answer the maximum number of commit entry's Magma should allow in each users session before that session will be terminated.  Commit entry's are records stored in the servers memory that record the objects changed by each user.  When a session is in a transaction, these entries 'pile up', consuming server memory.  Only when the client crosses a transaction boundary (i.e., begin, commit or abort) is the log for that session cleared."

	^maximumNumberOfChallengers
! !

!MagmaRepositoryDefinition methodsFor: 'settings' stamp: 'cmm 5/29/2002 22:43'!
maximumNumberOfChallengers: anInteger

	maximumNumberOfChallengers _ anInteger
! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 6/29/2004 23:52'!
minimumClassesToCreateRepository
	"We need Bag to properly prepare their permanent ReadStrategy's in MaBasicReadStrategy class.  In there, we set their readDepth to +1 because collections are almost always enumerated and it would perform poorly to materalize one at a time.  Blocks and CompiledMethods need to always be read full depth."

	^#(
	"Array and Set are not here because they are part of minimumClasses."
	Collection

"	CompiledMethod BlockContext    waiting for future version of Magma"

	)! !

!MagmaRepositoryDefinition methodsFor: 'code base' stamp: 'cmm 10/26/2004 12:57'!
packageAt: aMCVersionInfo ifAbsent: aBlock

	^ codeBase
		at: aMCVersionInfo
		ifAbsent: aBlock! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 6/7/2004 15:36'!
removeClassWithId: anInteger

	classDefinitions removeKey: anInteger! !

!MagmaRepositoryDefinition methodsFor: 'private' stamp: 'cmm 3/16/2005 12:44'!
removeCollection: aMagmaLargeCollection

	allLargeCollections remove: aMagmaLargeCollection! !

MaObject subclass: #MagmaRepositoryRequest
	instanceVariableNames: 'sessionId repositoryController'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaRepositoryRequest commentStamp: 'cmm 1/25/2003 17:56' prior: 0!
Superclass for all Magma request objects.!

MagmaRepositoryRequest subclass: #MaAbortTransactionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaAbortTransactionRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:11'!
process

	^repositoryController abortTransactionFor: sessionId
! !

MagmaRepositoryRequest subclass: #MaAbstractReadRequest
	instanceVariableNames: 'readStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaAbstractReadRequest methodsFor: 'building' stamp: 'cmm 9/1/2003 23:25'!
readStrategy: aMaReadStrategy

	readStrategy _ aMaReadStrategy! !

!MaAbstractReadRequest methodsFor: 'accessing' stamp: 'cmm 3/30/2003 12:59'!
waitCursor

	^Cursor read! !

MaAbstractReadRequest subclass: #MaAnchorRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaAnchorRequest commentStamp: 'cmm 1/25/2003 17:59' prior: 0!
I'm the request used when you ask for the root.  The "real" root is actually an instance of MaRootAnchor, which references your root (this provides service via the standard commit mechanism).!

!MaAnchorRequest methodsFor: 'actions' stamp: 'cmm 2/8/2005 23:38'!
process

	^repositoryController
		readAnchorFor: sessionId
		using: readStrategy! !

MaAbstractReadRequest subclass: #MaLargeCollectionSegmentRequest
	instanceVariableNames: 'quantity collectionOid attribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaLargeCollectionSegmentRequest methodsFor: 'building' stamp: ''!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaLargeCollectionSegmentRequest methodsFor: 'building' stamp: 'cmm 12/2/2004 13:50'!
collectionOid: anInteger

	collectionOid _ anInteger! !

!MaLargeCollectionSegmentRequest methodsFor: 'building' stamp: ''!
quantity: anInteger

	quantity _ anInteger
! !

MaLargeCollectionSegmentRequest subclass: #MaSegmentByIndexRequest
	instanceVariableNames: 'lowIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaSegmentByIndexRequest methodsFor: 'building' stamp: ''!
lowIndex: anInteger

	lowIndex _ anInteger
! !

!MaSegmentByIndexRequest methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:49'!
process

	^repositoryController
		upTo: quantity
		oidsFromIndex: lowIndex
		inLargeCollection: collectionOid
		on: attribute
		using: readStrategy
		forSession: sessionId! !

MaSegmentByIndexRequest subclass: #MaSegmentByKeyRequest
	instanceVariableNames: 'lowKey highKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaSegmentByKeyRequest methodsFor: 'accessing' stamp: ''!
highKey

	^highKey! !

!MaSegmentByKeyRequest methodsFor: 'building' stamp: ''!
highKey: anInteger

	highKey _ anInteger
! !

!MaSegmentByKeyRequest methodsFor: 'accessing' stamp: ''!
lowKey

	^lowKey! !

!MaSegmentByKeyRequest methodsFor: 'building' stamp: ''!
lowKey: anInteger

	lowKey _ anInteger
! !

!MaSegmentByKeyRequest methodsFor: 'actions' stamp: 'cmm 3/21/2005 15:54'!
process

	^repositoryController
		upTo: quantity
		oidsFrom: lowKey
		to: highKey
		startingAt: lowIndex
		inLargeCollection: collectionOid
		on: attribute
		using: readStrategy
		forSession: sessionId! !

MaAbstractReadRequest subclass: #MaReadRequest
	instanceVariableNames: 'oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaReadRequest commentStamp: 'cmm 1/25/2003 17:58' prior: 0!
I'm a request to a Magma server for a bunch of needed object buffers, due to proxy materialization or whatever.!

!MaReadRequest methodsFor: 'accessing' stamp: ''!
oid

	^oid! !

!MaReadRequest methodsFor: 'building' stamp: ''!
oid: anInteger

	oid _ anInteger
! !

!MaReadRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:10'!
process

	^repositoryController
		read: oid
		for: sessionId
		using: readStrategy! !

MagmaRepositoryRequest subclass: #MaCloseRepositoryRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaCloseRepositoryRequest methodsFor: 'as yet unclassified' stamp: 'cmm 4/30/2003 23:40'!
process

	repositoryController
		signalRequestGuard;
		close! !

!MaCloseRepositoryRequest methodsFor: 'as yet unclassified' stamp: 'cmm 12/31/2002 15:28'!
requiresConnection

	^false! !

MagmaRepositoryRequest subclass: #MaDownloadCodeRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaDownloadCodeRequest methodsFor: 'as yet unclassified' stamp: 'cmm 10/26/2004 21:54'!
process

	^ repositoryController codeBaseByteArray! !

!MaDownloadCodeRequest methodsFor: 'as yet unclassified' stamp: 'cmm 12/31/2002 15:26'!
requiresConnection

	^false! !

MagmaRepositoryRequest subclass: #MaLargeCollectionSizeRequest
	instanceVariableNames: 'collectionOid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

MaLargeCollectionSizeRequest subclass: #MaKeyIntervalInfoRequest
	instanceVariableNames: 'attribute lowKey highKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaKeyIntervalInfoRequest commentStamp: '<historical>' prior: 0!
This request is used to get sizes of sub-magmacollections, either with or without
index.
!

!MaKeyIntervalInfoRequest methodsFor: 'accessing' stamp: ''!
attribute

	^attribute! !

!MaKeyIntervalInfoRequest methodsFor: 'building' stamp: ''!
attribute: aSymbol

	attribute _ aSymbol
! !

!MaKeyIntervalInfoRequest methodsFor: 'accessing' stamp: ''!
highKey

	^highKey! !

!MaKeyIntervalInfoRequest methodsFor: 'building' stamp: ''!
highKey: anInteger

	highKey _ anInteger
! !

!MaKeyIntervalInfoRequest methodsFor: 'accessing' stamp: ''!
lowKey

	^lowKey! !

!MaKeyIntervalInfoRequest methodsFor: 'building' stamp: ''!
lowKey: anInteger

	lowKey _ anInteger
! !

!MaKeyIntervalInfoRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:12'!
process

	^repositoryController
		numberOfEntriesFrom: lowKey
		to: highKey
		inLargeCollection: collectionOid
		on: attribute! !

!MaLargeCollectionSizeRequest methodsFor: 'building' stamp: ''!
collectionOid: anInteger

	collectionOid _ anInteger
! !

!MaLargeCollectionSizeRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:13'!
process

	^repositoryController sizeOfLargeCollection: collectionOid
! !

MagmaRepositoryRequest subclass: #MaRepositoryConnectionRequest
	instanceVariableNames: 'userId magmaVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaRepositoryConnectionRequest methodsFor: 'accessing' stamp: 'cmm 12/30/2002 23:20'!
magmaVersion

	^magmaVersion! !

!MaRepositoryConnectionRequest methodsFor: 'building' stamp: 'cmm 12/30/2002 23:20'!
magmaVersion: anInteger

	magmaVersion _ anInteger! !

!MaRepositoryConnectionRequest methodsFor: 'actions' stamp: 'cmm 12/26/2004 22:37'!
process

	MagmaSession magmaVersion = magmaVersion
		ifFalse:
			[ MagmaUserError signal:
				'This server is running Magma version ', MagmaSession magmaVersion printString, '.  You may not connect with version ', magmaVersion printString, ' of the client code.  You may be able to install the code using browseCode.' ].

	^ repositoryController newSessionFor: userId! !

!MaRepositoryConnectionRequest methodsFor: 'testing' stamp: 'cmm 12/31/2002 15:27'!
requiresConnection

	^false! !

!MaRepositoryConnectionRequest methodsFor: 'building' stamp: ''!
userId: aString

	userId _ aString
! !

MagmaRepositoryRequest subclass: #MaRepositoryDisconnectRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaRepositoryDisconnectRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:13'!
process

	^repositoryController disconnect: sessionId
! !

MagmaRepositoryRequest subclass: #MaTransactionRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaTransactionRequest methodsFor: 'actions' stamp: 'cmm 12/17/2002 11:13'!
process
	^repositoryController newTransactionFor: sessionId! !

MagmaRepositoryRequest subclass: #MaWriteRequest
	instanceVariableNames: 'package beginAnother'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaWriteRequest commentStamp: 'cmm 1/25/2003 17:55' prior: 0!
I am the request object sent to a Magma server that commits changes to the database.!

!MaWriteRequest methodsFor: 'building' stamp: 'cmm 4/21/2003 17:04'!
beginAnother: aBoolean

	beginAnother _ aBoolean! !

!MaWriteRequest methodsFor: 'accessing' stamp: ''!
package

	^package! !

!MaWriteRequest methodsFor: 'building' stamp: ''!
package: aMaCommitPackage

	package _ aMaCommitPackage
! !

!MaWriteRequest methodsFor: 'actions' stamp: 'cmm 4/21/2003 14:45'!
process

	^repositoryController
		submitAll: package
		for: sessionId
		beginAnother: beginAnother! !

!MaWriteRequest methodsFor: 'accessing' stamp: 'cmm 3/30/2003 12:59'!
waitCursor

	^Cursor write! !

MagmaRepositoryRequest subclass: #MagmaIdRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaIdRequest methodsFor: 'as yet unclassified' stamp: 'cmm 1/14/2005 16:05'!
process

	^ repositoryController magmaId! !

!MagmaIdRequest methodsFor: 'as yet unclassified' stamp: 'cmm 1/14/2005 15:32'!
requiresConnection

	^ false! !

MagmaRepositoryRequest subclass: #MagmaPathNameRequest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaPathNameRequest methodsFor: 'as yet unclassified' stamp: 'cmm 9/24/2004 15:13'!
process

	^ repositoryController pathName! !

!MagmaPathNameRequest methodsFor: 'as yet unclassified' stamp: 'cmm 9/19/2004 22:58'!
requiresConnection

	^ false! !

!MagmaRepositoryRequest methodsFor: 'actions' stamp: ''!
process
	"Any persistent objects returned by this should be materialized only by the sessions
	serializer, not the repositoryLink's serializer because the sessions serializer is what
	works with the transaction to mark it read so changes can be detected."

	self subclassResponsibility
! !

!MagmaRepositoryRequest methodsFor: 'building' stamp: 'cmm 7/5/2004 11:57'!
repositoryController: aMagmaRepositoryController

	repositoryController _ aMagmaRepositoryController
! !

!MagmaRepositoryRequest methodsFor: 'testing' stamp: 'cmm 12/31/2002 15:26'!
requiresConnection

	^true! !

!MagmaRepositoryRequest methodsFor: 'private' stamp: ''!
sessionId

	^sessionId! !

!MagmaRepositoryRequest methodsFor: 'accessing' stamp: ''!
sessionId: anInteger

	sessionId _ anInteger
! !

!MagmaRepositoryRequest methodsFor: 'accessing' stamp: 'cmm 10/11/2004 12:29'!
waitCursor

	^Cursor wait! !

MaObject subclass: #MagmaServerResult
	instanceVariableNames: 'serverNotifications'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

MagmaServerResult subclass: #MaReadResult
	instanceVariableNames: 'byteArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaReadResult class methodsFor: 'as yet unclassified' stamp: 'cmm 12/16/2002 21:18'!
byteArray: aByteArray

	^self new byteArray: aByteArray; yourself! !

!MaReadResult methodsFor: 'accessing' stamp: 'cmm 12/16/2002 21:18'!
byteArray

	^byteArray! !

!MaReadResult methodsFor: 'private' stamp: 'cmm 12/17/2002 00:49'!
byteArray: aByteArray

	byteArray _ aByteArray! !

MagmaServerResult subclass: #MaRefreshViewResult
	instanceVariableNames: 'connection toBeRefreshed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

MaRefreshViewResult subclass: #MaCommitResult
	instanceVariableNames: 'permanentOids changedObjectBuffers newObjectBuffers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MaCommitResult commentStamp: '<historical>' prior: 0!
This class is instantiated on the server and returned to the client.
!

!MaCommitResult methodsFor: 'converting' stamp: 'cmm 1/27/2005 16:41'!
asFailedResult

	^ MaFailedCommitResult new
		serverNotifications: serverNotifications ;
		permanentOids: self permanentOids ;
		toBeRefreshed: toBeRefreshed;
		connection: connection! !

!MaCommitResult methodsFor: 'building' stamp: 'cmm 10/10/2004 21:46'!
changedObjectBuffers: aDictionary

	changedObjectBuffers _ aDictionary! !

!MaCommitResult methodsFor: 'testing' stamp: ''!
hasConflicts

	^false
! !

!MaCommitResult methodsFor: 'initializing' stamp: 'cmm 10/12/2004 21:40'!
initialize

	super initialize.
	newObjectBuffers _ OrderedCollection new.
	changedObjectBuffers _ #()! !

!MaCommitResult methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:34'!
newlyPersistedObjectsDo: oneArgBlock using: aMagmaSession
	"Birthday objects are the ones that were not persistent until my commit.  This method is useful for load scripts, where you probably want to stubOut: all the birthday objects right after loading them, so they can be collected much faster."

	permanentOids do:
		[ :eachOid | | obj |
		obj _ aMagmaSession serializer
			objectWithOid: eachOid
			ifAbsent: [ nil ].
		obj ifNotNil: [ oneArgBlock value: obj ] ]! !

!MaCommitResult methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:35'!
permanentOids
	"A Dictionary.  Key is the new-object oid, value is the permanent oid."

	^ permanentOids! !

!MaCommitResult methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:35'!
permanentOids: aDictionary
	"A Dictionary.  Key is the new-object oid, value is the permanent oid."

	permanentOids _ aDictionary! !

!MaCommitResult methodsFor: 'building' stamp: 'cmm 10/10/2004 20:46'!
recordNewObjectBuffer: aMaObjectBuffer

	newObjectBuffers add: aMaObjectBuffer! !

!MaCommitResult methodsFor: 'actions' stamp: 'cmm 12/2/2004 13:36'!
refresh: aMagmaSession

	aMagmaSession assignPermanentOidsFrom: permanentOids.
	super refresh: aMagmaSession.
	aMagmaSession
		recordObjects: newObjectBuffers ;
		recordObjects: changedObjectBuffers! !

MaCommitResult subclass: #MaFailedCommitResult
	instanceVariableNames: 'commitConflicts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-API'!

!MaFailedCommitResult methodsFor: 'converting' stamp: ''!
asFailedResult

	^self
! !

!MaFailedCommitResult methodsFor: 'accessing' stamp: 'cmm 6/26/2002 22:16'!
commitConflicts

	^commitConflicts! !

!MaFailedCommitResult methodsFor: 'accessing' stamp: 'cmm 11/25/2003 00:22'!
conflictMessage
	"This method demonstrates how the structure of a MaCommitResult might be utilized to
	provide a message to an end-user."

	| message |

	message _ MaTextMessage new.
	commitConflicts do:
		[ :each |
		message
			append: each connection userId;
			append: ' has committed changes to ';
			appendProperlyPluralized: 'object'
				for: each conflictingOids size;
			append: ' with ';
			appendProperlyPluralized: 'oid'
				for: each conflictingOids size;
			space;
			appendAndedList: each conflictingOids;
			append: '; ' ].
	message append:
		' while you were working on those same objects.  Please review and reapply your changes if necessary.'.
	^message messageText

! !

!MaFailedCommitResult methodsFor: 'testing' stamp: ''!
hasConflicts

	^true
! !

!MaFailedCommitResult methodsFor: 'initializing' stamp: 'cmm 12/24/2002 15:42'!
initialize

	super initialize.
	commitConflicts _ OrderedCollection new! !

!MaFailedCommitResult methodsFor: 'building' stamp: 'cmm 6/26/2002 00:33'!
populateConflictingObjectsFromOidsUsing: aMaObjectSerializer

	commitConflicts do: [ :each | each initializeConflictingObjectsUsing: aMaObjectSerializer ]
! !

!MaFailedCommitResult methodsFor: 'building' stamp: 'cmm 10/15/2004 16:19'!
recordObjectConflictWith: aMagmaClientConnection on: oidInteger

	(commitConflicts
		detect: [ : each | each conflictingConnection = aMagmaClientConnection ]
		ifNone: [ commitConflicts add: (MagmaCommitConflict connection: aMagmaClientConnection) ])
			addConflictingOid: oidInteger.
	^ self! !

!MaRefreshViewResult methodsFor: 'building' stamp: 'cmm 10/15/2004 16:54'!
addToBeRefreshed: aDictionary
	"aDictionary the containing the MaObjectBuffers that were committed by other sessions, keyed by their oid."
	toBeRefreshed addAll: aDictionary

"NOTE:  I've considered a performance improvement of adding just the entire aDictionary and then require clients to deal with an OrderedCollection of Dictionaries of MaObjectLinks but..  spinning aDictionary is really unavoidable because it would have to be serialized anyway.  Rebuilding those Dictionaries on the client-side is more expensive than just making an OrderedCollection."! !

!MaRefreshViewResult methodsFor: 'initializing' stamp: 'cmm 7/16/2002 21:25'!
connection

	^connection! !

!MaRefreshViewResult methodsFor: 'building' stamp: 'cmm 7/16/2002 21:22'!
connection: aMagmaClientConnection

	connection _ aMagmaClientConnection
! !

!MaRefreshViewResult methodsFor: 'initializing' stamp: 'cmm 6/20/2004 20:32'!
initialize

	super initialize.
	self toBeRefreshed: (Dictionary new: 50)! !

!MaRefreshViewResult methodsFor: 'accessing' stamp: 'cmm 12/2/2004 13:52'!
permanentOids

	^nil
! !

!MaRefreshViewResult methodsFor: 'actions' stamp: 'cmm 1/28/2005 00:17'!
refresh: aMagmaSession

	aMagmaSession
		refreshChangedObjects: toBeRefreshed ;
		resetMagmaCollectionChanges! !

!MaRefreshViewResult methodsFor: 'accessing' stamp: ''!
sessionId

	^self connection sessionId
! !

!MaRefreshViewResult methodsFor: 'accessing' stamp: ''!
toBeRefreshed

	^toBeRefreshed! !

!MaRefreshViewResult methodsFor: 'building' stamp: 'cmm 10/8/2004 16:52'!
toBeRefreshed: aDictionary

	toBeRefreshed _ aDictionary
! !

!MaRefreshViewResult methodsFor: 'accessing' stamp: ''!
userId

	^self connection userId
! !

MagmaServerResult subclass: #MagmaLargeCollectionSegment
	instanceVariableNames: 'startIndex keys objects lastKnownSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaLargeCollectionSegment commentStamp: 'cmm 12/1/2004 21:44' prior: 0!
I represent a "page" of objects in a MagmaCollection.!

!MagmaLargeCollectionSegment methodsFor: 'accessing' stamp: 'cmm 12/2/2004 10:53'!
actualPageSize
	^ objects size! !

!MagmaLargeCollectionSegment methodsFor: 'accessing' stamp: 'cmm 7/8/2002 12:40'!
at: anInteger

	^objects at: anInteger - startIndex + 1
! !

!MagmaLargeCollectionSegment methodsFor: 'private' stamp: 'cmm 3/22/2005 10:15'!
atEnd
	"Answer whether I contain the last element of the back-end index I originated from."

	^ lastKnownSize = 0 or: [ self includesIndex: lastKnownSize ]! !

!MagmaLargeCollectionSegment methodsFor: 'accessing' stamp: 'cmm 3/21/2005 16:44'!
endIndex
	"Answer the index within the large-collection or reader of the last element in the receivers objects collection."

	^ startIndex + objects size - 1! !

!MagmaLargeCollectionSegment methodsFor: 'testing' stamp: 'cmm 3/22/2005 10:24'!
includesIndex: anInteger
	"Answer whether logical anInteger-index falls within the range of indices currently covered by my 'objects'."

	^ anInteger
		between: self startIndex
		and: self endIndex! !

!MagmaLargeCollectionSegment methodsFor: 'building' stamp: 'cmm 4/15/2005 12:17'!
incrementStartIndex

	startIndex _ startIndex + 1! !

!MagmaLargeCollectionSegment methodsFor: 'testing' stamp: 'cmm 4/15/2005 10:05'!
isEmpty

	^ objects isEmpty! !

!MagmaLargeCollectionSegment methodsFor: 'accessing' stamp: 'cmm 4/18/2005 11:23'!
keys
	^ keys! !

!MagmaLargeCollectionSegment methodsFor: 'building' stamp: 'cmm 4/17/2005 22:11'!
keys: aSequenceableCollection

	keys _ aSequenceableCollection! !

!MagmaLargeCollectionSegment methodsFor: 'accessing' stamp: ''!
lastKnownSize

	^lastKnownSize! !

!MagmaLargeCollectionSegment methodsFor: 'building' stamp: ''!
lastKnownSize: anInteger

	lastKnownSize _ anInteger
! !

!MagmaLargeCollectionSegment methodsFor: 'accessing' stamp: ''!
objects

	^objects! !

!MagmaLargeCollectionSegment methodsFor: 'building' stamp: 'cmm 4/17/2005 22:11'!
objects: aSequenceableCollection

	objects _ aSequenceableCollection
! !

!MagmaLargeCollectionSegment methodsFor: 'building' stamp: 'cmm 4/18/2005 12:39'!
removeObject: anObject

	objects
		remove: anObject
		ifAbsent: [ "do nothing" ]! !

!MagmaLargeCollectionSegment methodsFor: 'building' stamp: 'cmm 4/18/2005 13:15'!
removeObject: anObject at: hashInteger

	| hashPosition |
	hashPosition _ keys indexOf: hashInteger ifAbsent: [ ^ self ].
	(objects at: hashPosition) == anObject 
		ifTrue: 
			[ "hmm, kind of ugly here..  Max-read-speed = returning Arrays, but to merge we have to convert them to OrderedCollections."
			objects class = Array
				ifTrue:
					[ objects _ objects asOrderedCollection.
					keys _ keys asOrderedCollection ].
			objects removeAtIndex: hashPosition.
			keys removeAtIndex: hashPosition ]! !

!MagmaLargeCollectionSegment methodsFor: 'private' stamp: 'cmm 3/21/2005 16:50'!
reset
self maMarked: 'delete'.
	startIndex _ nil! !

!MagmaLargeCollectionSegment methodsFor: 'accessing' stamp: 'cmm 3/22/2005 10:20'!
startIndex
	"Answers the logical index within the range of indices applicable to my Readers specified range."

	^ startIndex! !

!MagmaLargeCollectionSegment methodsFor: 'building' stamp: ''!
startIndex: anObject

	startIndex _ anObject
! !

!MagmaServerResult methodsFor: 'testing' stamp: 'cmm 1/28/2005 00:14'!
hasServerNotifications

	^ serverNotifications isEmptyOrNil not! !

!MagmaServerResult methodsFor: 'testing' stamp: 'cmm 1/28/2005 00:15'!
isMagmaServerResult

	^ true! !

!MagmaServerResult methodsFor: 'accessing' stamp: 'cmm 1/18/2005 21:53'!
serverNotifications

	^ serverNotifications! !

!MagmaServerResult methodsFor: 'accessing' stamp: 'cmm 1/18/2005 21:54'!
serverNotifications: aDictionary

	serverNotifications _ aDictionary! !

!MagmaServerResult methodsFor: 'accessing' stamp: 'cmm 1/18/2005 22:01'!
shouldRefresh
	"So many results do not need serverNotifications; therefore we do not keep a separate boolean variable for shouldRefresh that otherwise needs to be sent over the wire 1% of the time."
	^ serverNotifications includesKey: #shouldRefresh! !

!MagmaServerResult methodsFor: 'accessing' stamp: 'cmm 1/18/2005 21:54'!
shouldRefresh: aBoolean

	aBoolean ifTrue:
		[ serverNotifications 
			at: #shouldRefresh
			put: true ]! !

MaObject subclass: #MagmaSession
	instanceVariableNames: 'id user serializer transaction readStrategy definition preferences anchor transactionLevel link'
	classVariableNames: 'ConnectedSessions'
	poolDictionaries: ''
	category: 'Magma client-API'!

!MagmaSession commentStamp: 'cmm 2/25/2005 16:01' prior: 0!
This is a clients primary interface to a Magma repository.!

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 3/28/2005 13:59'!
cleanUp
	"References to MagmaSessions get stuck in old MethodContext's, preventing garbage-collection.  Run this method and these instances will be cleaned."

	| before after |
	self disconnectAndCloseAllConnectedSessions.
	Smalltalk garbageCollect.
	before _ MagmaSession instanceCount.
	MagmaSession allInstances do: [ : each | each becomeForward: nil copyHash: false ].
	Smalltalk garbageCollect.
	MagmaSession allInstances do:
		[ : each |
		(Smalltalk pointersTo: each)
			do:
				[ : referencer | 
				referencer class == MethodContext ifTrue: [ referencer receiver: nil ] ] ].
	Smalltalk garbageCollect.
	after _ MagmaSession instanceCount.

SystemNavigation default allObjectsDo: [ : e | ((e class inheritsFrom: Object) and: [ e isBehindWriteBarrier ]) ifTrue: [ Transcript cr; show: 'fixing ', e printString. e primitiveChangeClassTo: e class superclass basicNew ] ].

	^ 'MagmaSession instances (before->after):  ', (before->after) printString! !

!MagmaSession class methodsFor: 'accessing' stamp: 'cmm 7/2/2004 12:58'!
connectedSessions

	^ ConnectedSessions! !

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 1/17/2005 14:53'!
disconnectAndCloseAllConnectedSessions

	ConnectedSessions ifNotNil:
		[ ConnectedSessions copy do: [ : each | each disconnectAndClose ] ]! !

!MagmaSession class methodsFor: 'creation' stamp: 'cmm 10/27/2004 12:23'!
host: hostName port: anInteger

	^ self
		hostAddress: (NetNameResolver addressForName: hostName)
		port: anInteger! !

!MagmaSession class methodsFor: 'creation' stamp: 'cmm 12/26/2004 23:26'!
hostAddress: aByteArray port: anInteger

	^ self link:
		(MaTcpRequestServerLink
			hostAddress: aByteArray
			port: anInteger)! !

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 10/27/2004 15:32'!
initialize

	self disconnectAndCloseAllConnectedSessions.
	ConnectedSessions _ Set new.
	Smalltalk
		addToStartUpList: self;
		addToShutDownList: self! !

!MagmaSession class methodsFor: 'creation' stamp: 'cmm 12/26/2004 23:12'!
link: aMaServerLink

	^ self new
		link: aMaServerLink ;
		yourself! !

!MagmaSession class methodsFor: 'accessing' stamp: 'cmm 10/24/2004 19:17'!
magmaVersion

	^ 3! !

!MagmaSession class methodsFor: 'maui' stamp: 'cmm 1/26/2004 15:14'!
mauiBasicApi

	^#(hostAddress:port: openLocal:)! !

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 12/27/2004 23:16'!
shutDown: aboutToQuit

	super shutDown: aboutToQuit.
	ConnectedSessions
		do:
			[ : each |
			each isConnected
				ifTrue:
					[ each primDisconnect ] ]! !

!MagmaSession class methodsFor: 'initializing' stamp: 'cmm 12/28/2004 10:57'!
startUp: amResuming

	super startUp: amResuming.
	"We must ensure the servers are opened before we try to connect."
	(Smalltalk hasClassNamed: #MagmaRepositoryController)
		ifTrue:
			[ (Smalltalk classNamed: #MagmaRepositoryController) startUp: amResuming ].
	ConnectedSessions copy 
		do:
			[ :each |
			[ each primConnect ]
				on: MaEnvironmentError
				do: [ : error | each disconnect ] ]! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 4/12/2005 21:12'!
abort

	"This guard is needed for when we initially connect to the repository because we can't abort before the connection is made."
	self isConnected
		ifTrue:
			[ anchor _ nil.
			self resetTransactionLevel.
			preferences refreshPersistentObjectsEvenWhenChangedOnlyByMe
				ifTrue: [ transaction restore ].
			self refresh ]! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 3/16/2005 12:43'!
addLargeCollection: aMagmaCollection

	aMagmaCollection session ifNotNil: [ MagmaUserError signal: 'LargeCollections cannot be shared with other repositories.' ].
	definition addLargeCollection: aMagmaCollection.
	aMagmaCollection setOid: (self oidFor: aMagmaCollection).
	transaction monitorLargeCollectionChanges: aMagmaCollection changes! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 3/27/2005 22:28'!
allowWriteBarrier: aBoolean

	transaction validateWriteBarrier: aBoolean.
	preferences allowWriteBarrier: aBoolean! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:01'!
anchor

	^ anchor
		ifNil:
			[ | anch |
			anch _ self materializeAnchorFrom: 
				(self submit:
					(MaAnchorRequest new
						readStrategy: self resetReadStrategy ;
						yourself)).
			"avoid the root getting garbage collected before we can capture the changes because the user wrote mySession commit: [ mySession root at: 'hello' put: 'world' ]."
			anchor _ self inTransaction ifTrue: [ anch ] "otherwise, nil it out".
			anch ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 3/16/2005 12:38'!
assignPermanentOidsFrom: permanentOidsDictionary

	permanentOidsDictionary ifNil: [ ^ self ].
	permanentOidsDictionary keysAndValuesDo:
		[ : eachTempOid : eachPermanentOid |
		serializer
			objectWithOid: eachTempOid
			ifFound: 
				[ : persistentObject | 
				serializer
					oidOf: persistentObject
					is: eachPermanentOid.
				persistentObject maIsLargeCollection ifTrue: [ persistentObject setOid: eachPermanentOid ] ]
			ifAbsent: [ nil ] ]! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 4/18/2005 16:54'!
becomeForward: anotherSession
	"We hate to use become, but this time it seems the best approach.  When a session is disconnected (such as when saving the image), there may be objects in the image that still reference it such as proxies or a MagmaCollection.  When these objects are provoked, their session should reconnect automatically, but there may already be another MagmaSession instance connected to the same repository under the same id.  Under this case, we simply becomeForward: the stale session to the connected one.  (Hmm, maybe we should have two sessions).
	But this is only one of the steps that is needed.  Because the newly connected session will have its own new instances of MagmaCollections, *my* MagmaCollections must each be individually becomed to the ones in the connected session, otherwise the new session will think they're new MagmaCollections even though they're not."

	| needToRehash |
	(anotherSession isKindOf: MagmaSession) ifFalse: [ ^ super becomeForward: anotherSession ].
	needToRehash _ false.
	definition allLargeCollections do:
		[ : each |
		anotherSession definition allLargeCollections
			maDetect: [ : eachOther | each changes collectionOid = eachOther changes collectionOid ]
			ifFound:
				[ : foundOther | each becomeForward: foundOther.
				needToRehash _ true ]
			ifNone:
				[ "This is probably a bad marriage..  Perhaps we should just stop."
				MagmaNotification signal: 'No matching MagmaCollection with oid ', each changes collectionOid printString, ' in connected session.  Assuming this collection was dereferenced.' ] ].
	needToRehash ifTrue: [ anotherSession serializer rehashOids ].
	super becomeForward: anotherSession.
	self class connectedSessions rehash! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 23:09'!
begin

	| refreshViewResult |
	self incrementTransactionLevel.
	self inNestedTransaction ifTrue: [ ^ self ].
	refreshViewResult _ self submit: MaTransactionRequest new.

	preferences refreshPersistentObjectsEvenWhenChangedOnlyByMe
		ifTrue:
			[ transaction restore ].
	self refreshViewUsing: refreshViewResult! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 4/23/2003 13:08'!
cachedObjectCount
	"Answers how many persistent objects from this repository are in memory.  Your program should be careful not to reference too-large object structures at a time, or these cache Dictionaries will become large and slower."

	^serializer oidCount! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 5/8/2003 13:48'!
cachedObjectCountByClass

	^serializer cachedObjectCountByClass! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
canStubOut: anObject 
	anObject maIsMutatingProxy ifTrue: [^false].
	(self isPersistent: anObject) ifFalse: [^false].
	anObject maOriginalClass = MaClassDefinition ifTrue: [^false].
	anObject == serializer classIdManager classDefinitionsById 
		ifTrue: [^false].
	serializer classIdManager classDefinitionsById 
		do: [:eachCollection | eachCollection == anObject ifTrue: [^false]].
	^true! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 1/5/2005 22:08'!
cleanUp

	self maMarked: 'hack'.
	"MethodContexts seem to keep hold of their last execution state, causing MagmaSessions to not be able to be garbage collected, unless we clear out their receiver.  Why is this a problem?"
	
	
"Hmm..  Gonna comment this out until I understand it better.  It seems we could potentially nil out the receiver on a context that is part of the execution stack.

Until I figure or someone can tell me, use my class-side method, MagmaSession cleanUp."

"
	(Smalltalk pointersTo: self)
		do:
			[ : referencer | 
			referencer class == MethodContext ifTrue: [ referencer receiver: nil ] ].

	Smalltalk garbageCollect
"

	
	
"This is the prior method of cleaning proxies.  Very slow.."
"	MagmaNotification signal: 'Cleaning proxies, please wait...'.
	Transcript cr; show: 'cleaning ', MaOdbmsProxy allInstances size printString, ' proxies..'.
	MaOdbmsProxy allInstances do: [ : each | each session id = id ifTrue: [ each becomeForward: nil copyHash: false ] ]."! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/26/2004 22:58'!
closeRepository

	self isLocal ifFalse: [ MaUserError signal: 'Only available during local connections.' ].
	self isConnected ifTrue: [ self disconnect ].
	self submit: MaCloseRepositoryRequest new! !

!MagmaSession methodsFor: 'code base' stamp: 'cmm 10/26/2004 22:12'!
codeBase

	^ definition codeBase! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 4/21/2003 14:18'!
commit

	self commitAndBegin: false! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 00:23'!
commit: aBlock

	| result |
	self begin.
	result _ aBlock value.
	self commit.
	^result! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 4/21/2003 14:22'!
commitAndBegin

	self commitAndBegin: true! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 4/6/2005 18:16'!
commitAndBegin: aBoolean

	| commitPackage commitResult |
	self isConnected ifFalse: [ MagmaUserError signal: 'Must connect before you can commit.' ].
	self inNestedTransaction
		ifTrue: 
			[ "nested transaction commit, essentially does nothing"
			self decrementTransactionLevel.
			^ self ].
	self inTransaction ifFalse: [ MagmaUserError signal: 'No transaction to commit.' ].
	commitPackage _ self newCommitPackageFor: transaction.
	commitResult _ 
		[ [ anchor _ nil.
		self resetTransactionLevel.
		aBoolean ifTrue: [ self incrementTransactionLevel ].
		self submit:
			(MaWriteRequest new
				package: commitPackage ;
				beginAnother: aBoolean) ] ifCurtailed: [ self restoreAllClassMaps ] ]
			on: MagmaCommitError
			do:
				[ :exception |
				exception result populateConflictingObjectsFromOidsUsing: serializer.
				self refreshViewUsing: exception result.
				exception signal ].
	(commitPackage hasNewIndexes or: [ commitPackage hasRemovedIndexes ])
		ifTrue:
			[ self
				processNewAndRemovedIndexesIn: commitPackage
				using: commitResult ]
		ifFalse:
			[ transaction resetCommitPackage.
			self refreshViewUsing: commitResult]! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 1/13/2005 23:57'!
connect: aMagmaUser

	self isConnected ifTrue: [ MagmaUserError signal: 'Already connected.' ].
	user _ aMagmaUser.
	self primConnect.
	self isServerSession ifFalse: [ ConnectedSessions add: self ]! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 3/11/2005 13:21'!
connectAs: aString

	self connect: (MagmaUser id: aString)! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/11/2004 13:44'!
decrementTransactionLevel

	transactionLevel _ transactionLevel - 1! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/26/2004 23:32'!
definition
	"Answers the repository definition, a MagmaRepositoryDefinition."

	^ definition! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 5/1/2003 00:26'!
disconnect

	ConnectedSessions remove: self ifAbsent: [ "do nothing" ].
	self primDisconnect! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 9/15/2004 22:18'!
disconnectAndClose

	self disconnect.
	self isLocal ifTrue: [ self closeRepository ]! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 3/11/2005 14:11'!
ensureConnected
	"When stale proxies or MagmaCollections are provoked, ensure their session connects."

	self isConnected
		ifFalse:
			[ MagmaNotification signal: 'Encountered disconnected session, looking for equivalent connection...'.
			MagmaSession connectedSessions
				maDetect:
					[ : each | 
					((each isSameRepositoryAs: self)
					and:
						[ each userId = self userId
						or: [ each isLocal  "default to reuse, easier for users to understand"
						or: [ each sharesAnyObjectsWith: self ] ] ]) ]
				ifFound:
					[ : foundSession |
					MagmaNotification signal: 'Equivalent session found, connecting objects to use this one.'.
					"A new session cannot be used, we must merge them."
					self becomeForward: foundSession ]
				ifNone:
					[ MagmaNotification signal: 'no equivalent session found, reopening the stale session.'.
					user ifNil:
						[ user _ MagmaUserRequiredNotification requestUserFor: self.
						user ifNil: [ MagmaUserError signal: 'A user to connect must be supplied.' ] ].
					self connect: user ] ]! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 1/21/2003 21:41'!
finalizeOids
	"Use this after you've agitated Squeaks garbage collector into finalizing the various identity dictionaries maintained by me.  May be useful for situations when your program creates a lot of garbage."

	serializer finalizeOids.
	transaction finalizeOids! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:08'!
getCode
	"Answer the Dictionary of Streams that was manually installed in the server that can be browsed or filed-in to be able to connect to my repostory."

	| code classesAndCode |
	classesAndCode _ self submit: MaDownloadCodeRequest new.
	self loadClassDefinitionsFrom: classesAndCode first.
	code _ serializer materializeGraph: classesAndCode last.
	^code! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 1/26/2005 23:02'!
handleClassModification: aModifiedClassDefinitionEvent

	aModifiedClassDefinitionEvent isModified ifFalse: [ ^ self ].
	aModifiedClassDefinitionEvent item isMeta ifTrue: [ ^ self ].
	serializer handleClassModification: aModifiedClassDefinitionEvent.
	readStrategy ifNotNil: [ self readStrategy makeReadyForUseUsing: serializer classIdManager ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 1/26/2005 00:05'!
handleSpecialOidNotifications: aDictionary
	"aDictionary is keyed by selector Symbols, with Sets of ByteArray's as values.  The selectors indicate what should be done with those ByteArray's once materialized."

	| didRefresh |
	didRefresh _ false.
	"Must do classDefinitions Dictionary first."
	(aDictionary includesKey: #refreshClassDefinitions)
		ifTrue:
			[ didRefresh _ true.
			self refreshSpecialObjectsUsing: (aDictionary at: #refreshClassDefinitions) ].
	"Now refresh individual OrderedCollections of MaClassDefinitions, each representing its own version."
	(aDictionary includesKey: #refreshClassVersions)
		ifTrue:
			[ didRefresh _ true.
			self refreshSpecialObjectsUsing: (aDictionary at: #refreshClassVersions) ].
	(didRefresh and: [ self readStrategy notNil ]) ifTrue: [ self readStrategy makeReadyForUseUsing: serializer classIdManager ].! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 1/17/2005 14:47'!
hasDefinition
	^ self definition notNil! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 7/5/2004 15:02'!
hostAddress

	^ self link hostAddress! !

!MagmaSession methodsFor: 'private' stamp: ''!
id

	^id! !

!MagmaSession methodsFor: 'private' stamp: ''!
id: anInteger

	id _ anInteger
! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 00:16'!
inNestedTransaction

	^ transactionLevel > 1! !

!MagmaSession methodsFor: 'transactions' stamp: 'cmm 12/26/2004 00:20'!
inTransaction

	^ transactionLevel > 0! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/11/2004 13:44'!
incrementTransactionLevel

	transactionLevel _ transactionLevel + 1! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 2/22/2005 23:00'!
initialize

	super initialize.
	transaction _ MaTransaction session: self.
	preferences _ MagmaPreferences new.
	self
		initializeSerializer ;
		resetTransactionLevel ;
		initializeMagmaNotifications.
	self id: nil! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 1/16/2005 19:02'!
initializeDefinition

	definition _ MagmaRepositoryDefinition new! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 2/25/2005 14:03'!
initializeMagmaNotifications

	self
		when: #materializedFromMagma
		send: #noteMaterialized:
		to: self! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 4/14/2005 23:09'!
initializeSerializer
	serializer _
		MaObjectSerializer new
			toCreateProxies:
				[ :oid |
				MagmaMutatingProxy
					session: self
					oid: oid ];
			classIdManager: MagmaClassIdManager new;
			oidManager: MagmaOidManager new.
	serializer traversalStrategy
		traverseWhen:
			[ : path : parent : indexInteger | 
			(path last
				maShouldTraverseWithPath: path
				parent: parent
				index: indexInteger)
			and: [ path size <= 2 "Because we're serializing an Array of only changed objects, we only need capture their first level, but don't forget the OC container is level 1."
				or: [ MaOidCalculator isOidForNewObject: (self oidFor: path last) ] ] ] ;
		valueWhen:
			[ :path :parent :index |
			(path last
				maShouldAppendWithPath: path
				parent: parent
				index: index)
			and: [ path size <= 2 or: [ MaOidCalculator isOidForNewObject: (self oidFor: path last) ] ] ].
	serializer preferences
		"(sigh) Morphs keep their own #updateableActionMap, the map used to hold event-listener definitions.  Before, we were setting up these listeners on *materialization*, but this was causing them to be marked dirty immediately.  Therefore, we go ahead and set these listeners up 'permanently' upon serialization."
		beforeSerializingAny: Morph
		do:
			[ : aMorph |
			aMorph wantsMagmaEvents ifTrue:
				[ 
				aMorph
					when: #magmaAboutToRefresh 
					send: #aboutToRefreshFromMagma: "aMagmaRefreshEvent"
					to: aMorph.
				aMorph
					when: #magmaRefreshed
					send: #refreshedFromMagma: "aMagmaRefreshEvent"
					to: aMorph ] ] ;

		afterMaterializingAny: #MagmaLargeCollection
		do:
			[ : aMagmaCollection |
			aMagmaCollection
				initializeChanges ;
				setOid: (serializer oidFor: aMagmaCollection) ] ;

		afterMaterializingAny: #MagmaCollectionReader
		do: [ : aMagmaCollectionReader | aMagmaCollectionReader setUpListener ]! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 1/26/2005 16:36'!
initializeSystemChangeNotifications

	SystemChangeNotifier uniqueInstance
		notify: self
		ofSystemChangesOfItem: #class
		change: #Modified
		using: #handleClassModification:.
	SystemChangeNotifier uniqueInstance
		notify: serializer classIdManager
		ofSystemChangesOfItem: #class
		change: #Renamed
		using: #handleClassRename:! !

!MagmaSession methodsFor: 'connections' stamp: ''!
isConnected

	^self id notNil
! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/26/2004 23:06'!
isLocal

	^ link isLocal! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/26/2004 23:33'!
isPersistent: anObject
	"Answer whether the repository I'm connected to has anObject stored in it."

	^(self serializer hasOidFor: anObject) and: [ (MaOidCalculator isOidForNewObject: (self oidFor: anObject)) not ]! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/26/2004 23:08'!
isRemote

	^ self isLocal not! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 1/17/2005 17:36'!
isSameRepositoryAs: anotherMagmaSession

	^ anotherMagmaSession hasDefinition
	and: [ self definition magmaId = anotherMagmaSession definition magmaId ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/3/2003 23:09'!
isServerSession

	^id = 1! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:00'!
link

	^ link! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 23:59'!
link: aMaServerLink

	link _ aMaServerLink.
	link timeoutSeconds:
		(MagmaPreferences debug
			ifTrue: [ 172800 "2 days" ]
			ifFalse: [ 30 ])! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 12/26/2004 22:59'!
linkInformation

	^ link linkInformation! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 6/23/2004 17:45'!
loadClassDefinitionsFrom: aByteArray

	serializer classDefinitions: (self materializeObject: aByteArray)! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 11/1/2004 12:29'!
loadDefinitionFrom: aByteArray

	definition _ self materializeObject: aByteArray! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 1/14/2005 15:13'!
location
	"Answer a new MagmaRepositoryLink that can be used later to access to this session without having to be concerned with directory-paths or ip addresses."

	^ self isLocal
		ifTrue:
			[ MagmaLocalLocation path: self pathName ]
		ifFalse:
			[ MagmaRemoteLocation 
				hostAddress: self hostAddress
				port: self port ]! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 1/13/2005 14:37'!
magmaId
	^ definition magmaId! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 3/16/2005 12:45'!
managesMagmaCollection: aMagmaLargeCollection

	^ definition allLargeCollections includes: aMagmaLargeCollection! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 1/28/2005 00:17'!
materializeAnchorFrom: aMaReadResult

	^ self materializeObject: aMaReadResult byteArray! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 2/25/2005 14:30'!
materializeObject: aByteArray

	^ serializer
		materializeGraph: aByteArray
		do:
			[ : eachObject : eachBuffer | 
			eachObject wantsMagmaEvents ifTrue:
				[ | event |
				event _ (MagmaMaterializationEvent session: self)
					object: eachObject ;
					buffer: eachBuffer ;
					yourself.
				self
					triggerEvent: #materializedFromMagma  "calls noteMaterialized:"
					with: event ].
			transaction 
				markRead: eachObject
				using: eachBuffer ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/17/2002 00:09'!
materializeObjectsIn: aMaCollectionSegment

	aMaCollectionSegment objects doWithIndex:
		[ :eachBuffer :index |
		aMaCollectionSegment objects
			at: index
			put: (self materializeObject: eachBuffer) ]
! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/5/2005 20:28'!
newCommitPackageFor: aMaTransaction
	"It is possible to that we will serialize up to three times.  If we add a new LargeCollection that also adds instances of a new class, the first serialization will detect the new LargeCollection, the second notices the new classes, the third gets everything right.."

	| commitPackage mustReserialize |
	commitPackage _ aMaTransaction changedObjects.
	mustReserialize _ commitPackage serializeObjectsUsing: self.
	^ mustReserialize
		ifTrue: [ self newCommitPackageFor: aMaTransaction ]
		ifFalse: [ commitPackage ]! !

!MagmaSession methodsFor: 'forwarding proxy''s (bookmarks)' stamp: 'cmm 2/1/2005 22:54'!
newForwardingProxyFor: anObject
	"Answer an object which will forward any messages to anObject.  This is useful if anObject must belong in a different repository than your objects which want to send messages to anObject."

	(self isPersistent: anObject) ifFalse: [ MagmaUserError signal: 'Cannot make a forwarding proxy to a non-persistent object.' ].
	^ MagmaForwardingProxy
		session: self
		oid: (self oidFor: anObject)! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 2/25/2005 14:33'!
noteMaterialized: aMagmaMaterializationEvent

	aMagmaMaterializationEvent object materializedFromMagma: aMagmaMaterializationEvent! !

!MagmaSession methodsFor: 'large collections' stamp: 'cmm 4/7/2005 22:47'!
noteOldKeysFor: anObject
	"If anObject is in an indexed MagmaCollection and your program *is about to* change its keys, you must call this method or it will continue to be indexed under its old keys.  Emphasize, that you call this method *before* you change the keys, not after."

	transaction ensureOldHashesCapturedFor: anObject! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 3/1/2005 17:35'!
objectWithOid: anInteger ifAbsent: aBlock

	^serializer
		objectWithOid: anInteger
		ifAbsent:
			[ [ self realObjectFor: anInteger ]
				on: MagmaInvalidOid  "signaled in MaObjectFiler>>filePointerForLoid:"
				do: [ :exc | aBlock value ] ]! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 12/26/2004 23:04'!
occurrencesOf: anObject in: aMagmaCollection

	| oid |
	^ self submit: (
		MaKeyIntervalInfoRequest new
			collectionOid: (self oidFor: aMagmaCollection) ;
			attribute: nil ;
			lowKey: (oid _ self oidFor: anObject) ;
			highKey: oid)! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 2/1/2005 22:58'!
oidFor: anObject

	^ serializer oidFor: anObject! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/26/2004 22:44'!
pathName
	"Error if not local.  Check isLocal first."

	self isLocal ifFalse: [ MaUserError signal: 'Only available during local connections.' ].
	^ self submit: MagmaPathNameRequest new! !

!MagmaSession methodsFor: 'connections' stamp: 'cmm 7/5/2004 15:02'!
port

	^ self link port! !

!MagmaSession methodsFor: 'accessing' stamp: ''!
preferences

	^preferences! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:17'!
preferences: aMagmaPreferences

	preferences _ aMagmaPreferences! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 2/28/2005 21:56'!
primConnect

	| resultArray |
	self isConnected ifTrue: [ MagmaUserError signal: 'This session is already connected.' ].
	self isLocal ifTrue: [ self ensureOpen ].
	self hasDefinition ifTrue: [ self validateRemoteId ].
	MagmaNotification signal: 'connecting to ', self linkInformation, ' as ', self userId, '...'.
	link connect.
	resultArray _
		self submit:
			(MaRepositoryConnectionRequest new
				magmaVersion: MagmaSession magmaVersion;
				userId: self userId).
"We digress from proper objectification of a session result only because
we want to maintain a minimum set of classes necessary to acquire the class
map itself, for once we acqure that, we can do anything.  Prior to that, however,
we are limited to the only the classes that are ''basic'' classes according to the
MaDefaultClassIdManager."
	self
		id: (resultArray at: 1) ;
		loadClassDefinitionsFrom: (resultArray at: 2) ;
		loadDefinitionFrom: (resultArray at: 3).
	self initializeSystemChangeNotifications.
	MagmaNotification signal: 'connection established.'.
	^self! !

!MagmaSession methodsFor: 'initialize-release' stamp: 'cmm 3/28/2005 10:56'!
primDisconnect

	self isConnected
		ifTrue:
			[ MagmaNotification signal: 'disconnecting from ', self linkInformation.
			[ self submit: MaRepositoryDisconnectRequest new ]
				on: MagmaUserError, MaNetworkError
				do: [ : error | "already disconnected, don't sweat it." ].
			self
				resetTransactionLevel ;
				id: nil ;
				cleanUp ].
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self ;
		noMoreNotificationsFor: serializer classIdManager.
	transaction cleanUpWriteBarrier.
	Smalltalk garbageCollect! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/6/2005 18:16'!
processNewAndRemovedIndexesIn: aMagmaCommitPackage using: aMaCommitResult

	| backupPackage |
	backupPackage _ aMagmaCommitPackage copyWithNewLargeCollectionChanges.
	transaction resetCommitPackage.
	self refreshViewUsing: aMaCommitResult.
	backupPackage newIndexesDo:
		[ : eachCollection : eachIndexes |  | objectOidsAlreadyIndexed mcChanges |
		mcChanges _ aMagmaCommitPackage largeCollectionChangesFor: eachCollection.
		objectOidsAlreadyIndexed _ mcChanges added keys collect: 
			[ : each |
			(MaOidCalculator isOidForNewObject: each)
				ifTrue:
					[ aMaCommitResult permanentOids 
						at: each
						ifAbsent: [ MagmaSoftwareError signal: 'error building index, expected to find permanent oid' ] ]
				ifFalse: [ each ] ].
		eachCollection 
			buildIndexes: eachIndexes ignoring: objectOidsAlreadyIndexed ;
			commitUnlock ].
	backupPackage removedIndexesDo: [ :eachCollection :eachIndexes | eachCollection commitUnlock ]! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 9/23/2004 15:59'!
readStrategy
	"Answers an object that defines how many levels deep to read when encountering various kinds of objects."

	^ readStrategy! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 4/7/2005 16:31'!
readStrategy: aMaReadStrategy
	"Once the readStrategy is set, aMaReadStrategy is converted to use class ids.."

	aMaReadStrategy isBasic
		ifTrue:
			[ "basic read-strategies are not allowed because they circumvent the systemReadStrategy in the server."
			MagmaUserError signal: 'Basic read-strategies are not allowed, use a MaReadStrategy.' ].
	readStrategy _ aMaReadStrategy makeReadyForUseUsing: serializer classIdManager! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 3/1/2005 17:28'!
realObjectFor: oid

	| result |
	result _ self submit:
		(MaReadRequest new  "calls read:for:using:"
			oid: oid;
			readStrategy: self resetReadStrategy;
			yourself).
	result shouldRefresh "server will not give us true unless not in a transaction."
		ifTrue: [ self abort ].
	^self materializeObject: result byteArray! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 10/10/2004 22:08'!
recordObjects: aCollection
	"aCollection of MaObjectBuffers."

	aCollection do:
		[ : each |
		serializer
			objectWithOid: each oid
			ifFound:
				[ :object |
				transaction
					markRead: object
					using: each ]
			ifAbsent: [ "do nothing"  nil ] ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 21:59'!
refresh

	self refreshViewUsing: (self submit: MaAbortTransactionRequest new)! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 2/25/2005 14:15'!
refreshChangedObjects: changedObjects
	"changedObjects is a Dictionary of MaObjectBuffers that were written by other clients.  For each one that the receiver still knows its oid, set all of its instVars to the objects that map by its referenced oids.  If a referenced oid is not in the client, substitute with a proxy."

	| refreshEvents |
	"Some Morphs cannot be refreshed while they're stepping in the world; therefore we provide this hack to ensure we only update them 'offline'; e.g., we delete, refresh, then add them back at the same position and index as they were.  The events restoreData is used to capture this temporary information."
	refreshEvents _ OrderedCollection new.
	changedObjects do:
		[ : eachObjectBuffer |  | object |
		object _ serializer objectWithOid: eachObjectBuffer oid ifAbsent: [ nil ].
		(object == nil or: [ object maIsMutatingProxy ]) ifFalse:
			[ | event |
			event _ (MagmaRefreshEvent session: self)
				buffer: eachObjectBuffer ;
				object: object ;
				yourself.
			self refreshObject: event.
			object wantsMagmaEvents ifTrue: [ refreshEvents add: event ] ] ].
	"We prefer to do the refresh in a 'post' fashion, so event handlers may count on the freshest data everywhere."
	refreshEvents do:
		[ : each | 
		each object
			triggerEvent: #magmaRefreshed "calls #refreshedFromMagma:"
			with: each ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 2/25/2005 14:13'!
refreshObject: aMagmaRefreshEvent

	aMagmaRefreshEvent object wantsMagmaEvents
		ifTrue:
			[ aMagmaRefreshEvent object
				triggerEvent: #magmaAboutToRefresh "calls #aboutToRefreshFromMagma:"
				with: aMagmaRefreshEvent ].
	aMagmaRefreshEvent buffer
		refresh: aMagmaRefreshEvent object
		using: self.
	transaction
		markRead: aMagmaRefreshEvent object
		using: aMagmaRefreshEvent buffer! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/28/2004 15:47'!
refreshSpecialObjectsUsing: aSetOfByteArrays
	"each ByteArray is a graph buffer of either the entire classDefinitionsById, OR merely one of the OrderedCollections of the definitions for a particular id/class."

	aSetOfByteArrays do: [ : each | self materializeObject: each ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/4/2005 10:55'!
refreshViewUsing: aMaRefreshViewResult
	"I have crossed a transaction boundary, either through abort, commit or begin."

	aMaRefreshViewResult refresh: self.
	"Q:  When do we reset the commitPackage?
	A:  Definitely on every #commit.   For #begin and #abort, it matters whether refreshPersistentObjectsEvenWhenChangedOnlyByMe is set.  With its default value, false, we want to support the 'forgetting to begin' use-case; where a user makes some changes, realizes they hadn't started a transaction, so they just do a #begin, during which only the objects which were changed by others are refreshed, their own changes are preserved.  They can then press #commit and their changes will be saved.  This is actually a useful commit-strategy."
	preferences refreshPersistentObjectsEvenWhenChangedOnlyByMe 
		ifTrue:
			[ transaction resetCommitPackage ]! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 1/14/2005 16:04'!
remoteMagmaId

	^ self submit: MagmaIdRequest new! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 10/10/2004 20:05'!
resetMagmaCollectionChanges

	transaction largeCollectionChanges do: [ :each | each reset ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 1/25/2005 14:48'!
resetReadStrategy
	"We allow the user to define read strategies 'specifications' for classes that may not even exist in the repository.  So, classes that aren't known yet are remembered by the strategy."

	^ readStrategy
		ifNil: [ nil ]
		ifNotNil:
			[ readStrategy isNew  "do we have new depth specifications?"
				ifTrue:
					[ | answer |
					answer _ readStrategy copyWithoutSpecifications.
					readStrategy hasUnusedDepths 
						ifTrue: [ readStrategy beOld ]
						ifFalse: [ readStrategy _ nil ].
					answer ]
				ifFalse:
					[ nil ] ]! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/11/2004 13:55'!
resetTransactionLevel
	transactionLevel _ 0! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 11/1/2004 12:30'!
restoreAllClassMaps
	"This for a very specific scenario.  If the user attempts to commit a new or changed class and the commit fails for any reason, their classMaps (both persistent and non-persistent) need to be restored to their state without all the new classes because, if they then try to commit some of those same new classes again, it will not detect the new addition to the classDefinitions."

	transaction restore: serializer classIdManager classDefinitionsById.
	serializer classIdManager classDefinitionsById do:
		[ : eachDefinitions |
		transaction restore: eachDefinitions ].
	serializer classIdManager rebuildTransientClassMaps! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 12/28/2004 23:54'!
root
	"Every Magma repository has a single root object off which every other object directly or indirectly hangs.  This method answers it."

	^self anchor root! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/28/2004 23:57'!
root: anObject

	anchor _ self anchor.
	anchor root ifNotNil: [ Warning signal: 'Are you sure you want to wipe out the entire database for ', anObject printString, '?' ].
	anchor root: anObject! !

!MagmaSession methodsFor: 'private' stamp: ''!
serializer

	^serializer! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/29/2004 15:00'!
sharesAnyObjectsWith: anotherMagmaSession

	self == anotherMagmaSession ifTrue: [ ^ true ].
	(self isSameRepositoryAs: anotherMagmaSession) ifFalse: [ ^ false ].
	^ anotherMagmaSession serializer sharesAnyObjectsWith: anotherMagmaSession serializer! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
signalExceptionLike: anException 
	| signalableError |
	signalableError := anException maOriginalClass new 
				copyAttributes: (anException maOriginalClass allInstVarNames 
						copyWithoutAll: #('signalContext' 'handlerContext' 'outerContext'))
				from: anException.
	"this is probably not necessary.."
	signalableError signal! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 12/26/2004 22:54'!
sizeOfLargeCollection: aMagmaCollection

	self ensureConnected.  "Need this before we call oidFor:, below."
	^ self submit:
		(MaLargeCollectionSizeRequest new 
			collectionOid: (self oidFor: aMagmaCollection) ;
			yourself)! !

!MagmaSession methodsFor: 'performance' stamp: 'cmm 2/21/2005 16:38'!
stubOut: anObject
	"Convert anObject to a proxy, potentially freeing the objects it references for garbage collection.  Useful for keeping memory consumption under control."

	| oid |
	(self canStubOut: anObject) ifFalse: [ ^ self ].	
	oid _ self oidFor: anObject.
	transaction remove: anObject.
	serializer cleanObject: anObject.
	anObject
		becomeForward:
			(MagmaMutatingProxy
				session: self
				oid: oid)
		copyHash: false! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 1/28/2005 00:16'!
submit: aMagmaRepositoryRequest
	"Submit aMagmaRepositoryRequest and answer the result.  This is a core method."
	| result |
	aMagmaRepositoryRequest requiresConnection ifTrue: [ self ensureConnected ].
	aMagmaRepositoryRequest sessionId: id.
	result _ MagmaPreferences handStatus
		ifTrue:
			[ aMagmaRepositoryRequest waitCursor showWhile: [ link submit: aMagmaRepositoryRequest ] ]
		ifFalse: [ link submit: aMagmaRepositoryRequest ].
	result maIsException ifTrue: [ self signalExceptionLike: result ].
	(result isMagmaServerResult and: [ result hasServerNotifications ])
		ifTrue:
			[ self handleSpecialOidNotifications: result serverNotifications ].
	^ result! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 3/16/2005 12:32'!
upTo: anInteger objectsIn: aMagmaCollection fromIndex: startIndex on: aMaIndexDefinition using: aMaReadStrategy
	"Answer a MaCollectionSegment or aMaIndexedCollectionSegment.  Calls upTo:oidsFromIndex:inLargeCollection:on:using:forSession:"

	| segmentResult |
	segmentResult _
		(self submit: (
			MaSegmentByIndexRequest new
				quantity: anInteger;
				collectionOid: (self oidFor: aMagmaCollection) ;
				lowIndex: startIndex ;
				attribute: (aMaIndexDefinition ifNotNil: [ aMaIndexDefinition attribute ]) ;
				readStrategy: aMaReadStrategy ;
				yourself)).
	self materializeObjectsIn: segmentResult.
	^ segmentResult! !

!MagmaSession methodsFor: 'private-magma collections' stamp: 'cmm 4/18/2005 11:13'!
upTo: anInteger objectsIn: aMagmaCollection fromKey: lowKey to: highKey startingAt: indexInteger on: aMaIndexDefinition using: aMaReadStrategy
	"Calls upTo:oidsFrom:to:startingAt:inLargeCollection:on:using:forSession:"

	| segment |
	segment _
		self submit: (
			MaSegmentByKeyRequest new
				quantity: anInteger ;
				collectionOid: (self oidFor: aMagmaCollection) ;
				lowKey: lowKey ;
				highKey: highKey ;
				lowIndex: indexInteger ;
				attribute: aMaIndexDefinition attribute ;
				readStrategy: aMaReadStrategy ;
				yourself).
	self materializeObjectsIn: segment.
	^ segment! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 1/17/2005 14:33'!
user
	^ user! !

!MagmaSession methodsFor: 'accessing' stamp: 'cmm 1/17/2005 14:33'!
userId

	^ self user id! !

!MagmaSession methodsFor: 'private' stamp: 'cmm 1/14/2005 16:07'!
validateRemoteId
	"Ensure my id is the same as my repository's id.  I am used to reconnect after being disconnected during which time a new repository could have been created in the same location, which would render my objects with invalid oids."

	self magmaId = self remoteMagmaId
		ifFalse:
			[ MagmaEnvironmentError signal: 'Cannot connect because the repository has been replaced.' ]! !

MaObject subclass: #MagmaUser
	instanceVariableNames: 'id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Domain'!

!MagmaUser class methodsFor: 'create' stamp: 'cmm 1/15/2005 16:37'!
id: aString
	^ self new id: aString; yourself! !

!MagmaUser methodsFor: 'initialize' stamp: 'cmm 1/15/2005 16:37'!
id
	^ id! !

!MagmaUser methodsFor: 'initialize' stamp: 'cmm 1/15/2005 16:37'!
id: aString
	id _ aString! !

!MagmaUser methodsFor: 'printing' stamp: 'cmm 1/17/2005 21:59'!
maPrintAbbreviatedOn: aStream

	self maPrintAttribute: #id on: aStream! !

MaUserError subclass: #MagmaUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MagmaUserError subclass: #MagmaDuplicateObjectInCollection
	instanceVariableNames: 'doBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MagmaDuplicateObjectInCollection commentStamp: '<historical>' prior: 0!
Signalled by MagmaSet if a duplicate object is added to the collection.!

MagmaUserError subclass: #MagmaEquivalentObjectNotInCollection
	instanceVariableNames: 'doBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MagmaUserError subclass: #MagmaInvalidIndexObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MagmaUserError subclass: #MagmaInvalidOid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!MagmaInvalidOid commentStamp: 'cmm 3/1/2005 17:34' prior: 0!
Signaled when the server is asked for an object at a particular oid but no object is present at that oid.!

!ScrollBar methodsFor: '*magma client' stamp: 'cmm 4/13/2005 14:11'!
isImmutableInMagma 
	"disallow one clients scrolling to affect other clients."

	^ true! !

!ScrollBar methodsFor: '*magma client' stamp: 'cmm 4/13/2005 14:10'!
wantsMagmaEvents
	"We don't refresh scrollbars.  Although this technically isn't necessary as long I answer true to isImmutableInMagma, this will prevent my updatableActionMap from getting the event-listeners put in there unnecessarily."

	^ false! !

!StrikeFont methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:32'!
isImmutableInMagma

	^ true! !

WriteBarrier subclass: #MaTransaction
	instanceVariableNames: 'readSet session largeCollectionChanges commitPackage potentialKeysChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MaTransaction commentStamp: '<historical>' prior: 0!
This class is private.  Applications should use the transaction control provided on
MagmaSession.
!

!MaTransaction class methodsFor: 'creation' stamp: ''!
session: aMagmaSession

	^self new session: aMagmaSession
! !

!MaTransaction methodsFor: 'deprecated' stamp: 'cmm 4/7/2005 12:24'!
aboutToModify: anObject
	"This is called by WriteBarrier subclasses (#preNotify) which is generated by MagmaWbMethodBuilder>>#generatePreNotification.  I was going to use this to try to capture index key-changes, but it turns out that is a flawed concept (see WhyNoChangedKeyAutoDetection.jpg).
	
	Still, I decided to keep the code for preNotifying around since it might come in useful in the future."
! !

!MaTransaction methodsFor: 'private' stamp: 'cmm 4/4/2005 13:21'!
addChangesFromReadSet

	| truncateds |
	truncateds _ OrderedCollection new.
	readSet keysAndValuesDo:
		[ : eachCurrent : eachBuffer |  | didChange useWriteBarrier |
		useWriteBarrier _ self useWriteBarrierOn: eachCurrent.
		didChange _
			useWriteBarrier not
			and: [ "The whole purpose of WriteBarrier integration is to avoid the performance-penalty of this line."
				eachBuffer isDifferent: eachCurrent using: session serializer ].
		didChange
			ifTrue:
				[ (session serializer isTruncated: eachCurrent)
					ifTrue: 
						[ (truncateds ifNil: [ truncateds _ OrderedCollection new ]) add: eachCurrent ].
				commitPackage addObject: eachCurrent ] ].
	self warnOfTruncationsIn: truncateds! !

!MaTransaction methodsFor: 'private' stamp: 'cmm 3/27/2005 17:02'!
addLargeCollectionChangesTo: aMaCommitPackage

	largeCollectionChanges do:
		[ :each |
		each hasChanges
			ifTrue:
				[ aMaCommitPackage
					addLargeCollectionChanges: each
					using: session ] ]! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 4/10/2005 19:11'!
captureOldHashesFor: anObject

	largeCollectionChanges do:
		[ : eachChanges |
		(eachChanges collection canIndex: anObject)
			ifTrue:
				[ eachChanges collection indexes do:
					[ : eachIndex |
					"preserve old keys"
						potentialKeysChange
							at: anObject
							put: { eachChanges. eachIndex. eachIndex indexHashesFor: anObject } ] ] ]! !

!MaTransaction methodsFor: 'accessing' stamp: 'cmm 4/5/2005 21:31'!
changedObjects

	| preservedCommitPackage answer |
	"this method must be non-destructive to the my commitPackage because it may be requested again."
	preservedCommitPackage _ commitPackage copyWithNewLargeCollectionChanges.  "It should actually be ok to share its 'objects'."
	self
		addChangesFromReadSet ;  "another potential truncation warning"
		recordPotentialKeyChanges ;
		addLargeCollectionChangesTo: commitPackage.
	answer _ commitPackage.
	commitPackage _ preservedCommitPackage.
	^ answer! !

!MaTransaction methodsFor: 'initializing' stamp: 'cmm 4/4/2005 10:54'!
cleanUpWriteBarrier

	commitPackage objectsDo: [ : each | self remove: each ].
	self resetCommitPackage! !

!MaTransaction methodsFor: 'deprecated' stamp: 'cmm 4/6/2005 22:02'!
ensureOldHashesCapturedFor: anObject
	"What we need to do here is capture the before-keys of any object which, potentially belonging to a MagmaCollection, potentially changing its key by way of its instVars being changed so that we may, in modified: actually determine whether we should record the changed-key in my commitPackage."

	(potentialKeysChange includesKey: anObject) ifTrue: [ ^ self ].
	self captureOldHashesFor: anObject! !

!MaTransaction methodsFor: 'actions' stamp: 'cmm 1/20/2003 22:30'!
finalizeOids

	readSet finalizeValues! !

!MaTransaction methodsFor: 'initializing' stamp: 'cmm 4/4/2005 12:06'!
initialize

	super initialize.
	readSet _ MaWeakIdentityKeyDictionary new.
	largeCollectionChanges _ WeakSet new.
	self resetCommitPackage! !

!MaTransaction methodsFor: 'accessing' stamp: ''!
largeCollectionChanges

	^largeCollectionChanges! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 4/8/2005 12:40'!
markRead: anObject using: aMaObjectBuffer
	| useWriteBarrier |
	anObject isImmutableInMagma ifTrue: [ "can't change, don't bother recording my state." ^ anObject ].	
	(useWriteBarrier _ self useWriteBarrierOn: anObject)
		ifTrue:
			[ self add: anObject.
			commitPackage removeObject: anObject ].
	(useWriteBarrier not
	or: [ session preferences refreshPersistentObjectsEvenWhenChangedOnlyByMe ])
		ifTrue:
			[ self
				persistentRepresentationOf: anObject
				is: aMaObjectBuffer ].
	anObject maIsLargeCollection 
		ifTrue:
			[ self monitorLargeCollectionChanges: anObject changes.
			anObject session: session ].
	^ anObject! !

!MaTransaction methodsFor: 'writebarrier' stamp: 'cmm 4/4/2005 13:23'!
modified: anObject

	(session serializer isTruncated: anObject)
		ifTrue:
			[ self warnOfTruncationsIn: { anObject } ].
	commitPackage addObject: anObject! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 3/16/2005 12:43'!
monitorLargeCollectionChanges: aMaLargeCollectionChanges

	largeCollectionChanges add: aMaLargeCollectionChanges
! !

!MaTransaction methodsFor: 'writebarrier' stamp: 'cmm 4/3/2005 16:42'!
newBuilderForClass: aClass
	MagmaNotification signal: 'Compiling anonymous subclass of ', aClass name.
	^ MagmaWbClassBuilder
		target: aClass 
		barrier: self! !

!MaTransaction methodsFor: 'private' stamp: 'cmm 10/8/2004 17:36'!
persistentRepresentationOf: anObject is: aMaObjectBuffer

	readSet
		at: anObject
		put: aMaObjectBuffer! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 4/7/2005 17:30'!
recordPotentialKeyChanges

	potentialKeysChange keysAndValuesDo:
		[ : eachObject : eachChangesAndIndexAndOldHashes |
		"eachChangesAndIndexAndOldHashes was built in captureOldHashesFor:.  Sorry this is so ugly."
		self
			recordPotentialKeyChangesFrom: eachChangesAndIndexAndOldHashes last
			of: eachObject
			index: (eachChangesAndIndexAndOldHashes at: 2)
			in: eachChangesAndIndexAndOldHashes first ]! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 4/7/2005 17:27'!
recordPotentialKeyChangesFrom: oldHashValues of: anObject index: aMaIndexDefinition in: aMagmaCollectionChanges

	| newHashValues |
	anObject ifNil: [ ^ self ].
	newHashValues _ aMaIndexDefinition indexHashesFor: anObject.
	"If hash index value has changed."
	(oldHashValues maConsistsOf: newHashValues)
		ifFalse:
			[ | common |
			common _ oldHashValues intersection: newHashValues.
			aMagmaCollectionChanges
				move: anObject
				from: (oldHashValues removeAll: common; yourself)
				to: (newHashValues removeAll: common; yourself)
				forIndexedAttribute: aMaIndexDefinition attribute ]! !

!MaTransaction methodsFor: 'building' stamp: 'cmm 10/23/2002 21:20'!
remove: anObject

	readSet
		removeKey: anObject
		ifAbsent: [ "do nothing" ]
! !

!MaTransaction methodsFor: 'initializing' stamp: 'cmm 4/8/2005 11:58'!
resetCommitPackage

	commitPackage _ MaCommitPackage new.
	"potentialKeyChanges are only ever part of a single commit-package, so reset those too."
	potentialKeysChange _ MaWeakIdentityKeyDictionary new! !

!MaTransaction methodsFor: 'actions' stamp: 'cmm 11/24/2004 11:16'!
restore
	"restore all changed objects to their state as read from the repository."

	readSet keysAndValuesDo:
		[ : eachOriginal : eachBackup | 
		eachBackup
			refresh: eachOriginal
			using: session ]! !

!MaTransaction methodsFor: 'actions' stamp: 'cmm 4/8/2005 11:45'!
restore: anObject

	| buffer |
	buffer _ readSet at: anObject.
	buffer
		refresh: anObject
		using: session.
	potentialKeysChange
		removeKey: anObject
		ifAbsent: [ "do nothing" ]! !

!MaTransaction methodsFor: 'private' stamp: ''!
session: aMagmaSession

	session _ aMagmaSession
! !

!MaTransaction methodsFor: 'writebarrier' stamp: 'cmm 3/27/2005 22:47'!
useWriteBarrierOn: anObject

	^ anObject maAllowsWriteBarrier
		and: [ session preferences allowWriteBarrier
		and: 
			[ "this only here for documentation purposes, we will never get here because classDefinitionsById is a Dictionary."
			anObject ~~ session serializer classIdManager classDefinitionsById ] ]! !

!MaTransaction methodsFor: 'writebarrier' stamp: 'cmm 3/27/2005 22:56'!
validateWriteBarrier: aBoolean
	"We can't allow them to stop using the writeBarrier in the middle of a transaction in which objects are already changed.."

	aBoolean
		ifFalse:
			[ commitPackage objects notEmpty
				ifTrue:
					[ MagmaUserError signal: 'Cannot stop using writeBarrier in the middle of a transaction.' ] ]! !

!MaTransaction methodsFor: 'private' stamp: 'cmm 4/10/2005 18:00'!
warnOfTruncationsIn: aCollection 
	aCollection isEmptyOrNil 
		ifFalse: 
			[MagmaTruncationWarning 
				signal: (String streamContents: 
							[:stream | 
							stream nextPutAll: 'Your definition of '.
							(aCollection collect: [:each | each maOriginalClass name]) asSet do: 
									[:each | 
									stream
										nextPutAll: each;
										nextPutAll: ', '].
							stream 
								nextPutAll: 'are missing instance variables present in the repository-version.  If you proceed with this commit, information in one or more of these instances will be lost.'])]! !

WBMethodBuilder subclass: #MagmaWbMethodBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Private'!

!MagmaWbMethodBuilder methodsFor: 'private' stamp: 'cmm 4/7/2005 12:26'!
buildCompiledMethod

"I was going to use this to try to capture index key-changes, but it turns out that is a flawed concept (see WhyNoChangedKeyAutoDetection.jpg).
	
	Still, I decided to keep the code for preNotifying around since it might come in useful in the future."

	^ super buildCompiledMethod

"
	generator _ BytecodeGenerator new numArgs: selector numArgs.
	self generateStoreFields.
	self generatePreNotification.
	self generateCallSuper.
	self generateCheckFields.
	self generateReturn.
	self generateNotification.
	self generateReturn.
	^ generator compiledMethod
"! !

!MagmaWbMethodBuilder methodsFor: 'private' stamp: 'cmm 4/3/2005 16:47'!
generatePreNotification
	generator label: #preNotify.
	generator pushReceiver.
	generator send: #writeBarrier.
	generator pushReceiver.
	generator send: #aboutToModify:! !

PackageInfo subclass: #MagmaClientPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Info'!

!MagmaClientPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 3/15/2005 22:44'!
changesText

	^'
1.0gamma8
	- Live class evolution.  Developers can stay connected to Magma repositories while changing class-definitions and Magma will "do the right thing".
	- Magma can now serve as a code-repository for individual classes, change sets and Monticello packages.  The Monticello UI can be used with Magma as the back-end.
	- Support for many more classes such as BlockContexts, MethodContexts, CompiledMethods, Metaclasses (by reference), SortedCollections, WeakSets, billion-object Bags and Intervals, PluckedSounds, Speaker (i.e., Klatt) and other Variable-word classes are also supported.
	- Nested transactions.  You can now have multiple-levels of transactions and only the outer-most one actually writes them all to the repository.
	- Support for transient variables.  You can now specify named variables that you don''t want persisted in the repository.
	- stale proxies from disconnected sessions, if provoked, will now try to find the new session and reconnect automatically.
	- support for MagmaRepositoryLink objects that can be used to create a session to a local or remote repository without caring about the type of connection.
	- MagmaCollection improvements.  New large collections, MagmaSet and MagmaDictionary, MagmaIdentityDictionary and MagmaArray.
	- Better error handling.
	- Lots of code trimmed.  An entire package, a couple of class-hierarchies, and roughly 100 extension methods to base-classes were cleaned out thanks to various refactorings.

1.0gamma7
	- Compatible with Squeak 3.7.
	- Better support for Symbols (thanks to Brent Pinkney!!).
	- fix for storing Exceptions in the repository (to accommodate changes in Squeak 3.6).
	- New Date index type for MagmaCollections.
	- New Float index type for MagmaCollections.
	- MagmaSessions cleaned from MethodContext receivers, allowing full garbage collection (thanks to Giovanni!!).
	- Critical bugs with MagmaCollections fixed and now pass the new, extra-stringent tests in the Tester package.

1.0gamma6
	- works with Squeak 3.6.  Doesn''t work with versions before 3.6.
	- fixed issue with servers that were running when the image was saved (functionality implemented in 1.0gamma5).  Fixed similar bug for saving with open local repository connections.
	- disconnect now cleans up the proxies for that session.  Please be patient, this can take a while if you have a lot.  Also now cleaning dynamic largeCollection attributes when disconnecting a session.
	- fixed bug with creating repository using an unqualified file name.
	- fixed an unnoticed reference to platform-specific code (ByteArray>>unsignedByteAt: uses FFI primitives).
	- improved the internal system-read-strategy.


1.0gamma5
	- Servers and clients can now survive image restarts.
	- added a new session preference (see MagmaPreferences), "signalProxyMaterialization" so you can capture MagmaNotifications and fine-tune your read strategies.
	- Another performance improvement!!  ReadStrategies are now cached on the server, instead of in your MagmaSession, improving read-efficiency when using read strategies because the strategy-object no longer needs to be serialized and transported for every proxy materialization.  Additionally, ReadStrategies for classes that don''t exist in the repository are no longer dropped.  Instead, they are remembered until you put those classes into the repository.
	- commit conflicts no longer provide the entire MagmaClientConnection object who conflicted with your session, just the userId.  This is due to the aforementioned cached readStrategy, no need to be sending that down on a commit conflict.
	- Since we have eradicated the "root trap" we can make replacing the root consistent with other Magma changes.  A transaction is now required.
	- several bug fixes.


1.0gamma4

Enhancements:
	- A new MagmaSessionRequest notification provides a flexible, simple way to signal any session behavior, such as begin and commit from deep within domain classes without them needing to reference a MagmaSession.
	- Support for Morphs.
	- A new session preference is available.  When signalChangedNotifications is set to true, then, upon crossing of every transaction boundary, all objects in your image that were changed by other users will be sent #magmaChanged, the stub implemented on Object does nothing.
	- A substantial performance improvement on commits.
	- Tweaked default read-depth down to 2, from 3 seems to have
	- MagmaSession>>commitAndBegin is a new method that allows you to commit your current transaction and begin a new one within a single call the server.  This can be used to further improve performance to "load scripts."
	- Use MagmaSession>>cachedObjectCount to keep tabs on the how much of the persistent model is in memory, referenced by the program.  There are also new stats on the server side such as number of objects in the repository.
	- A new MagmaPreferences global attribute, handStatus, now determines whether the Hand will change to the "write" cursor when committing, the "read" cursor when reading, and the "up" cursor when waiting on the server for anything else.  While mostly just a curiousity, it also allows eyeball-profiling of the time spent in the client vs. the server so you can assess whether your commits are appropriately sized.
  - The "root trap" has been eradicated.  Your session will now reference the root every time you begin a transaction and dereferenced as soon as you commit or abort.  Since your transactions will presumably be short, there should be no problem with accumulating too much of the database in memory.

Bug fixes:
  - Fixed doesNotUnderstand: error with the MagmaRepository>>delete: utility method.
  - Improved a bug with materializing proxy''s to Symbols.  It''s slower than other kinds of objects, but should work as long as you never try to materialize a system-needed selector such as #size or #yourself or #add:.  Due to a bug with Squeak''s becomeForward: primitive (the modification of the target objects hash bits), you must be sure to use ReadStrategies to ensure these Symbols NEVER get proxied, or the becomeForward: could lock up Squeak.  So, this includes the actionSelectors of your Morph''s.  For more information, see http://lists.squeakfoundation.org/pipermail/squeak-dev/2003-March/055383.html, or to demonstrate the problem for yourself, evaluate the following (be sure you have saved your image first!!):

	String new becomeForward: #size

1.0gamma3:
  - MagmaCollections performance improvement
  - Better support for multiple sessions in the same image, connected to the same remote repository

1.0gamma2:
  - minor bug fixes
  - compatibility with Linux filenames / endianness

1.0gamma:
  - initial SqueakMap release'! !

!MagmaClientPackageInfo methodsFor: 'accessing' stamp: 'cmm 4/2/2004 13:19'!
prerequisitePackages
	^ #( 'Ma client server' 'Ma dynamic instance variables' 'Ma time objects' )! !

!MagmaClientPackageInfo methodsFor: 'as yet unclassified' stamp: 'cmm 2/4/2003 18:11'!
readmeText

	^'This package lets you connect to servers hosting Magma databases.

For more information:  http://minnow.cc.gatech.edu/squeak/2665'! !

MaEnvironmentError subclass: #MagmaEnvironmentError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

MagmaEnvironmentError subclass: #MagmaGarbageCollectedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-Exceptions'!

!FlapTab methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:37'!
isImmutableInMagma

	^ true! !

!BasicClassOrganizer methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:33'!
isImmutableInMagma

	^ true! !

MaClassIdManager subclass: #MagmaClassIdManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma client-private'!

!MagmaClassIdManager commentStamp: 'cmm 6/28/2004 15:04' prior: 0!
The purpose of this class is to keep track of which classes are persistent.!

!MagmaClassIdManager methodsFor: 'as yet unclassified' stamp: 'cmm 10/15/2004 12:40'!
assimilateInImageDefinition: aClass
	aClass isMeta ifTrue: [ MagmaSoftwareError signal: 'Metaclass instances are not stored here.' ].
	self addClassDefinition: (self inImageDefinition: aClass)! !

!MagmaClassIdManager methodsFor: 'accessing' stamp: 'cmm 6/29/2004 17:43'!
classDefinitionsById: aDictionary

	super classDefinitionsById: aDictionary.
	self rebuildTransientClassMaps! !

!MagmaClassIdManager methodsFor: 'initialize-release' stamp: 'cmm 9/26/2004 23:41'!
finalize
	"Theoretically, this is not necessary, it's just here for extra safety."

	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!MagmaClassIdManager methodsFor: 'event handling' stamp: 'cmm 10/1/2004 15:19'!
handleClassModification: aClass using: aMaObjectSerializer

	self refreshInImageDefinition: aClass! !

!MagmaClassIdManager methodsFor: 'event handling' stamp: 'cmm 10/1/2004 15:21'!
handleClassRename: aRenamedEvent
	"aRenamedEvent's item has just been renamed."
	aRenamedEvent isRenamed ifFalse: [ ^ self ].
	(self includesIdForClass: aRenamedEvent item) ifFalse: [ ^ self ].
	(self classDefinitionsForClass: aRenamedEvent item) do:
		[ : eachClassDefinition |
		eachClassDefinition className: aRenamedEvent newName ]! !

!MagmaClassIdManager methodsFor: 'special-case' stamp: 'cmm 4/10/2005 18:00'!
rebuildTransientClassMaps
	| highestId |
	idsByClass := idsByClass maOriginalClass new: idsByClass size.
	classesById := classesById maOriginalClass new: classesById size.
	inImageDefinitions := inImageDefinitions maOriginalClass 
				new: inImageDefinitions size.
	highestId := 0.
	classDefinitionsById keysAndValuesDo: 
			[:eachId :eachDefinitions | 
			| eachClass |
			eachDefinitions last isDefined 
				ifTrue: 
					[eachClass := eachDefinitions last classObject.
					highestId := highestId max: eachId.
					self idOfClass: eachClass is: eachId.
					self refreshInImageDefinition: eachClass]].
	nextClassId := highestId max: nextClassId! !

!ProtoObject methodsFor: '*magma client' stamp: 'cmm 3/16/2005 12:37'!
maIsLargeCollection 

	^ false
! !

!ProtoObject methodsFor: '*magma client' stamp: 'cmm 4/13/2005 14:04'!
wantsMagmaEvents
	"If true, this object will listen to #magmaAboutToRefresh events from the event-listener mechanism (see Object 'events' method category).  After overriding with true in your class, you may then use #when:send:to: to direct the events to your purpose.  For example:
	
	self when: #magmaAboutToRefresh send: #doSomething to: anyObject
	self when: #magmaRefreshed send: #changed to: self
	self when: #materializedFromMagma send: #upgrade: to: self  (arg is a MagmaMaterializationEvent)"

	^ false! !

!ProcessorScheduler methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:37'!
isImmutableInMagma

	^ true! !

!EventSensor methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:35'!
isImmutableInMagma

	^ true! !

!MaOidCalculator class methodsFor: '*magma client' stamp: 'cmm 8/6/2002 23:19'!
firstUserObjectOid

	^2066542! !

!MaOidCalculator class methodsFor: '*magma client-debugging' stamp: 'cmm 12/2/2004 13:44'!
infoFor: oidInteger

	| obj |
	obj _
		self
			objectWithOid: oidInteger
			ifNone:
				[ ^(MaOidCalculator isOidForNewObject: oidInteger)
					ifTrue: [ 'new object' ]
					ifFalse: [ 'index position: ', (self indexPositionForOid: oidInteger) printString ] ].
	^'(' , obj printString , ')'! !

!MaOidCalculator class methodsFor: '*magma client' stamp: 'cmm 12/30/2002 21:48'!
isOidForNewObject: anInteger

	^anInteger
		between: self newOidMinimum
		and: self firstUserObjectOid - 1! !

!DisplayScreen methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:35'!
isImmutableInMagma

	^ true! !

!Array methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:34'!
isImmutableInMagma
	"If I am one of the special global constant Array's, I am immutable, otherwise I'm not."

	^ self == (TextConstants at: #DefaultTabsArray)
	or: [ self == (TextConstants at: #DefaultMarginTabsArray) ]! !

!Array methodsFor: '*magma client' stamp: 'cmm 2/8/2005 16:42'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"Because I got here, I am one of the shared special Array's in the system (see maAsStorageObject).  Changes are not tracked for logically referenced objects."

	^ self maUsesStandardStorage
		and:
			[ super
				maIsChangedFrom: aMaByteObjectBuffer
				using: aMaObjectSerializer ]! !

!UUID methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:34'!
isImmutableInMagma

	^ true! !

!UUID methodsFor: '*magma client' stamp: 'cmm 3/27/2005 23:14'!
maAllowsWriteBarrier
	"These can't change, therefore no reason to allow WriteBarrier."

	^ false! !

!Association methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:36'!
isImmutableInMagma
	"Magma does not track changes to globals.  Therefore, if I am one of the entries in the Smalltalk global dictionary, I am immutable, otherwise I'm not."

	^ self maUsesStandardStorage not! !

!Association methodsFor: '*magma client' stamp: 'cmm 2/8/2005 16:08'!
maIsChangedFrom: aMaByteObjectBuffer using: aMaObjectSerializer
	"If I was an Association for a known global (see #maAsStorageObject), then I am being stored as a Proxy.  Changes to these global relationships are not tracked."

	^ false! !

!TranscriptStream methodsFor: '*magma client' stamp: 'cmm 4/8/2005 12:37'!
isImmutableInMagma

	^ true! !
MagmaCollection initialize!
MagmaPreferences initialize!
MagmaSession initialize!
